// ***************************************************************
// ** --------------------------------------------------------- **
// ** -------------- NYT Dataviz ------------------------------ **
// ** --------------------------------------------------------- **
// ***************************************************************
//
// JM Escalante | www.realitat.com | jmescalante@realitat.com \\ 
/*
 This sketch uses the article Search using NYTimes API v2 to save results as text files.
 Currently searching for: year, headline and url.
 -
 Version history:
 v 01 - First attempt to load NY Times data 
 v 02 - This sketch saves all of the gathered data in a txt file (so we can put this all in the main frame)
 This sketch is a total different approach, it's about finding all of the registry timed.
 v 03 - This sketch tries to optimize the search by allowing multiple search terms at a time!
 v 04 - This sketch loads the data right from a text file (instead of declaring it within processing)
 v 05 - We solve an issue on requests per second
 v 06 - Turns out the NYTimes API does not support pagination beyond page 100, so a new methog must be implemented
 v 07 - It is working now baby !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 */

// INDEX file to use (a txt file)
String nombreIndex = "musicians"; // technicians writers artists musicians topics
// *
int intervaloSegmentosFecha = 10; // This is if we're going to divide the intel by decade or every year, or so. 10 is default
int callsPorSegundo = 5; // The NYTimes won't allow more than 10 btw, 5 works, 1 is just to be on the safe side

// --------------------------------------------------------- 

void setup() {
  // 1. Normal functions
  size(330, 13);
  background(240);

  // 2. We load the index file
  busquedas = loadStrings("INDICES/"+nombreIndex+".txt");

  // 3. We establish a maximum number of searches
  busquedasTotales = busquedas.length;
  // 
  // 4. Let there be...time!
  iniciarTiempo();
  // 5. This frameRate thing is just and old superstition.
  frameRate(10);
  // 6. Feedback
  println(">> TIMED APP START");
}

// --------------------------------------------------------- 
void draw() {

  // 1. We draw a loading bar to indicate our progress
  loadingBar();
  // 2. We verify our time
  verificarTiempo();
  //
  // 3. We execute the query if permitted ********************************* (NORMAL MODE) ******************************************
  if (queryActiva && queryPermitida && !segmentedMode){
    // Aumentamos las calls
    callsVigentesEnEsteSegundo++;
    println(">> >> >> >> >> >> >> >> >> Executing a call on sec: "+segundoActual+" << << << << << << << << << << ");
    APICall(paginaActual); // Most important line, we call the API function
  }
  
  // 4. We execute the query if permitted *******************************(SEGMENTED DATE MODE) ************************************
  if (queryActiva && queryPermitida && segmentedMode){
    // Aumentamos las calls
    callsVigentesEnEsteSegundo++;
    println(">> >> >> >> >> >> >> >> >> Executing a SEGMENTED call on sec: "+segundoActual+" << << << << << << << << << << ");
    APICallSegmented(paginaActual); // Most important line
  }
  
}
