// ******************************************
// ** All API related data ******************
// ******************************************

// --------------------------------------------------------------------------------------------------------
// Variables
JSONObject objetoJSON;
int itemsTotales;
//
// Componentes de la QUery 
String APIArticleKey = "28e3f8d9ac16073bd242a9aa1736a70a:3:71448524";
String NYTimesURL = "http://api.nytimes.com/svc/search/v2/articlesearch.";
// *
String busqueda = "%22Curtis+Roads%22";
String [] busquedas;
String nombreArchivo = "Curtis Roads";
// See the first tab for original search terms
// *
int paginaActual = 0;
int itemActual = 0;
int busquedaActual = 0;
int busquedasTotales;
int callsTotales = 0;
String sort = "oldest"; // ALways oldest to the date segme
String tipoQuery = "json";
String query; // Aqu'i construiremos la principal query a enviar al NYTimes
String fechaInicio = "19000101";  // Del 1900
String fechaFin = "20151231"; // Al 'ultimo d'ia del 2015
// *
Boolean queryActiva = true; // Esta variable nos ayuda a evitar queries infinitas
// * The actual CONTENT:
String anosFinales = "";
String titulosFinales = "";
String urlsFinales = "";
// --------------------------------------------------------------------------------------------------------

void  APICall(int pagina) {
  // This is a typical request
  //http://api.nytimes.com/svc/search/v2/articlesearch.
  // response-format?[q=search term&fq=filter-field:(filter-term)&additional-params=values]&api-key=####

  // 0. We re-Arrange the term
  String termino = reemplazarEspacios(busquedas[busquedaActual]);
  termino =  "%22"+termino+"%22";// This is to make it an exact search

  // 00. Feedback 
  println(">> Starting call no. "+callsTotales+" Term: "+termino+" | item: "+itemActual+"/("+itemsTotales+")");
  callsTotales++;

  // A. We build our request/query
  query = NYTimesURL+tipoQuery+"?q="+termino+"&page="+pagina+"&begin_date="+fechaInicio+"&end_date="+fechaFin+"&sort="+sort+"&api-key="+APIArticleKey;

  // B. We'll make the request now or catch an excetion:
  try {

    //1. We create the request 
    objetoJSON = loadJSONObject(query);
    println(">> Query deseada: ");
    //println(query);

    // 2. Vamos a establecer el "PARSING"
    JSONObject response = objetoJSON.getJSONObject("response");
    JSONObject meta = response.getJSONObject("meta");
    JSONArray resultados = response.getJSONArray("docs");
    //println(">> META");
    //println(meta);
    //println(">> RESULTADOS");
    //println(resultados);
    println("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ");
    // 3. Revisamos los totales
    itemsTotales = meta.getInt("hits");

    if (itemsTotales > 900) {
      segmentedMode = true;
      iniciarSegmentedMode();
    } else {
      segmentedMode = false;
    }
    //println(">> Totales: "+itemsTotales);
    println("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ");

    // 4. Vamos a obtener los valores de cada item
    for (int i = 0; i < itemsTotales && i < 10 && itemActual < itemsTotales; i++) { // 10 son los resultados que obtenemos
      // 4 - 1 Creamos un item por cada noticia
      JSONObject itemExclusivo = resultados.getJSONObject(i);

      // 4 - 2 Vamos con la fecha
      String fecha = itemExclusivo.getString("pub_date");
      String [] fechaSeparada = fecha.split("-");
      int ano = int(fechaSeparada[0]);
      anosFinales += ano+" xxyxx "; // We add the year to our long string

      println(" Fecha ["+i+"] = "+ano);

      // 4 - 3 El titulo del articulo
      JSONObject headlineObject = itemExclusivo.getJSONObject("headline");
      String titulo = headlineObject.getString("main");
      //println(" TITLE >> "+titulo);
      titulosFinales += titulo+" xxyxx "; // We add this year to our long list

      //4 - 4 La url
      String vinculo = itemExclusivo.getString("web_url");
      urlsFinales += vinculo+" xxyxx "; // We add this year to our long list

      // 4 - 5 We add the item
      itemActual++;
    }

    // 5. We stop the whole thing if we've reached our limit or... ask for more!
    if (itemActual >= itemsTotales) {
      efectuarCambioNormal(); // Not a segmented date change
    } else {
      // We search again
      paginaActual++;
      //APICall(paginaActual);
    }
  }
  catch(Exception x) {
    // Fail Switch
    println(" >> Something really bad happened bro :( ");
    println(">> FAIL QUERY: "+query);
    x.printStackTrace();
  }
}

// --------------------------------------------------------------------------------------------------------
void saveResults() {
  // A. We save the text files

    // 1 - we create some new arrays based on the already gathered data.
  String [] anosFinalesArreglo = split(anosFinales, " xxyxx ");
  String [] titulosFinalesArreglo = split(titulosFinales, " xxyxx ");
  String [] urlsFinalesArreglo = split(urlsFinales, " xxyxx ");

  // 2 - we save them
  saveStrings( "SAVED_SEARCHES/"+nombreIndex+"/"+busquedas[busquedaActual]+"_anos.txt", anosFinalesArreglo);
  saveStrings( "SAVED_SEARCHES/"+nombreIndex+"/"+busquedas[busquedaActual]+"_titulos.txt", titulosFinalesArreglo);
  saveStrings( "SAVED_SEARCHES/"+nombreIndex+"/"+busquedas[busquedaActual]+"_urls.txt", urlsFinalesArreglo);
}
// --------------------------------------------------------------------------------------------------------

void endSketch() {
  // B. We close the sketch
  exit();
}


// --------------------------------------------------------------------------------------------------------

String reemplazarEspacios(String palabra) {

  // 1. We create an empty word to put the values in
  String palabraUnida = "";

  // 2. We check every one of them and create a new string
  for (int i = 0; i < palabra.length (); i++) {
    if (palabra.charAt(i) == ' ') {
      // IT's a space, we put a +
      palabraUnida += "+";
    } else {
      // It's not a space, put the same thing
      palabraUnida += palabra.charAt(i);
    }
  }

  // 3. We add them all
  return palabraUnida;
}
// --------------------------------------------------------------------------------------------------------

void efectuarCambioNormal() {
  // We save everything first
  saveResults();

  // We will see if there are any more searches
  if (busquedaActual < busquedasTotales-1) {
    //
    busquedaActual++; // an additional search

    // We reset everything needed, but with a different search query
    paginaActual = 0;
    itemActual = 0;
    anosFinales = "";
    titulosFinales = "";
    urlsFinales = "";
  } else {
    queryActiva = false; // No more queries thank you
    endSketch(); // The sketch is over.
  }
}
