
// **************************************************
// ** SEGMENTED related operations ******************
// **************************************************

// This function has been implemented to over-come the NYTimes functionality of segmenting data after the 100 page.
int fechaMinima = 1900;
int fechaMaxima = 2015;
int fechaActual = 0;
// Next variables declared in the MAIN tab
//int intervaloSegmentosFecha = 10; // This is if we're going to divide the intel by decade or every year, or so.

// *********************************************
Boolean segmentedMode = false;
// Remember oldest must be turned on!!!
//-----------------------------------------------------------------------

// SEGMENTED MODE FUNCTION
void  APICallSegmented(int pagina) {

  // 0. We re-Arrange the term
  String termino = reemplazarEspacios(busquedas[busquedaActual]);
  termino =  "%22"+termino+"%22";// This is to make it an exact search

  // 00. Feedback 
  println(">> SEGMENTED Starting call no. "+callsTotales+" Term: "+termino+" | item: "+itemActual+"/("+itemsTotales+")");
  println(" >> DATES: "+fechaMinima+"-"+fechaMinima+10);
  callsTotales++;

  // 000. New start dates
  String fechaInicioS = fechaActual+"0101";  // Segmented date
  String fechaFinS = (fechaActual+10)+"1231"; // Segmented date

  // A. We build our request/query
  query = NYTimesURL+tipoQuery+"?q="+termino+"&page="+pagina+"&begin_date="+fechaInicioS+"&end_date="+fechaFinS+"&sort="+sort+"&api-key="+APIArticleKey;

  // B. We'll make the request now or catch an excetion:
  try {

    //1. We create the request 
    objetoJSON = loadJSONObject(query);
    println(">> SEGMENTED Query deseada: ");
    //println(query);

    // 2. Vamos a establecer el "PARSING"
    JSONObject response = objetoJSON.getJSONObject("response");
    JSONObject meta = response.getJSONObject("meta");
    JSONArray resultados = response.getJSONArray("docs");
    //println(">> META");
    //println(meta);
    //println(">> RESULTADOS");
    //println(resultados);
    println("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ");
    // 3. Revisamos los totales
    itemsTotales = meta.getInt("hits");

    //println(">> Totales: "+itemsTotales);
    println("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ");

    // 4. Vamos a obtener los valores de cada item
    for (int i = 0; i < itemsTotales && i < 10 && itemActual < itemsTotales; i++) { // 10 son los resultados que obtenemos
      // 4 - 1 Creamos un item por cada noticia
      JSONObject itemExclusivo = resultados.getJSONObject(i);

      // 4 - 2 Vamos con la fecha
      String fecha = itemExclusivo.getString("pub_date");
      String [] fechaSeparada = fecha.split("-");
      int ano = int(fechaSeparada[0]);
      anosFinales += ano+" xxyxx "; // We add the year to our long string

      println(" Fecha ["+i+"] = "+ano);

      // 4 - 3 El titulo del articulo
      JSONObject headlineObject = itemExclusivo.getJSONObject("headline");
      String titulo = headlineObject.getString("main");
      //println(" TITLE >> "+titulo);
      titulosFinales += titulo+" xxyxx "; // We add this year to our long list

      //4 - 4 La url
      String vinculo = itemExclusivo.getString("web_url");
      urlsFinales += vinculo+" xxyxx "; // We add this year to our long list

      // 4 - 5 We add the item
      itemActual++;
    }

    // 5. We stop the whole thing if we've reached our limit or... ask for more!
    if (itemActual >= itemsTotales) {
      incrementarFecha();
    } else {
      // We search again
      paginaActual++;
      //APICall(paginaActual);
    }
  }
  catch(Exception x) {
    // Fail Switch
    println(" >> Something really bad happened bro :( SEGMENTED :(");
    println(">> FAIL SEGMENTED QUERY: "+query);
    x.printStackTrace();
  }
}


//-----------------------------------------------------------------------
void iniciarSegmentedMode() {

  // This function will start the segmented mode
  fechaActual = fechaMinima; // This is where it all starts.
  //paginaActualS = 0;

  // - NORMAL RESET OF EVERYTHING
  paginaActual = 0;
  itemActual = 0;
  anosFinales = "";
  titulosFinales = "";
  urlsFinales = "";
}
// ----------------------------------------------------------------------
void incrementarFecha() {

  // We will increment our dates or... end the segmented mode.
  fechaActual += intervaloSegmentosFecha;

  // Let's see if we are finished
  if (fechaActual+10 > fechaMaxima) {
    // Nothing to see here folks, it's over, segmented mode OFF
    segmentedMode = false;

    // Normal change
    efectuarCambioNormal();
  } else {
    // - NORMAL RESET OF EVERYTHING (for internal recursive dates)
    paginaActual = 0;
    itemActual = 0;
    // (We won't reset items here, because we want the arrays to keep on building)
  }
}
