// This tab has been directly imported from the Rise And Fall final Code v11, no changes made whatsoever.
// --------------------------------------------------- \\
// ------------- data loading ------------------------ \\
// --------------------------------------------------- \\
// This tab relates loads all of the data!!!!!!!!!!!!!!!!
//
// * Working variables
int topics, writers, technicians, artists, musicians; // totales
String [] artistNombre, technicianNombre, writerNombre, topicNombre, musicianNombre; // Names
// * Complex detailed data files --->
Data [] artistInfo, technicianInfo, writerInfo, topicInfo, musicianInfo; 
Data itemT; // We'll use this item to iterate individually while displaying data
// *
// ------------------------------------------------------------------------------------------------------------------------
void loadData() {
  println(">> DATA loading starts --- > ");

  // 1. First we load the index data (Nombre)cap
  artistNombre =  loadStrings("DATA/INDICES/artists.txt");
  technicianNombre =  loadStrings("DATA/INDICES/technicians.txt");
  writerNombre =  loadStrings("DATA/INDICES/writers.txt");
  topicNombre =  loadStrings("DATA/INDICES/topics.txt");
  musicianNombre =  loadStrings("DATA/INDICES/musicians.txt");

  // 2. We specify the quantities
  artists = artistNombre.length;
  technicians = technicianNombre.length;
  writers = writerNombre.length;
  topics = topicNombre.length;
  musicians = musicianNombre.length;
  println(">> TOTALES >> artists("+artists+")  technicians("+technicians+")  writers("+writers+")  topics("+topics+")");
  println(" >> ------------------------------------------------------------------------------------------------------");
  // 3. We start the Main Arrays
  artistInfo = new Data[ artists ];
  technicianInfo = new Data[ technicians ];
  writerInfo = new Data [ writers ];
  topicInfo = new Data [ topics ];
  musicianInfo = new Data [ topics ];

  // 3. We load each data for each member of the name's array, and put it into the INFO Data container(Ano, Url, Titulo)
  for (int i = 0; i < artists; i++) { // ARTIST

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"artists/"+artistNombre[i]+".txt"); // NGrams
    // 2. We create a new SubClass 
    artistInfo[i] = new Data( anoT, urlT, tituloT, nGramsT );

    // 3. Feedback
    if (i == 0) println(">> First Artist["+i+"]: "+ artistNombre[i]+" ("+artistInfo[i].getAno(0)+") -> "+artistInfo[i].getTitulo(0));
  }
  for (int i = 0; i < writers; i++) { // WRITER

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"writers/"+writerNombre[i]+".txt"); // NGrams

    // 2. We create a new SubClass 
    writerInfo[i] = new Data( anoT, urlT, tituloT, nGramsT );

    // 3. Feedback
    if (i == 0) println(">> First Writer["+i+"]: "+ writerNombre[i]+" ("+writerInfo[i].getAno(0)+") -> "+writerInfo[i].getTitulo(0));
  }
  for (int i = 0; i < technicians; i++) { // TECHNICIAN

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"technicians/"+technicianNombre[i]+".txt"); // NGrams

    // 2. We create a new SubClass 
    technicianInfo[i] = new Data( anoT, urlT, tituloT, nGramsT );

    // 3. Feedback
    if (i == 0) println(">> First Tech["+i+"]: "+ technicianNombre[i]+" ("+technicianInfo[i].getAno(0)+") -> "+technicianInfo[i].getTitulo(0));
  }
  for (int i = 0; i < topics; i++) { // TOPIC

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"topics/"+topicNombre[i]+".txt"); // NGrams

    // 2. We create a new SubClass 
    topicInfo[i] = new Data( anoT, urlT, tituloT, nGramsT );

    // 3. Feedback
    if (i == 0) println(">> First TOPIC["+i+"]: "+ topicNombre[i]+" ("+topicInfo[i].getAno(0)+") -> "+topicInfo[i].getTitulo(0));
  }
  for (int i = 0; i < musicians; i++) { // MUSICIAN

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"musicians/"+musicianNombre[i]+".txt"); // NGrams

    // 2. We create a new SubClass 
    musicianInfo[i] = new Data( anoT, urlT, tituloT, nGramsT );

    // 3. Feedback
    if (i == 0) println(">> First MUSICIAN["+i+"]: "+ musicianNombre[i]+" ("+musicianInfo[i].getAno(0)+") -> "+musicianInfo[i].getTitulo(0));
  }
  // Ends Load Data function
  print(">> NGRAMS loaded too!");
  println(">> ------------------------------------------------------------------------------------------------------");
}

// -----------------------------------------------------------------------------------------------------------
// This Small Class will keep all of our Data for each individual (very helpful)

class Data {
  // A. Properties
  String [] ano, url, titulo, nGrams;
  float [] nGramF;
  int cantidad, cantidadNGrams;

  // B. Constructores
  Data(String [] ano, String [] url, String [] titulo, String [] nGram) {
    this.ano = ano;
    this.url = url;
    this.titulo = titulo;
    this.cantidad = ano.length;
    this.nGrams = nGram;
    this.cantidadNGrams = nGram.length-1;
    // We fill the float NGram Array with floating numbers
    
    this.nGramF = new float[ cantidadNGrams ];
    for (int i = 0; i < cantidadNGrams; i++) {
      nGramF[i] = float( nGram[i] );
    }
  }

  // C. Getters/Setters (Very important, this is how we access the data)
  int getCantidad() {
    return cantidad;
  }
  String getAno(int i) {
    return ano[i];
  }
  String getUrl(int i) {
    return url[i];
  }
  String getTitulo(int i) {
    return titulo[i];
  }
  String getNGram(int i) {
    return nGrams[i];
  }
  float getNGramF(int i) {
    return nGramF[i];
  }
  int getCantidadNGrams() {
    return cantidadNGrams;
  }
}

