// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// 0 artists | 1 musicians | 2 technicians | 3 topics | 4 writers
// NGRAM top Parser
// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ FUNCTION STARTS
// This is where the true magic happens, we will sort every data per year
void analizarNGrams() {
  println(">> NGRAMS ANALYSIS STARTS.... bleep... bleep");

  // 0. How many years?
  int anoInicial = 1900;
  int anoFinal = 2015;
  int anos = anoFinal-anoInicial;

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ARTISTS NGrams

  // 1. We will create a new NGram object
  nGramYear [] artistsYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category)
    artistsYears[i] = new nGramYear(artists, "artists", anoActual, "NGRAMS");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < artists; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = artistNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. Which NGram position do we want
      int cantidadNGrams = artistInfo[j].getCantidadNGrams();
      int deseo = int(map( anoActual, anoInicial, anoFinal, 0, cantidadNGrams ));

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iiI. We get the dato (in floating number) of that specific years
      float dato = artistInfo[j].getNGramF(deseo);

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iv. We fill the nGram Year object
      artistsYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    artistsYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    artistsYears[i].saveData();
  }

  // Final feedback
  println("ARTISTS >> all years data saved");

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ MUSICIANS NGrams

  // 1. We will create a new NGram object
  nGramYear [] musiciansYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category)
    musiciansYears[i] = new nGramYear(musicians, "musicians", anoActual, "NGRAMS");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < musicians; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = musicianNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. Which NGram position do we want
      int cantidadNGrams = musicianInfo[j].getCantidadNGrams();
      int deseo = int(map( anoActual, anoInicial, anoFinal, 0, cantidadNGrams ));

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iiI. We get the dato (in floating number) of that specific years
      float dato = musicianInfo[j].getNGramF(deseo);

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iv. We fill the nGram Year object
      musiciansYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    musiciansYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    musiciansYears[i].saveData();
  }

  // Final feedback
  println("MUSICIANS >> all years data saved");

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ TECHNICIANS NGrams

  // 1. We will create a new NGram object
  nGramYear [] techniciansYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category)
    techniciansYears[i] = new nGramYear(technicians, "technicians", anoActual, "NGRAMS");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < technicians; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = technicianNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. Which NGram position do we want
      int cantidadNGrams = technicianInfo[j].getCantidadNGrams();
      int deseo = int(map( anoActual, anoInicial, anoFinal, 0, cantidadNGrams ));

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iiI. We get the dato (in floating number) of that specific years
      float dato = technicianInfo[j].getNGramF(deseo);

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iv. We fill the nGram Year object
      techniciansYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    techniciansYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    techniciansYears[i].saveData();
  }

  // Final feedback
  println("TECHNICIANS >> all years data saved");

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ TOPICS NGrams

  // 1. We will create a new NGram object
  nGramYear [] topicsYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category)
    topicsYears[i] = new nGramYear(topics, "topics", anoActual, "NGRAMS");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < topics; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = topicNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. Which NGram position do we want
      int cantidadNGrams = topicInfo[j].getCantidadNGrams();
      int deseo = int(map( anoActual, anoInicial, anoFinal, 0, cantidadNGrams ));

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iiI. We get the dato (in floating number) of that specific years
      float dato = topicInfo[j].getNGramF(deseo);

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iv. We fill the nGram Year object
      topicsYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    topicsYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    topicsYears[i].saveData();
  }

  // Final feedback
  println("TOPICS >> all years data saved");

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ WRITERS NGrams

  // 1. We will create a new NGram object
  nGramYear [] writersYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category)
    writersYears[i] = new nGramYear(writers, "writers", anoActual, "NGRAMS");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < writers; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = writerNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. Which NGram position do we want
      int cantidadNGrams = writerInfo[j].getCantidadNGrams();
      int deseo = int(map( anoActual, anoInicial, anoFinal, 0, cantidadNGrams ));

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iiI. We get the dato (in floating number) of that specific years
      float dato = writerInfo[j].getNGramF(deseo);

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iv. We fill the nGram Year object
      writersYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    writersYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    writersYears[i].saveData();
  }

  // Final feedback
  println("WRITERS >> all years data saved");


  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ We close everything
  // This function should close the sketch once it finishes
  //estoyAnalizando = false;
  if(!NYTimesMode) exit();
}

// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ DAT YEARLY CLASS

// This object holds all of the NGRAM data of one specific year
// For example, all NGram data of 1994 of the artists category
class nGramYear {
  // A. Properties
  String [] dataList; // This will hold all of the data
  String categoria, tipo;
  int contadorLocal, ano;

  // B.  
  nGramYear(int cantidad, String categoria, int ano, String tipo) { // This wilL vary depending on the # of artists or # of topics...
    dataList = new String[cantidad];
    contadorLocal = 0;
    this.categoria = categoria;
    this.ano = ano;
    this.tipo = tipo; // "NGRAMS or NYTimes"
  }
  // C. SETters
  void setNewItem(float dato, String nombre) {
    // For NGRAMS we need a floating data, so, no probs
    if (tipo == "NGRAMS") dataList[contadorLocal] = ano+","+dato+","+nombre;
    // For NYTimes we need a working data, so..;.
    // The thing is, the ordering array needs the same number Digits
    if (tipo == "NYTimes") {
      String datoB = ""; 
      // We'll add some zeros
      if (dato < 1000) {
        datoB = "0"+dato;
        if (dato < 100) {
          datoB = "0"+datoB;
          if (dato<10) {
            datoB = "0"+datoB;
          }
        }
      }
      dataList[contadorLocal] = ano+","+datoB+","+nombre;
    }
    contadorLocal++;
  }
  // D. GETters

  // Methods
  void sortData() {
    //This function will put the highest NGram values on the top (for this year tho)
    // 1. First we sort it so the ones are on top
    dataList = sort(dataList);
    // 2. Since the data is reversed (1 means zero) we reverse our array
    if (tipo == "NYTimes") dataList = reverse(dataList); // For some reason, we didn't need to
  }

  // -----------------------
  void saveData() {
    // Now we save the data
    String ruta = "DATA/"+tipo+"_yearlyTops/"+categoria+"/"+ano+".txt";
    saveStrings(ruta, dataList);
  }
}
