
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// 0 artists | 1 musicians | 2 technicians | 3 topics | 4 writers
// NYTimes Top Parser

// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ FUNCTION STARTS
// This is where the true magic happens, we will sort every data per year
void analizarNYTimes() {
  println(">> NYTIMES ANALYSIS STARTS.... bleep... bleep");

  // 0. How many years?
  int anoInicial = 1900;
  int anoFinal = 2015;
  int anos = anoFinal-anoInicial;

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ nytimes      ARTISTS   

  // 1. We will create a new NGram object
  nGramYear [] artistsYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category, current year, NYtimes or NGRAMS)
    artistsYears[i] = new nGramYear(artists, "artists", anoActual, "NYTimes");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < artists; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = artistNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. We will calculate how many mentions this artist has in this very particular year
      int dato = 0;
      int cantidadMentions = artistInfo[j].getCantidad(); // How many mentions does this artist has?
      for (int k = 0; k < cantidadMentions; k++) {
        // We will cycle thru each mentions and if it is our target year, we increase the number, that simple
        if ( int(artistInfo[j].getAno(k)) == int(anoActual) ) dato++;
      }
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iii. We fill the nGram Year object
      artistsYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    artistsYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    artistsYears[i].saveData();
  }
  // Final feedback
  println("ARTISTS >> all years data saved (NyTimes Mode)");


// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ nytimes      MUSICIANS  

  // 1. We will create a new NGram object
  nGramYear [] musiciansYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category, current year, NYtimes or NGRAMS)
    musiciansYears[i] = new nGramYear(musicians, "musicians", anoActual, "NYTimes");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < musicians; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = musicianNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. We will calculate how many mentions this artist has in this very particular year
      int dato = 0;
      int cantidadMentions = musicianInfo[j].getCantidad(); // How many mentions does this artist has?
      for (int k = 0; k < cantidadMentions; k++) {
        // We will cycle thru each mentions and if it is our target year, we increase the number, that simple
        if ( int(musicianInfo[j].getAno(k)) == int(anoActual) ) dato++;
      }
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iii. We fill the nGram Year object
      musiciansYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    musiciansYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    musiciansYears[i].saveData();
  }
  // Final feedback
  println("MUSICIANS >> all years data saved (NyTimes Mode)");
  
  
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ nytimes      TECHNICIANS   

  // 1. We will create a new NGram object
  nGramYear [] techniciansYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category, current year, NYtimes or NGRAMS)
    techniciansYears[i] = new nGramYear(technicians, "technicians", anoActual, "NYTimes");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < technicians; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = technicianNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. We will calculate how many mentions this artist has in this very particular year
      int dato = 0;
      int cantidadMentions = technicianInfo[j].getCantidad(); // How many mentions does this artist has?
      for (int k = 0; k < cantidadMentions; k++) {
        // We will cycle thru each mentions and if it is our target year, we increase the number, that simple
        if ( int(technicianInfo[j].getAno(k)) == int(anoActual) ) dato++;
      }
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iii. We fill the nGram Year object
      techniciansYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    techniciansYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    techniciansYears[i].saveData();
  }
  // Final feedback
  println("TECHNICIANS >> all years data saved (NyTimes Mode)");
  
  
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ nytimes      TOPICS

  // 1. We will create a new NGram object
  nGramYear [] topicsYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category, current year, NYtimes or NGRAMS)
    topicsYears[i] = new nGramYear(topics, "topics", anoActual, "NYTimes");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < topics; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = topicNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. We will calculate how many mentions this artist has in this very particular year
      int dato = 0;
      int cantidadMentions = topicInfo[j].getCantidad(); // How many mentions does this artist has?
      for (int k = 0; k < cantidadMentions; k++) {
        // We will cycle thru each mentions and if it is our target year, we increase the number, that simple
        if ( int(topicInfo[j].getAno(k)) == int(anoActual) ) dato++;
      }
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iii. We fill the nGram Year object
      topicsYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    topicsYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    topicsYears[i].saveData();
  }
  // Final feedback
  println("TOPICS >> all years data saved (NyTimes Mode)");
  
  
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ nytimes      WRITERS   

  // 1. We will create a new NGram object
  nGramYear [] writersYears = new nGramYear[ anos ];

  // 2. We will fill it, one nGramYear per year, duh
  for (int i = 0; i < anos; i++) {

    // a. The year (first value of our component)
    int anoActual = anoInicial+i;

    // b. We create a new object, just for this year
    //                          ( totals,  category, current year, NYtimes or NGRAMS)
    writersYears[i] = new nGramYear(writers, "writers", anoActual, "NYTimes");

    // c. Now we will cycle thru earch and every artist/musician/topic...
    for (int j = 0; j < writers; j++) {
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // i. We get the name
      String nombre = writerNombre[j];

      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // ii. We will calculate how many mentions this artist has in this very particular year
      int dato = 0;
      int cantidadMentions = writerInfo[j].getCantidad(); // How many mentions does this artist has?
      for (int k = 0; k < cantidadMentions; k++) {
        // We will cycle thru each mentions and if it is our target year, we increase the number, that simple
        if ( int(writerInfo[j].getAno(k)) == int(anoActual) ) dato++;
      }
      // ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼ ▼
      // iii. We fill the nGram Year object
      writersYears[i].setNewItem( dato, nombre);
    }

    // d. Now that all the data is filled, we sort all of the NGrams, so we can get the top ones
    writersYears[i].sortData();

    // e. Now that the data has been sorted, we save it into one file
    writersYears[i].saveData();
  }
  // Final feedback
  println("WRITERS >> all years data saved (NyTimes Mode)");

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ We close everything
  // This function should close the sketch once it finishes, it's done, nothing to see here boys
  exit();
}
