// --------------------------------------------------- \\
// ------------- data loading ------------------------ \\
// --------------------------------------------------- \\
// This tab relates loads all of the data!!!!!!!!!!!!!!!!
//
// * Working variables
int topics, writers, technicians, artists, musicians; // totales
String [] artistNombre, technicianNombre, writerNombre, topicNombre, musicianNombre; // Names

// * Complex detailed data files --->
Data [] artistInfo, technicianInfo, writerInfo, topicInfo, musicianInfo; 
YearlyData [] artistInfoTopNYT, technicianInfoTopNYT, writerInfoTopNYT, topicInfoTopNYT, musicianInfoTopNYT;
YearlyData [] artistInfoTopNGram, technicianInfoTopNGram, writerInfoTopNGram, topicInfoTopNGram, musicianInfoTopNGram;
Data itemT, detailItem; // We'll use this item to iterate individually while displaying data
// *
// ------------------------------------------------------------------------------------------------------------------------
void loadData() {
  println(">> DATA loading starts --- > ");

  // 1. First we load the index data (Nombre)cap
  artistNombre =  loadStrings("DATA/INDICES/artists.txt");
  technicianNombre =  loadStrings("DATA/INDICES/technicians.txt");
  writerNombre =  loadStrings("DATA/INDICES/writers.txt");
  topicNombre =  loadStrings("DATA/INDICES/topics.txt");
  musicianNombre =  loadStrings("DATA/INDICES/musicians.txt");

  // 2. We specify the quantities
  artists = artistNombre.length;
  technicians = technicianNombre.length;
  writers = writerNombre.length;
  topics = topicNombre.length;
  musicians = musicianNombre.length;
  println(">> TOTALES >> artists("+artists+")  technicians("+technicians+")  writers("+writers+")  topics("+topics+")");
  println(" >> ------------------------------------------------------------------------------------------------------");

  // XX. We load the Yearly Data
  cargarYearlyData();

  // 3. We start the Main Arrays
  artistInfo = new Data[ artists ];
  technicianInfo = new Data[ technicians ];
  writerInfo = new Data [ writers ];
  topicInfo = new Data [ topics ];
  musicianInfo = new Data [ topics ];

  // 3. We load each data for each member of the name's array, and put it into the INFO Data container(Ano, Url, Titulo)
  for (int i = 0; i < artists; i++) { // ARTIST

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"artists/"+artistNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"artists/"+artistNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"artists/"+artistNombre[i]+".txt"); // NYTimes yearly tops
    // 2. We create a new SubClass 
    artistInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "artists" );

    // 3. Feedback
    if (i == 0) println(">> First Artist["+i+"]: "+ artistNombre[i]+" ("+artistInfo[i].getAno(0)+") -> "+artistInfo[i].getTitulo(0));
  }
  for (int i = 0; i < writers; i++) { // WRITER

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"writers/"+writerNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"writers/"+writerNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"writers/"+writerNombre[i]+".txt"); // NYTimes yearly tops

    // 2. We create a new SubClass 
    writerInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "writers" );

    // 3. Feedback
    if (i == 0) println(">> First Writer["+i+"]: "+ writerNombre[i]+" ("+writerInfo[i].getAno(0)+") -> "+writerInfo[i].getTitulo(0));
  }
  for (int i = 0; i < technicians; i++) { // TECHNICIAN

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"technicians/"+technicianNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"technicians/"+technicianNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"technicians/"+technicianNombre[i]+".txt"); // NYTimes yearly tops

    // 2. We create a new SubClass 
    technicianInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "technicians" );

    // 3. Feedback
    if (i == 0) println(">> First Tech["+i+"]: "+ technicianNombre[i]+" ("+technicianInfo[i].getAno(0)+") -> "+technicianInfo[i].getTitulo(0));
  }
  for (int i = 0; i < topics; i++) { // TOPIC

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"topics/"+topicNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"topics/"+topicNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"topics/"+topicNombre[i]+".txt"); // NYTimes yearly tops

    // 2. We create a new SubClass 
    topicInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "topics" );

    // 3. Feedback
    if (i == 0) println(">> First TOPIC["+i+"]: "+ topicNombre[i]+" ("+topicInfo[i].getAno(0)+") -> "+topicInfo[i].getTitulo(0));
  }
  for (int i = 0; i < musicians; i++) { // MUSICIAN

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"musicians/"+musicianNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"musicians/"+musicianNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"musicians/"+musicianNombre[i]+".txt"); // NYTimes yearly tops

    // 2. We create a new SubClass 
    musicianInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "musicians");

    // 3. Feedback
    if (i == 0) println(">> First MUSICIAN["+i+"]: "+ musicianNombre[i]+" ("+musicianInfo[i].getAno(0)+") -> "+musicianInfo[i].getTitulo(0));
  }
  // Ends Load Data function
  print(">> NGRAMS loaded too!");
  println(">> ------------------------------------------------------------------------------------------------------");
}
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ 
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓  D A T A  -  C L A S S E S
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ 
// -----------------------------------------------------------------------------------------------------------
// This BOTH Small Classes will keep all of our Data for each individual (very helpful)
// One fo the main Data (except yearly top participants)
class Data {
  // A. Properties
  String [] ano, url, titulo, nGrams;
  float [] nGramF;
  String tipo; // artists ? musicians ? technicians ? topics ? writers ?
  int cantidad, cantidadNGrams;
  //YearlyData [] nGramYears; // We will store all of the NGRAM Yearly Data Here
  // YearlyData [] NYTimesYears; // We will store all of the NYTimes Yearly Data Here

  // B. Constructores
  Data(String [] ano, String [] url, String [] titulo, String [] nGram, String tipo) {
    this.ano = ano;
    this.url = url;
    this.titulo = titulo;
    this.cantidad = ano.length;
    this.nGrams = nGram;
    this.tipo = tipo;
    this.cantidadNGrams = nGram.length-1;
    // We fill the float NGram Array with floating numbers
    this.nGramF = new float[ cantidadNGrams ];
    for (int i = 0; i < cantidadNGrams; i++) {
      nGramF[i] = float( nGram[i] );
    }
  }

  // C. Getters/Setters (Very important, this is how we access the data)
  int getCantidad() {
    return cantidad;
  }
  String getAno(int i) {
    return ano[i];
  }
  String getUrl(int i) {
    return url[i];
  }
  String getTitulo(int i) {
    return titulo[i];
  }
  String getNGram(int i) {
    return nGrams[i];
  }
  float getNGramF(int i) {
    return nGramF[i];
  }
  int getCantidadNGrams() {
    return cantidadNGrams;
  }
  /*
  String [] getNGramYearlyTop(int anoDeseado) {
   // anoDeseado should come in 0, 1, 2, 3 array numeration (take the necessary precautions)
   return nGramYears[anoDeseado].getYearValues();
   }
   String [] getNYTimesYearlyTop(int anoDeseado) {
   // anoDeseado should come in 0, 1, 2, 3 array numeration (take the necessary precautions)
   return NYTimesYears[anoDeseado].getYearValues();
   }
   */
}
// *******************************************************************************************************************************************************
// YEALRY DATA --> One individual class to store just one single year data *******************************************************************************
// *******************************************************************************************************************************************************
class YearlyData {
  // A. Properties ------------------------------------------------------------------------
  String [] yearValues; // WE will hold all of the individual year values here
  String ruta, tipo;
  int ano;

  // B. Constructor -----------------------------------------------------------------------
  //NYTimesYears[i] = new YearlyData( "NGRAMS_yearlyTops", anoActual, tipo );
  YearlyData( String ruta, int ano, String tipo ) {
    this.ruta = ruta;
    this.ano = ano;
    this.tipo = tipo;
    // We load the array
    String rutaFinal = ruta+"/"+tipo+"/"+ano+".txt";
    yearValues = loadStrings(rutaFinal);
    // Feedback: 
    if (random(100) > 99) {
      //println("Random year data loaded --> "+rutaFinal);
      //println("Pos 0: "+yearValues[0]);
    }
  }
  // C. Getters | Setters -----------------------------------------------------------------
  String [] getYearValues() {
    return yearValues;
  }
  // Class ends next ---->
}


// -------------------------------------------------------------------------------
// The function that creates the Yearly data using the previous class
/*
This Variables were declared earlier:
 YearlyData [] artistInfoTopNYT, technicianInfoTopNYT, writerInfoTopNYT, topicInfoTopNYT, musicianInfoTopNYT;
 YearlyData [] artistInfoTopNGram, technicianInfoTopNGram, writerInfoTopNGram, topicInfoTopNGram, musicianInfoTopNGram;
 */
void cargarYearlyData() {
// WHat is important to remember is that every item in this array is a YearlyDataObject which we can call to get information

  // i. Total quantity of years
  int cantidadAnos = int(fecha2-fecha1);

  // ii. We start all Arrays NYT and NGram
  artistInfoTopNYT = new YearlyData[cantidadAnos];
  technicianInfoTopNYT = new YearlyData[cantidadAnos];
  writerInfoTopNYT = new YearlyData[cantidadAnos];
  topicInfoTopNYT = new YearlyData[cantidadAnos];
  musicianInfoTopNYT = new YearlyData[cantidadAnos];
  //
  artistInfoTopNGram = new YearlyData[cantidadAnos];
  technicianInfoTopNGram = new YearlyData[cantidadAnos];
  writerInfoTopNGram = new YearlyData[cantidadAnos];
  topicInfoTopNGram = new YearlyData[cantidadAnos];
  musicianInfoTopNGram = new YearlyData[cantidadAnos];


  // iii. We fill these Arrays
  for (int i = 0; i < cantidadAnos; i++) {
    int anoActual = int(fecha1+i);
    //                                 (folder Name,       year,    category 
    artistInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "artists");
    artistInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "artists");
    //
    musicianInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "musicians");
    musicianInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "musicians");
    //
    technicianInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "technicians");
    technicianInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "technicians");
    //
    topicInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "topics");
    topicInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "topics");
    //
    writerInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "writers");
    writerInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "writers");
  }
  
  //return nGramYears[anoDeseado].getYearValues();
}
