
// ************************************************************************************************************* \\
// ************************************************************************************************************* \\
// *************************************** r · i · s · e · · & · · f · a · l · l ·****************************** \\
// ************************************************************************************************************* \\
// ************************************************************************************************************* \\
//                                                                                                               \\
// An electronic art history exploration by JM Escalante | MAT-UCSB |  realitat.com | jmescalante@realitat.com   \\
//                                                                                                               \\
// ************************************************************************************************************* \\
/*
Version History
 
 01 - Early setup and data load
 02 - We load the NGram data as Numbers
 03 - First dataViz attempt
 04 - Too many squares, second attempt with PShape (too many shapes being drawn at the same time, issue not yet resolved, paused)
 04 - Zooming and main timeline operations implemented | first fonts loaded too
 05 - Huge Map Data Viz Working (needs more tunning tho) | Terrible mistake of not including musicians
 06 - NGram early tests
 07 - NGram visual style solved!
 08 - Texts over Mouse implemented and HugeMaps with different types of data (much needed for performance) huge Data Viz highly modified here
 09 - The alternate filling of the Array now belongs to a different function and DataMatrix CLASS (which does all of the sorting)
 10 - The gridMap (Tenori-on homage)  now works | Play function with spacebar implemented | PDF Record
 11 - TOP Yearly terms loaded | Central year type in the middle 
 12 - Yearly counts now finally visualized as a separate dataViz() | BIG step ! 
 13 - Text now appear in the huge graphic in the PDF | Crosses in corners | Fixed a problem of sketh crash due to invalid date | click to google button!
 Close button | Graph Titles | huge Map now supports huge and mini versions with the ability to change NYTimes or NGram from the outside
 Titles on each graph now implemented | animated crosses 
 14 - Scenarios motor implemented (not yet the buttons to acces it, just via keyboard)
 15 - Individual scenario (took one entire day to code) now working in all vizMap types.
 16 - Back button in detail view | Main Navigation | type improvements | startCover 
 17 - Low Resolution Modes Corrected
 
 */
// * Switches and other variables (data variables in "d_a_t_a" tab)
Boolean frameFeedback = true;
Boolean fullscreen = true;
int ancho = 1280;
int alto = 720;
import processing.pdf.*;
// *
// - - Color Definitions
color amarillo =  color(255, 190, 15);// Yellow
color naranja = color(255, 96, 10);// Pure orange
color rojo = color(255, 10, 10); // Rojo medio anaranjado
color blanco = color(230, 246, 255); // Azul super claro, casi blanco
color azul1 =  color(125, 223, 255);// Clarito
color azul2 = color(0, 162, 255); // Oscuro (semi)
color azul3 = color(26, 32, 39); // SUPER OSCURO (fondo)
// -------------------------------------------------------------------------------------------------------------------

void setup() {
  // 1. Display properties
  sizeProperties();  
  // 2. We load the data (crucial step)
  loadData();
  // 3. We create the shapes for PShapes
  loadShapes();
  // 4. Font operations
  loadFonts();
  // 5. Starting cover values
  startCover();
}


// ------------------------------------------------------------------------------------------------------------------
//
void draw() { // NEEDS TO BE CLEANED UP!!!
  if (deboIniciarPDF) iniciarPDF();
  // Fondo
  background(azul3);

  // We show the scenarios
  mostrarEscenarios();

  // Zooming and Paning operations
  zooming();

  // WE draw the closing button interface
  if (!deboTerminarPDF) closeButton(); // ( X )

  // We check if the project is playing currently
  if (enReproduccion) playFunction();

  // 
  if (deboTerminarPDF) terminarPDF();


  // Kamindustries CEO's trick
  if (frameCount%2==0 && frameFeedback) {
    fill(blanco);
    if (escenarioActual == "detail view") fill(azul3);
    textFont(avenirMediumSmall, 8);
    //text(frameRate, width - 45, 19);
  }
  //
  if (enTransicion) ejecutarTransicion();
}
