// -------------------------------------------------------- \\
// ------------- TOP MENTIONS VIEW ------------------------ \\
// -------------------------------------------------------- \\
// 
// -------------------------------------------------------------------------------------
// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████  FUNCTION START
// This function shows the TOP terms for some categories
// ----------( cooordenadas -------------------------- la categoria , cuantos tops,   )
void topsMap(float c1x, float c1y, float c2x, float c2y, String quienes, String title, int limite) {

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ TEST RECT *
  // 1. Rectangle test ( comment and uncomment as needed )
  shapeMode(CORNERS);
  fill(red(blanco), green(blanco), blue(blanco), 17);
  //shape(Rect, c1x, c1y, c2x, c2y);

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ CENTER COORDINATES
  // 1. We specify our centers (from where we'll work)
  float ancho = c2x-c1x;
  float cx = c1x+(ancho/2); // el centro en X
  float alto = c2y-c1y;
  float cy = c1y+(alto/2); // el centro en Y
  cy = c1y;
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ COLOR
  // 1. Each color for every category
  color c = obtenerColor(quienes);

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ MAIN TITLE AND subdividing line
  // 1. We put the main title
  float alturaTitle = c1y+7.5;
  fill(c);
  textAlign(CENTER);
  textFont(avenirTops);
  text(title, cx, alturaTitle);
  // 2. A dividing line (just for reference perhaps)
  stroke(blanco);
  stroke(red(blanco), green(blanco), blue(blanco), 70);
  //line(cx, alturaTitle+20, cx, alturaTitle+( alto-17.5 ));


  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ GATHERING THE DATA
  // 1. To make this easier, we'll create a new object with all of the data
  TopData datosTop = new TopData( quienes, limite, int(timeLineCenter) ); // (both for NYT & NGram)
  String [] nombresNYTop = datosTop.getNombresNYT(); // Para los main titles            - NYT
  String [] valoresNYTop = datosTop.getValoresNYT(); // Para el subtitle % o items      - NYT
  String [] nombresNGramTop = datosTop.getNombresNGram(); // Para los main titles       - NGRAMS 
  String [] valoresNGramTop = datosTop.getValoresNGram(); // Para el subtitle % o items - NGRAMS


  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ ANIMATING the circle growth 


  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ DRAWING THE VALUES
  // 
  float alturaRenglon = 30;
  float alturaInicio = alturaTitle+40;
  float desplazamientoH = 13; // How much we will move to the left or right the text between the columns

  // 1. We draw the whole data ------------------------------------
  float textoXR = 0.0; // We put this outside so we can access it for the subtitles
  float textoLR = 0.0;
  float textoXL = 0.0;
  float yRenglon = 100;
  for (int i = 0; i < limite && i < 15 && yRenglon < c2y-20; i++) {
    // -------------------------------------------------------------
    // a. We calculate the row height  -----------------------------
    yRenglon = alturaInicio+(alturaRenglon*i);

    // ---------------------------------------------------------------------
    // b. Let's specify coordinates for the center circles ------------------------------------ ( we are not drawing them right now)
    //     b1 LEFT (nyt)
    float xCircleL = cx-desplazamientoH;
    //     b2 RIGHT (ngram)
    float xCircleR = cx+desplazamientoH;


    // -------------------------------------------------------------
    // c. Let's put the main TITLE and SUBTITLE ----------------------
    //     c1 LEFT (nyt)
    String topTitleL = nombresNYTop[i]; // Value for the top title
    int subTitleL = int(valoresNYTop[i]); // Value for the subtitle
    if (subTitleL == 0) topTitleL = "X"; // We put an "x" if there is no value
    textoXL = xCircleL-(alturaRenglon/2) -8; // Location of the text
    fill(c);
    textAlign(RIGHT);
    textFont(avenirBlack, 8);
    if (i == 0) textFont(avenirBlack, 11); // If it is the first, special font treatment
    text(topTitleL.toUpperCase(), textoXL, yRenglon +3); // Top title
    textFont(avenirHeavy, 7);
    fill( red(blanco), green(blanco), blue(blanco), 150 );
    if (subTitleL > 0) text( subTitleL, textoXL, yRenglon +12 ); // Subtitle, only if it's greater than -
    //     d2 RIGHT (nGram)
    String topTitleR = nombresNGramTop[i]; // Value for the Top title
    float subTitleR = map(float(valoresNGramTop[i]), 0, 1, 1, 0); // Subtitle Value (inverted cause of the NGram conversion)
    float subTitleRPorcentaje = int(map(subTitleR, 0, 1, 0, 100 )); // 
    String subTitleRArreglado = subTitleRPorcentaje+"%";
    if (subTitleR <= 0) topTitleR = "X";
    textoXR = xCircleR+(alturaRenglon/2) +8;
    fill(c);
    textAlign(LEFT);
    textFont(avenirBlack, 8);
    if (i == 0) textFont(avenirBlack, 11);
    text(topTitleR.toUpperCase(), textoXR, yRenglon +3);
    textFont(avenirHeavy, 7);
    fill( red(blanco), green(blanco), blue(blanco), 150 );
    if (subTitleR > 0) text( subTitleRArreglado, textoXR, yRenglon +12 );


    // 



    // ------------------------------------------------------------------------------------
    // c. Let's specify the center circles sizes first ------------------------------------
    //     b1 LEFT (nyt)
    //float xCircleL = cx-desplazamientoH;
    float tamanoCirculoL = alturaRenglon*1.5;
    float tamanoCirculoLArreglado = map( float(valoresNYTop[i]), float(valoresNYTop[int(limite-1)]), float(valoresNYTop[0]), tamanoCirculoL/7, tamanoCirculoL );
    float tamanoCirculoR = alturaRenglon*1.5*( subTitleRPorcentaje/100  );
    fill(red(c), green(c), blue(c), 160); // This color will only change if the mouse is over the button

    // -------------------------------------------------------------------------------------
    // d. Let's make them interactive (click to google) ------------------------------------
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••  NYT
    if ( hiceHit( xCircleL-(tamanoCirculoLArreglado/2), yRenglon-(tamanoCirculoLArreglado/2), xCircleL+(tamanoCirculoLArreglado/2), yRenglon+(tamanoCirculoLArreglado/2))) {
      if (topTitleL != "X") {
        // 1. MOUSE OVER DRAW ATTRIBUTES
        fill(blanco); // full HOVEr color

        // 2. ACTION AFTER HIT
        if (mousePressed && fallOff == 0) {
          String [] nombreABuscar = separarTexto(topTitleL, false);
          String nombreABuscarFinal = nombreABuscar[0]+"+"+nombreABuscar[1];
          String anoABuscar = int( timeLineCenter )+"";
          String rutaURL = "https://www.google.com/?gws_rd=ssl#safe=off&q="+nombreABuscarFinal+"+"+anoABuscar;
          open(rutaURL);

          fill(255); // White press

          fallOff = fallOffLimit;
        } 
        // 3. FALL OFF OPERATIONS (ignore)
        // FallOff Operations, highly important!
        fallOff -= 1;
        if (fallOff <= 0) fallOff = 0; // So we don't get negative values
      } // <-- No content iF
    } // <-- Button iF
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••

    // ------------------------------------------------------------------------------------
    // e1. Let's draw the NYTIMES MAIN circles  ------------------------------------
    //     e1 LEFT (nyt)
    noStroke();
    shapeMode(CENTER);
    shape(Ellipse, xCircleL, yRenglon, tamanoCirculoLArreglado, tamanoCirculoLArreglado);


    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••  NGrams
    fill(red(c), green(c), blue(c), 160); // This color will only change if the mouse is over the button
    if ( hiceHit( xCircleR-(tamanoCirculoR/2), yRenglon-(tamanoCirculoR/2), xCircleR+(tamanoCirculoR/2), yRenglon+(tamanoCirculoR/2))) {
      if (topTitleR != "X") {
        // 1. MOUSE OVER DRAW ATTRIBUTES
        fill(blanco); // full HOVER color

        // 2. ACTION AFTER HIT
        if (mousePressed && fallOff == 0) {
          String [] nombreABuscar = separarTexto(topTitleR, false);
          String nombreABuscarFinal = nombreABuscar[0]+"+"+nombreABuscar[1];
          String anoABuscar = int( timeLineCenter )+"";
          String rutaURL = "https://www.google.com/?gws_rd=ssl#safe=off&q="+nombreABuscarFinal+"+"+anoABuscar;
          open(rutaURL);

          fill(255); // White press

          fallOff = fallOffLimit;
        } 
        // 3. FALL OFF OPERATIONS (ignore)
        // FallOff Operations, highly important!
        fallOff -= 1;
        if (fallOff <= 0) fallOff = 0; // So we don't get negative values
      } // <-- No content iF
    } // <-- Button iF
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••

    // e2. Let's draw the NGRAMS MAIN circles  ------------------------------------
    //     e2. RIGHT (ngram)
    //float xCircleR = cx+desplazamientoH;
    //fill(c);
    shapeMode(CENTER);
    shape(Ellipse, xCircleR, yRenglon, tamanoCirculoR, tamanoCirculoR);


    // f. Let's draw the center dark circles ------------------------------------
    //     b1 LEFT (nyt)
    fill(azul3);
    shapeMode(CENTER);
    shape(Ellipse, xCircleL, yRenglon, 4, 4);
    //     b2 RIGHT (ngram)
    fill(azul3);
    shapeMode(CENTER);
    shape(Ellipse, xCircleR, yRenglon, 4, 4);
  }
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ NGRAM and Google Titles
  // 1. WE set a new height (x already defined in these variables --> textoXR | textoLR = 0.0;
  float alturaCategories = alturaTitle+20;

  // 2. We just draw the Text, that simple
  fill(red(blanco), green(blanco), blue(blanco), 70);
  textAlign(RIGHT);
  textFont( avenirMedium, 7 );
  text("NYTIMES", textoXL, alturaCategories);
  textAlign(LEFT);
  text("NGRAM", textoXR, alturaCategories);
  // TopsMap Viz ends next ---->
}

// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ 

// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ TPO DATA CLass

// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ 

// ----------------------------------------------------------------------------------------------------------
// This class will process all of the information we'll need and then return them
// This class was made to make it easy handling all of the values and keep the topsMap() function clan
/*
TopData datosTop = new TopData( quienes, limite, timeLineCenter ); // (both for NYT & NGram)
 String [] nombresNYTop = datosTop.getNombresNYT(); // Para los main titles            - NYT
 String [] valoresNYTop = datosTop.getValoresNYT(); // Para el subtitle % o items      - NYT
 String [] nombresNGramTop = datosTop.getNombresNGram(); // Para los main titles       - NGRAMS 
 String [] valoresNGramTop = datosTop.getValoresNGram(); // Para el subtitle % o items - NGRAMS
 */
// ----------------------------------------------------------------------------------------------------------
class TopData {
  // A. Propiedades -----------------------------------------------------------------------------------------
  String tipo; // artists? topics?....
  int limite; // How many items from the top ten we will return
  int fecha;
  // The arrays to hold the whole thing
  String [] rawNYT, rawNGrams; // This function will save the raw data
  String [] nombresNYT, nombresNGram, valoresNYT, valoresNGram;

  // B. Constructores ---------------------------------------------------------------------------------------
  TopData( String tipo, int limite, int fecha ) {
    // 1. We receive the values -----------------------------------------------------------------------------
    this.tipo = tipo;
    this.limite = limite;
    this.fecha = fecha;

    // 2. So, we get the Raw data for the NYT and NGram -----------------------------------------------------
    int anoDeseado = int(fecha-fecha1);
    // 
    if (tipo.equals("artists")) rawNYT = artistInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("artists")) rawNGrams = artistInfoTopNGram[anoDeseado].getYearValues();
    //
    if (tipo.equals("musicians")) rawNYT = musicianInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("musicians")) rawNGrams = musicianInfoTopNGram[anoDeseado].getYearValues();
    //
    if (tipo.equals("technicians")) rawNYT = technicianInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("technicians")) rawNGrams = technicianInfoTopNGram[anoDeseado].getYearValues();
    //
    if (tipo.equals("topics")) rawNYT = topicInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("topics")) rawNGrams = topicInfoTopNGram[anoDeseado].getYearValues();
    //
    if (tipo.equals("writers")) rawNYT = writerInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("writers")) rawNGrams = writerInfoTopNGram[anoDeseado].getYearValues();

    // 3. And now we start the final recipients array (the ones that will be returned) --------------------------
    nombresNYT = new String[limite];
    valoresNYT = new String[limite];
    nombresNGram = new String[limite];
    valoresNGram = new String[limite];

    // 4. Finally, we fill all of the items (notice that the NGram Values is already twisted) ------------------
    // We could probably did this function with some slice value, meh
    for (int i = 0; i < limite; i++) {

      // i. This is a ROW in the rawNYT Array --> 1906,0.79,Extended Reality
      //    We split every row
      String [] datosExplotadosNYT = split(rawNYT[i], ",");
      String [] datosExplotadosNGrams = split(rawNGrams[i], ",");

      // ii. We fill the values
      nombresNYT[i] = datosExplotadosNYT[2];
      valoresNYT[i] = datosExplotadosNYT[1];
      nombresNGram[i] = datosExplotadosNGrams[2];
      valoresNGram[i] = datosExplotadosNGrams[1];
    }
  }
  // C. GETTERS without them this class would make no sense -------------------------------------------------
  String [] getNombresNYT() {
    return nombresNYT;
  }
  String [] getValoresNYT() {
    return valoresNYT;
  }
  String [] getNombresNGram() {
    return nombresNGram;
  }
  String [] getValoresNGram() {
    return valoresNGram;
  }
}
