// ---------------------------------------------------- \\
// ------------- grid Map View ------------------------ \\
// ---------------------------------------------------- \\

// A more detailed view on each change based on an specific date (TENORI-ON STYLE)

// -------------------------------------------------------------------------------------
void gridMap(float c1x, float c1y, float c2x, float c2y, String quienes, Boolean dividir) {

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ WHICH DATA ARE WE GOING TO USE?
  // 1. ACTIVATED TYPES - Who is activated
  //   We create a new object to store all of our data files (and for future Array Filling)
  SortingHat dataMatrix = new SortingHat(quienes);

  // 2. QUANTITIES - We extract the total number from our datamatrix object
  int totales = dataMatrix.getTotales();

  // 3. ALTERNATION FILLING - The DataMatrix Object has already sorted everything for us
  String [] positionsTipo = dataMatrix.getPositionsTipo(); // We'll save the types here
  int [] positionsNo = dataMatrix.getPositionsNo(); // We'll save the numbers to each array position here

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ TEST RECT * CROSSES TOO
  // 1. Rectangle test ( comment and uncomment as needed )
  shapeMode(CORNERS);
  fill(red(blanco), green(blanco), blue(blanco), 17);
  //shape(Rect, c1x, c1y, c2x, c2y);
  //2. Some crosses to mark the territory
  colocarCrucecillas( c1x, c1y, c2x, c2y );

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ CEll size and DRAWING PROPERTIES
  // 1. We calculate height and width
  float altura = c2y-c1y;
  float ancho = c2x-c1x;

  // 2. We will estimate how many elements per row and column
  int renglones = ceil(sqrt(totales));
  int columnas = ceil(sqrt(totales));

  // 3. We will divide our width and height
  float anchoColumna = ancho/(columnas+1);
  float altoRenglon = altura/(renglones+1);

  // 4. According to the lowest value we will establish a cell size
  float cellSize = 1;
  if (anchoColumna > altoRenglon) cellSize = altoRenglon;
  if (altoRenglon > anchoColumna) cellSize = anchoColumna;

  // 5. We readjust the real cell size
  float alturaTexto = 18; //Very important since the text is down
  if(!dividir) alturaTexto = 10;
  float margen = 2;
  float cell = cellSize-(margen*2)-alturaTexto ;

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ ACTUAL DRAWING
  int contadorItems = 0;
  int  cellRes = 0; // Here, so we can access it later.
  // We cycle each cell
  for (int i = 0; i < renglones && contadorItems < totales; i++) {
    // 1. We establish a width for the cell
    float y = altoRenglon*(i+1);
    y += c1y;// We re-adjust the position
    for (int j = 0; j < columnas && contadorItems < totales; j++) {
      // 2. We establish a renglon height
      float x = anchoColumna*(j+1);
      x += c1x; 

      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ Cell individual operations start here
      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ 0 . Item T Object defined here
      if (positionsTipo[contadorItems].equals("artists")) itemT = artistInfo[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("musicians")) itemT = musicianInfo[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("technicians")) itemT = technicianInfo[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("writers")) itemT = writerInfo[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("topics")) itemT = topicInfo[positionsNo[contadorItems]];
      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ a . Main Cell drawing and preparations
      // 1. Cell Square
      noFill();
      strokeWeight(1);
      noStroke();
      fill(red(blanco), green(blanco), blue(blanco), 19);
      noStroke();
      // ellipse(x, y, 3, 3); // elipse de prueba
      rectMode(CENTER);
      rect(x, y, cell, cell);

      // 2. Middle line
      stroke(red(azul3), green(azul3), blue(azul3), 130);
      line( x, y- cell/2, x, y+ cell/2 );

      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ b . Getting the Name and displaying it

      // 3. Text - getting the data
      String nombre = "meh";
      if (positionsTipo[contadorItems].equals("artists")) nombre = artistNombre[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("writers")) nombre = writerNombre[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("technicians")) nombre = technicianNombre[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("musicians")) nombre = musicianNombre[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("topics")) nombre = topicNombre[positionsNo[contadorItems]];
      String [] nombreFinal = separarTexto(nombre, dividir);
      

      // 3 - B . Text - puttin' it there
      fill(blanco);
      textAlign(CENTER);
      textFont( avenirMediumSmall);
      //      text( nombreFinal[0].toUpperCase(), x, y+ cell/2 + alturaTexto/2 + 2);
      if(dividir){
      text( nombreFinal[0], x, y+ cell/2 + alturaTexto/2 + 2);
      text( nombreFinal[1], x, y+ cell/2 + alturaTexto + 2);
      }else{
        text( nombre, x, y+ cell/2 + alturaTexto/2 + 4);
      }

      // 4. We Specify the drawing properties according to their type
      color c = obtenerColor(positionsTipo[i]);

      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ BUTTON/INteraction
      // Button for the CELL
      //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
      //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   ( x )
      if ( hiceHit( x-(cell/2), y-(cell/2), x+(cell/2), y+(cell/2))) { 

        // 1. MOUSE OVER DRAW ATTRIBUTES
        fill(red(blanco), green(blanco), blue(blanco), 50); // OVER COLOR
        noStroke();
        rectMode(CENTER);
        rect(x, y, cell, cell);

        // 2. ACTION AFTER HIT
        if (mousePressed && fallOff == 0) {
          // A. We set the individual data
          individuoPos = positionsNo[contadorItems];
          individuoType = positionsTipo[contadorItems];
          individuoNombre = nombre;

          // B. We restart the filling function
          iniciarDetailViz();

          // C. We start the transition
          iniciarTransicion("detail view"); // Detail View

          fallOff = fallOffLimit;
        } 
        // 3. FALL OFF OPERATIONS highly important!
        fallOff -= 1;
        if (fallOff <= 0) fallOff = 0; // So we don't get negative values
      } 
      //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
      //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••

      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ c . Gettin' NGram Data


      // A. GRID RESOLUTION
      cellRes = 5; // Siempre impar !!! MOLTO IMPORTANTE!
      int mitadCellRes = ceil(cellRes/2);

      // B. Central Year
      int anoCentral = int(timeLineCenter);
      int anoInicial = int(timeLineCenter-floor((cellRes/2)));

      // C. We create and fill an array with years
      int [] nGramYears = new int [cellRes];
      for (int k = 0; k < cellRes; k++) { // 1st half
        nGramYears[k] = anoInicial+k;
        //println("Year ["+k+"] = "+nGramYears[k]);
      }

      // D. Data gather for each year NGram -----------------------------
      float [] ngrams = new float[ cellRes ];
      for (int k = 0; k < cellRes; k++) {

        // We will gather this NGram totals
        int nGramTotalesT = itemT.getCantidadNGrams();

        // We Calculate a position
        int deseo = floor(map( nGramYears[k], fecha1, fecha2, 0, nGramTotalesT-1));

        // FailSwitch gathering the data
        ngrams[k] = 1.0;
        if (deseo >= 0 && deseo < nGramTotalesT) {
          ngrams[k] = itemT.getNGramF(deseo);
        } else {
          ngrams[k] = 1.0;
        }
        //println(">> NGRAM ["+k+"] = "+ngrams[k]);
      }

      // E.  We will scale the Data
      for (int k = 0; k < cellRes; k++) {
        ngrams[k] = int(map(ngrams[k], 1, 0, 0, cellRes)); // Crucial step to draw the data
        //ngrams[k] = ceil(map(ngrams[k], 0, 1, 0, cellRes));
      }

      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ d . We get the color data


      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ e . Drawing finally!!!!!!!!!! (grid Tenori style)
      int totalesTenori = cellRes*cellRes; // Total number
      // We translate everything
      pushMatrix();
      translate(-cell/2 + (cell/cellRes)/2, -cell/2);

      int contadorTenori = 0;
      for (int k = 0; k < cellRes && contadorTenori < totalesTenori; k++ ) { //Columnas
        float xTenori = cell/cellRes * k ;

        for (int m = 0; m < cellRes && contadorTenori < totalesTenori; m++) { // Renglones
          float yTenori = cell/cellRes * m;

          // Tamano del circulo
          float radioTenori = cell/cellRes -1;

          // We ask and we draw then
          float posicionPregunta = map( m, 0, cellRes, cellRes, 0 );
          if (ngrams[k] >= posicionPregunta) {
            // We draw the circle
            fill(c);
            noStroke();
            shapeMode(CENTER);
            shape(Ellipse, x+xTenori, y+yTenori, radioTenori, radioTenori);
          }

          //Tenori objects counter
          contadorTenori++;
        }
      }
      popMatrix();

      // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ Each Cycle 2 fors end after -->
      contadorItems++;
    }
  }
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ MAP TITLE 
  // At the end, so we could use the cellRes variable
  // 1. We establish our title
  String tituloMap = "// "+cellRes+"-YEAR NGRAM";

  // 2. Where should we put this?
  float yTitle = c1y-10;
  float xTitle = c1x;
  // yTitle = c1y;


  //3. Let's put it mate, once and for all
  fill(red(blanco), green(blanco), blue(blanco), 210);
  textAlign(LEFT);
  textFont(avenirBlack, 9.5);
  text(tituloMap, xTitle, yTitle);

  // gridMapViz ends next ------->
}
