// ---------------------------------------------------- \\
// ------------- huge Map View ------------------------ \\
// ---------------------------------------------------- \\
// The first initial view over time
// 
Boolean estatico = true; // This means, show the full year or a zoom (i think this wasn't used at last)
//
// ----------------------------------------------------------------------------------------------------------------------------------------------
// 
// --------  ( coordenadas x,y cuadro, tipo "barras/bolas", grid/reticula, quienes="todos")
void hugeMap(float c1x, float c1y, float c2x, float c2y, String tipo, Boolean grid, String quienes, Boolean uniZoom, String leyenda, String tipoMapa) {
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ NYTimes or NGrams ????? 
  // VERY IMPORTANT! This few lines will establish the whole behaviour of our map
  // This lines allow the user to change the map on the go with an external variable as switch 
  Boolean NYTimesMode = true;
  Boolean NGramMode = false;
  if (hugeMapMode == "both") NGramMode = true; // We activate them all
  if (tipoMapa == "hugeMap" && hugeMapMode == "NGram") {
    NYTimesMode = false;
    NGramMode = true;
  }
  if (tipoMapa == "miniMap" && miniMapMode == "NGram") {
    NYTimesMode = false;
    NGramMode = true;
  }

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ WHO IS ACTIVATED?
  // 1. Who is activated
  //   We create a new object to store all of our data files (and for future Array Filling)
  SortingHat dataMatrix = new SortingHat(quienes);

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ TEST RECT AND CROSSES
  // 1. Rectangle test ( comment and uncomment as needed )
  shapeMode(CORNERS);
  fill(red(blanco), green(blanco), blue(blanco), 17);
  //shape(Rect, c1x, c1y, c2x, c2y);
  //2. Some crosses to mark the territory
  colocarCrucecillas( c1x, c1y, c2x, c2y );
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ MAP TITLE
  // 1. We establish our title
  String tituloMap = "// N.Y.TIMES MENTIONS";
  if (NGramMode) tituloMap = "// GOOGLE'S NGRAM COUNT";

  // 2. Where should we put this?
  float yTitle = c1y-40;
  float xTitle = c1x;

  //3. Let's put it mate, once and for all
  fill(red(blanco), green(blanco), blue(blanco), 210);
  textAlign(LEFT);
  textFont(avenirBlack, 9.5);
  text(tituloMap, xTitle, yTitle);
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ TIME FRAME SETTINGS
  // (very important, according to the zoom level) -------------------------------
  // 1. Standard values for #1 zoom
  float fechaMin = fecha1;
  float fechaMax = fecha2;
  //2. If zoom is greater than one, then we calculate according to our centered date
  if (zoom > 1) {
    // This is how many years normally fit
    float standarizedYears = 115; 
    // b. We create a range we'll add to the timeline Center Date to the right and left
    float yearsRange = standarizedYears/2; // We split it into two, casue there are two sides

    // 3. WE check if the UniZOom property is activated
    if (uniZoom) {
      yearsRange /= 1.1;
    } else {
      yearsRange /= zoom; // We divide it according to the zoom level
    }

    // c. We specify the new Min and Max Dates
    fechaMin = timeLineCenter-yearsRange;
    fechaMax = timeLineCenter+yearsRange;

    // d. If we are too into 2015, we will leave the zoom in 2015 in the far right side
    /* FAIL --> revisit this later
     if(fechaMax> 2014){
     fechaMin = 2015-(standarizedYears/zoom);
     fechaMax = 2015;
     }
     */
  }

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ Date display and helpers
  // 0. A height for all dates
  float fechasAlturaY = c1y-15;
  // 1. We display the TOP dates
  noStroke();
  fill(red(blanco), green(blanco), blue(blanco), 255);
  textFont(avenirBook, 15);
  if (tipoMapa == "miniMap") textFont(avenirMedium, 9);
  textAlign(LEFT);
  text(floor(fechaMin), c1x, fechasAlturaY); // MIN
  textAlign(CENTER);
  //
  float centroX = c1x+((c2x-c1x)/2); // 
  int anoCentralDato = floor(map( centroX, c1x, c2x, fechaMin, fechaMax ));
  textFont(avenirBook, 15);
  text(anoCentralDato, centroX, fechasAlturaY); // MIDDLE
  //
  textAlign(RIGHT);
  textFont(avenirBook, 15);
  if (tipoMapa == "miniMap") textFont(avenirMedium, 9);
  text(floor(fechaMax), c2x, fechasAlturaY); // MAX
  // 2. We display the current timeline state
  strokeWeight(0.6);
  stroke(blanco);
  float posTimeLineParticular = map( timeLineCenter, fechaMin, fechaMax, c1x, c2x );
  line( posTimeLineParticular, c1y, posTimeLineParticular, c2y );
  fill(blanco);
  shapeMode(CENTER);
  shape(Ellipse, posTimeLineParticular, c1y, 3, 3 );
  shape(Ellipse, posTimeLineParticular, c2y, 3, 3 );
  //  3. And now some interval dates
  int cantidadFechasMitad = 4;
  float intervalo = ((c2x-c1x)/2)/cantidadFechasMitad;
  for (int i = 1; i < cantidadFechasMitad; i++) { // LEFT SIDE
    // 3 - 1 We calculate the position and a date according to that position
    float fechaMiniX = c1x+( intervalo*i );
    int datoFechaMini = floor(map( fechaMiniX, c1x, c2x, fechaMin, fechaMax ));
    // 3 - 2 We draw the text
    textAlign(CENTER);
    textFont(avenirMedium, 9);
    fill(red(blanco), green(blanco), blue(blanco), 105);
    text( datoFechaMini, fechaMiniX, fechasAlturaY);
  }
  for (int i = 1; i < cantidadFechasMitad; i++) { // RIGHT SIDE
    // 3 - 1 We calculate the position and a date according to that position
    float fechaMiniX = centroX+( intervalo*i );
    int datoFechaMini = floor(map( fechaMiniX, c1x, c2x, fechaMin, fechaMax ));
    // 3 - 2 We draw the text
    textAlign(CENTER);
    textFont(avenirMedium, 9);
    fill(red(blanco), green(blanco), blue(blanco), 105);
    text( datoFechaMini, fechaMiniX, fechasAlturaY);
  }
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ Quantities
  // 1. We extract the total number from our datamatrix object
  int totales = dataMatrix.getTotales();
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ We calculate the height
  // 1. We calculate a height for each member and the current height
  float y = c1y;
  float interY = c2y-c1y;
  interY /= totales;

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ Alternation and Intel Filling
  // 1. The DataMatrix Object has already sorted everything for us
  String [] positionsTipo = dataMatrix.getPositionsTipo(); // We'll save the types here
  int [] positionsNo = dataMatrix.getPositionsNo(); // We'll save the numbers to each array position here

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ Drawing operations

  // 4. We proceed to draw everything! Finally!
  // -------------------------------------------------------------------------------- Legend variables 
  String leyendaNombre = "meh";
  float leyendaY = 0.0;
  color leyendaColor = color(255, 0, 0);
  // ------------------------------------------------------------------------------------------- -
  // ------------------------------------------------------------------------------------------- -
  for ( int i = 0; i < totales; i++ ) { // ------------------------------------------ FOR starts - (each item)
    // 0. 1st APPEARANCE
    Boolean primeraAparicion = true;
    // ----------------------------------------------------------------------------------------- -
    // A. Obtenemos nuestra altura actual
    float yT = y+(interY*i); // T de temporal

    // ----------------------------------------------------------------------------------------- -
    // B. We Draw the GRID lines
    int frecuencia = 15; // frecuencia con la que apareceran las l'ineas 15 original
    if (grid && i%frecuencia == (frecuencia-1)) { // nice % modulo
      // 
      strokeWeight(0.6);
      stroke(red(blanco), green(blanco), blue(blanco), 55);
      line( c1x, yT, c2x, yT);
    }
    // ----------------------------------------------------------------------------------------- -
    // C. --> We will put the names (if applicable) to the left
    if (leyenda == "conLeyenda" && deboTerminarPDF) {
      String nombreRenglon = "";
      // a. We get the name
      if (positionsTipo[i].equals("artists")) nombreRenglon = artistNombre[positionsNo[i]];
      if (positionsTipo[i].equals("writers")) nombreRenglon = writerNombre[positionsNo[i]];
      if (positionsTipo[i].equals("technicians")) nombreRenglon = technicianNombre[positionsNo[i]];
      if (positionsTipo[i].equals("musicians")) nombreRenglon = musicianNombre[positionsNo[i]];
      if (positionsTipo[i].equals("topics")) nombreRenglon = topicNombre[positionsNo[i]];
      // c. WE put it
      fill(red(blanco), green(blanco), blue(blanco), 120);
      textAlign(RIGHT);
      textFont(avenirMedium, 6);
      text(nombreRenglon, c1x -13, yT);
    }
    // ----------------------------------------------------------------------------------------- -
    // D.. We Specify the drawing properties according to their type
    color c = obtenerColor(positionsTipo[i]);
    fill(c);
    //println(">> We just specified drawing properties");
    // X. This funcion TEST TES TEST just a ball
    // shape( Ellipse, random(c1x, c2x), yT, 5, 5 );
    // ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ 
    // ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ 
    // D. Now, a tricky part. We will analyze each row for each item  ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲

    // 1 - Let's get how many items this item has
    int cantidad = 0;
    if (positionsTipo[i].equals("artists")) cantidad = artistInfo[positionsNo[i]].getCantidad();
    if (positionsTipo[i].equals("musicians")) cantidad = musicianInfo[positionsNo[i]].getCantidad();
    if (positionsTipo[i].equals("technicians")) cantidad = technicianInfo[positionsNo[i]].getCantidad();
    if (positionsTipo[i].equals("writers")) cantidad = writerInfo[positionsNo[i]].getCantidad();
    if (positionsTipo[i].equals("topics")) cantidad = topicInfo[positionsNo[i]].getCantidad();

    // 2 - We save everything into one Data item ---> itemT
    if (positionsTipo[i].equals("artists")) itemT = artistInfo[positionsNo[i]];
    if (positionsTipo[i].equals("musicians")) itemT = musicianInfo[positionsNo[i]];
    if (positionsTipo[i].equals("technicians")) itemT = technicianInfo[positionsNo[i]];
    if (positionsTipo[i].equals("writers")) itemT = writerInfo[positionsNo[i]];
    if (positionsTipo[i].equals("topics")) itemT = topicInfo[positionsNo[i]];

    // 3 - We'll calculate a slight displacement (to prevent overlapping) in an horizontal fashion
    float displacementWindow = (c2x-c1x)/(fechaMax-fechaMin); //This is the available data per Year
    float displacement = 0;
    if (positionsTipo[i].equals("artists")) displacement = (displacementWindow/5)*0;
    if (positionsTipo[i].equals("musicians")) displacement = (displacementWindow/5)*1;
    if (positionsTipo[i].equals("topics")) displacement = (displacementWindow/5)*2;
    if (positionsTipo[i].equals("technicians")) displacement = (displacementWindow/5)*3;
    if (positionsTipo[i].equals("writers")) displacement = (displacementWindow/5)*4;

    // 4 - Let's iterate through that data
    int fechaAnterior = 1800; // A random date that will never exist
    int fechaActual = 1900; // 
    int sumaElementosFecha = 0; // We will know how many elements we have

    //println(">> On to NYTimes operation, if activated");
    // 5 - New York Times Operations
    for (int j = 0; j < cantidad && NYTimesMode; j++) {

      // a. we get the year
      fechaActual = int(itemT.getAno(j));
      // b. we add the counter
      sumaElementosFecha++;
      // c. We ask if the year is different from the previous one (so we draw something)
      if (fechaActual != fechaAnterior) {
        // --> we specify a new date
        fechaAnterior = fechaActual;
        // --> we see if it is within the timeScale limit
        Boolean puedoDibujar = false;
        if ( fechaActual > fechaMin && fechaActual < fechaMax &&  sumaElementosFecha>1) puedoDibujar = true;
        // --> we specify the X position where to draw
        float xCuadrito = map( fechaActual, fechaMin, fechaMax, c1x, c2x );
        // -- > NYTimes mode
        // ********************************************************
        float tamano = 0.0; // WE declare this outside the next loop so we can access it on the 1st appearance cross
        if (NYTimesMode) { // --> NYTimesMode
          // --> Let's calculate a size for the Bar
          tamano = map( sumaElementosFecha, 0, 1000, 0.3, 1.4 );
          // --> Finally, we draw the bar
          shapeMode(CENTER);
          stroke(255);
          noStroke();
          //if (puedoDibujar) shape( Ellipse, xCuadrito + displacement, yT, tamano, tamano );
          if (puedoDibujar && tipo.equals("barras")) shape( Rect, xCuadrito + displacement, yT, displacementWindow*tamano, 4 );
          if (puedoDibujar && tipo.equals("bolas")) shape( Ellipse, xCuadrito + displacement, yT, displacementWindow*tamano/1, displacementWindow*tamano/1 );
        }
        // d. We do the operations for the 1st appearance ( x - - - )
        //
        if (primeraAparicion && sumaElementosFecha > 1) {
          // WE ask if it is proper to draw (yet again)
          // if ( fechaActual > fechaMin && fechaActual < fechaMax &&  sumaElementosFecha>1) puedoDibujar = true;
          // We draw the cross
          pushMatrix();
          float alturaPrimeraAparicion = 14;
          //translate( xCuadrito + displacement - (tamano/2) - 9, yT);
          translate( xCuadrito + displacement -9 -(displacementWindow*tamano/2), yT);
          fill(c);
          //strokeWeight(3);
          noStroke();
          if (puedoDibujar) {
            rotate(radians(45));
            shapeMode(CENTER);
            shape( Rect, 0, 0, 3, alturaPrimeraAparicion);
            rotate(radians(90));
            shape( Rect, 0, 0, 3, alturaPrimeraAparicion);
          }
          popMatrix();

          // We set the 1st appearance off
          primeraAparicion = false;
        }
        // --> we reset the elements per date
        sumaElementosFecha = 0;
      }
    }
    // 5b - New York times Mouse Helper
    if (mouseY < yT+(interY/2) && mouseY > yT-(interY/2) && mouseX > c1x && mouseX < c2x && NYTimesMode) {
      //fill(c);
      strokeWeight(1.5);
      stroke(red(blanco), green(blanco), blue(blanco), 124);
      line(c1x, yT, c2x, yT);
    }
    // ********************************************************
    // --> NGram Mode
    //println(">> On to NGram Mode if activated");
    if (NGramMode) {

      // i. Working variables -----------------------------
      int resolution = 77; // How many points our shape will have 150/10 helps and it's fast
      float [] puntosXT = new float[resolution]; // AN Array with all the points in the shape
      float puntoInicial = 0.0; // We record the first point, so we can close the shape
      float puntoFinal = 0.0; // same... but final
      float xTN = 0.0; //working variables
      float yTN = 0.0; 

      // ii. Display properties --------------------------
      //Boolean colocarCero = true;
      noStroke();
      //stroke(red(azul3), green(azul3), blue(azul3), 33);
      fill(red(c), green(c), blue(c), 100);

      // iii. Mouse goodies ------------------------------
      if (mouseY < yT+(interY/2) && mouseY > yT-(interY/2) && mouseX>c1x && mouseX < c2x) {
        fill(c);
        strokeWeight(1.5);
        stroke(red(blanco), green(blanco), blue(blanco), 244);
      }
      // iv. Shape Begins --------------------------------
      beginShape(); // We beginAShape
      for (int k = 0; k < resolution; k++) {
        // We check our X
        xTN = map( k, 0, resolution, c1x, c2x );

        // We get our Y
        float mappingFecha = map(xTN, c1x, c2x, fechaMin, fechaMax); // Transforming x value into dates
        if (mappingFecha <= fecha1 || mappingFecha >= fecha2) { // Let's see if we are not asking for null dates
          yTN = 1.0; // We put a zero value (which is 1.0 in Ngram mode)
          // yTN = 1.0;
        } else {
          int nGramTotales = itemT.getCantidadNGrams();
          int nGramDeseado = floor(map(mappingFecha, fecha1, fecha2, 0, nGramTotales ));
          //println(">>["+i+"] nGramTotales= "+nGramTotales+" VS deseo= "+nGramDeseado+" fecha= "+mappingFecha);
          float nGramT = itemT.getNGramF(nGramDeseado);
          //println(" >> NGRAM data: "+nGramT);
          // yTN = (1-nGramT); // Cause we are re-adjusting the values
          yTN = nGramT;
        }
        // We make the height operations
        float nuevaAltura = map( yTN, 1, 0, 0, -100 );
        yTN = yT+nuevaAltura; // We finally set the Y where it belongs

        // At last, we put a vertex
        vertex( xTN, yTN );
        // We check if this is the first point
        if (k == 0) puntoInicial = yTN;

        // We check if this is the last point
        if (k == resolution-1) puntoFinal =yTN;
      }
      // Closing shape operations
      vertex(c2x, yT); //Final
      vertex(c1x, yT); // Inicial
      endShape();
      // ---------------------------------------------- Shape for constructor ends  (NGram)
    } 

    // 6 - Text indicator/legend (Variable setting only)
    // a. We ask if they're on sight! On Sight! On Site!
    if (mouseY < yT+(interY/2) && mouseY > yT-(interY/2) && mouseX>c1x && mouseX < c2x) {

      // b. We get the topic name (I know this is a terrible way to do it)
      if (positionsTipo[i].equals("artists")) leyendaNombre = artistNombre[positionsNo[i]];
      if (positionsTipo[i].equals("writers")) leyendaNombre = writerNombre[positionsNo[i]];
      if (positionsTipo[i].equals("technicians")) leyendaNombre = technicianNombre[positionsNo[i]];
      if (positionsTipo[i].equals("musicians")) leyendaNombre = musicianNombre[positionsNo[i]];
      if (positionsTipo[i].equals("topics")) leyendaNombre = topicNombre[positionsNo[i]];

      // c. Y position and color Name
      leyendaY = yT;
      leyendaColor = c;
    }


    // ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲
    // ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲ ▲

    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
    // Button for the CELL •••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   (to detail view)
    if ( hiceHit(  c1x, yT-(interY/2) , c2x, yT+(interY/2) )) { 
      // 1. MOUSE OVER DRAW ATTRIBUTES
      // No mouse over for this button
      // 2. ACTION AFTER HIT
      if (mousePressed && fallOff == 0) {
        // A. We set the individual data
        individuoPos = positionsNo[i];
        individuoType = positionsTipo[i];
        individuoNombre = leyendaNombre;

        // B. We restart the filling function
        iniciarDetailViz();

        // C. We start the transition
        iniciarTransicion("detail view"); // Detail View

        fallOff = fallOffLimit;
      } 
      // 3. FALL OFF OPERATIONS highly important!
      fallOff -= 1;
      if (fallOff <= 0) fallOff = 0; // So we don't get negative values
    } 
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
    //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  } // <------ each item "for" ends

  //
  // 6 - Text indicator/legend (we draw it at the end so it would be on top, previous operations calculated before)

  if (mouseY < c2y && mouseY > c1y && mouseX>c1x && mouseX < c2x) {  
    // println(">> Printing text legend");  
    // i. This variables are declared up (nested inside each item's loop) --> 
    //String leyendaNombre | float leyendaY  | color  leyendaColor 

    // ii. Background - calculation and positions
    float caracteresNombre = leyendaNombre.length();
    float anchoRectBack = map(caracteresNombre, 0, 1, 1, 9);
    float trasladoText = 14;

    // iii. Background - draw
    fill(leyendaColor);
    noStroke();
    rectMode(CENTER);
    rect(mouseX, leyendaY-trasladoText, anchoRectBack, 17);

    // iv. The small cartoon globe thing
    beginShape();
    vertex(mouseX, leyendaY);
    vertex(mouseX-13, leyendaY-trasladoText);
    vertex(mouseX+13, leyendaY-trasladoText);
    vertex(mouseX, leyendaY);
    endShape();

    // v. We put the name 
    fill(azul3);
    textFont( avenirHeavy, 13 );
    text(leyendaNombre, mouseX, leyendaY-trasladoText+4);
  }

  // 
  // ------------------------------------------------------------------------------------------- -
  // ------------------------------------------------------------------------------------------- -
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████
  // HugeMap Ends next: --->
}
// --------------------------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------------------------------- Useful functions for this same map
// --------------------------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------------------------
void colocarCrucecillas(float x1, float y1, float x2, float y2) {

  // 1. We attempt to draw one for each point (so simple) (with a slight touch of animated effect)
  if (random(100)<99)colocarCruz(x1, y1);
  if (random(100)<99)colocarCruz(x1, y2);
  if (random(100)<99)colocarCruz(x2, y2);
  if (random(100)<99)colocarCruz(x2, y1);
}
// --------------------------------------------------------------------------------------------------------------------------------------
void colocarCruz(float x, float y) {
  // 1. Trasladamos el escenario
  pushMatrix();
  translate(x, y);

  // 2. A height for the line (L)
  float alturaL = 3;

  // 3. Cross properties
  strokeWeight(1);
  stroke(red(blanco), green(blanco), blue(blanco), 120);
  line( alturaL, 0, -alturaL, 0); // Horizontal
  line( 0, +alturaL, 0, -alturaL); // Horizontal

  // C'est tout!
  popMatrix();
}
