// ---------------------------------------------------- \\
// ------------- huge Map View ------------------------ \\
// ---------------------------------------------------- \\
// Just one data per individual (detail view)
// This global variables must be set 
int individuoPos = 1;
String individuoType = "technicians";
String individuoNombre = "Buckminster Fuller";
//color c = obtenerColor(positionsTipo[i]);
float detailNYTimesMaxMention = 0;
float friccionNYTimes = 7;
float friccionNgrams = 6;
// -------------------------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------------------------
void detailView(float c1x, float c1y, float c2x, float c2y) {
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ COORDINATES
  // 1. We establish our coordinates and center points from where to start drawing
  float cx = (c2x-c1x)/2; // The center
  float desplazamientoSuperior = 51;
  float cy = c2y -desplazamientoSuperior ; // El punto base sobre el cual empezaremos hacia arriba, japanese style!


  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ BACKGROUND & color data
  // 1. Bckground drawing
  noStroke();
  fill(blanco);
  shapeMode(CORNERS);
  shape(Rect, c1x, c1y, c2x, c2y);
  color c = obtenerColor( individuoType );

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ GRAPH Baseline and properties
  // 1. Viz properties
  float anchoGrafica = 650;
  float alturaGrafica = 160; // This will be the measure of increments
  // 2. Baseline
  stroke(red(c), green(c), blue(c), 180);
  strokeWeight(3);
  strokeCap(SQUARE);
  line( cx-(anchoGrafica/2), cy, cx+(anchoGrafica/2), cy );

  // 3. We set the dates
  fill(red(azul3), green(azul3), blue(azul3), 255);
  textFont(avenirRegular, 11);
  textAlign (LEFT);
  text(int(fecha1), cx-(anchoGrafica/2), cy+19);
  textAlign (RIGHT);
  text(int(fecha2), cx+(anchoGrafica/2), cy+19);

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ DATA LOCAL OBJECT
  // 1. This object will hold all of the data
  // We save everything into one Data item ---> detailItem
  if (individuoType.equals("artists")) detailItem = artistInfo[individuoPos];
  if (individuoType.equals("musicians")) detailItem = musicianInfo[individuoPos];
  if (individuoType.equals("technicians")) detailItem = technicianInfo[individuoPos];
  if (individuoType.equals("writers")) detailItem = writerInfo[individuoPos];
  if (individuoType.equals("topics")) detailItem = topicInfo[individuoPos];

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ NGRAM GRAPH 
  // 1. Crucial variables for sketch control
  float NGramMaximo = 1.0; // To know the biggest one, we already know the lowest 1.0 = 0
  float NGramAnoActual = 0.0; // SO we know what to draw

  // 2. We will re-fill/get the detail data
  for (int i = 0; i < detailRes; i++) {
    // a. which NGram do we want?
    int cantidadNGrams = detailItem.getCantidadNGrams();
    int deseo = int(map( i, 0, detailRes, 0, cantidadNGrams ));
    if (deseo >= cantidadNGrams || deseo <= 0) deseo = 0; // (FAIL SWITCH)

    // b. what is the value of that NGram
    detailAlturasD[i] = detailItem.getNGramF( deseo );

    // c. We see if it is the biggest (or lowest in practice) so far
    if (detailAlturasD[i] < NGramMaximo) NGramMaximo = detailAlturasD[i];

    // d. We get the current year data
    int fechaLocal = int(map(i, 0, detailRes, fecha1, fecha2));
    if (fechaLocal == int(timeLineCenter)) NGramAnoActual = detailAlturasD[i];

    // e. We calculate the actual positions using friction
    detailAlturas[i] = calcularFriccion(detailAlturas[i], detailAlturasD[i], friccionNgrams);
  }

  // 3. We draw the graph finally!!!!
  pushMatrix();
  translate( cx-(anchoGrafica/2), cy ); // We translate into the origins
  noStroke();
  fill(red(c), green(c), blue(c), 190);
  beginShape();
  vertex(0, 0); // First vertex
  for (int i = 0; i < detailRes; i++) {
    // a. Calculamos la x del vertex
    float xNgram = map( i, 0, detailRes, 0, anchoGrafica );

    // B. ahora la Y del vertex (inverted, since low in Ngrams means 1, and high means 0)
    float yNgram = map( detailAlturas[i], 0, 1, 1, 0 ); // This is just a percentage
    yNgram =  alturaGrafica * yNgram;// This is the actual height
    yNgram *= -1;// Minus -1 since we don't want it to be flipped

    // C. Colocamos el vertex
    vertex(xNgram, yNgram);
  }
  vertex(anchoGrafica, 0);
  vertex(0, 0); // Last vertex to Properly close the Shape
  endShape();


  //4. Now we will put our little helper friend, our buddy
  //4-1. X Position
  float detailNGramCircleX = map( timeLineCenter, fecha1, fecha2, 0, anchoGrafica );

  // 4-2. Y Position ( a little bit more tricky)
  // 4-2 a. which NGram do we want?
  int cantidadNGrams = detailItem.getCantidadNGrams();
  int deseo = int(map( timeLineCenter, fecha1, fecha2, 0, cantidadNGrams ));
  if (deseo >= cantidadNGrams || deseo <= 0) deseo = 0; // (FAIL SWITCH)

  // 4-2 b. We set the new height
  float detailNGramCircleY = detailItem.getNGramF(deseo);

  // 4-2 c. We adjust the height
  detailNGramCircleY = map(detailNGramCircleY, 1, 0, 0, 1); // This are just valies from 0 to 1, now correctly ordered
  detailNGramCircleY *= alturaGrafica; // this is a multiplication for the height, a percentage
  detailNGramCircleY *= -1; // we invert them to be down to up

  // 4-3 We will draw him at last
  strokeWeight(2);
  fill(red(azul3), green(azul3), blue(azul3), 220);
  noStroke();
  ellipseMode(CENTER);
  ellipse(detailNGramCircleX, detailNGramCircleY-1, 7, 7);
  strokeWeight(1);
  stroke(red(azul3), green(azul3), blue(azul3), 20);
  line(detailNGramCircleX, detailNGramCircleY-1, detailNGramCircleX, detailNGramCircleY-height);

  popMatrix();

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ NYTimes graph
  // 1. We start cyclin' thru the data and drawing on the go 
  // a. Drawing properties
  pushMatrix();
  translate( cx-(anchoGrafica/2), cy ); // We translate into the origins
  noStroke();
  fill(red(azul3), green(azul3), blue(azul3), 90);
  beginShape();
  vertex(0, 0);

  // b. Let's calculate friction values
  for (int i = 0; i < (fecha2-fecha1); i++ ) {
    detailMentions[i] = calcularFriccion(detailMentions[i], detailMentionsD[i], friccionNYTimes);
  }

  // c. Actual iteration
  for (int i = 0; i < NYTimesRes; i++) {

    // d. We calculate the X position
    float nyTimesX = map(i, 0, NYTimesRes, 0, anchoGrafica);

    // e. We get the desired year
    int anoDeseado = int(map( i, 0, NYTimesRes, fecha1, fecha2));
    anoDeseado -= fecha1;
    if (anoDeseado < 0 || anoDeseado >= detailMentions.length) anoDeseado = 0;

    // f. we get the data for that desired year
    float nyTimesY = detailMentions[anoDeseado];
    nyTimesY = map(nyTimesY, 0, detailNYTimesMaxMention, 0, alturaGrafica);
    nyTimesY *= -1;

    // g. we add a vertex
    curveVertex( nyTimesX, nyTimesY );
    //vertex( nyTimesX, nyTimesY );
  }

  vertex(anchoGrafica, 0);
  vertex(0, 0);
  endShape();
  popMatrix();

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ TYPE: title and year
  // 1. We set the height for the Year
  float yearHeight = cy - alturaGrafica - 55;

  // 2. We put the year
  fill(red(azul3), green(azul3), blue(azul3), 40);
  textFont(avenirBookYear, 34);
  textAlign(CENTER);
  text(int(timeLineCenter), cx, yearHeight);

  // 3. We set the height for the Main Title
  float nameHeight = yearHeight -55;

  // 4. We put the title
  fill(red(c), green(c), blue(c), 180);
  textFont(avenirMediumBig, 37);
  textAlign(CENTER);
  text( individuoNombre, cx, nameHeight );


  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ NYTimes mention legend
  // 1. We set the bar displacement and size
  int barrasTotales = 6;
  int anchoBarra = 25;
  int alturaBarras = 25;
  float alturaBarra = alturaBarras/barrasTotales;
  float xBarra = cx-70;
  float yBarra = yearHeight;

  // 2. For this, how many mentions compared to the total?
  int fechaDeseada =  int(timeLineCenter-fecha1);
  if (fechaDeseada < 0 || fechaDeseada >= (fecha2-fecha1))fechaDeseada = 0; // (FAIL SWITCH)
  float currentMeasurement = detailMentions[ fechaDeseada];
  int howManyBars = int(map(currentMeasurement, 0, detailNYTimesMaxMention, 0, barrasTotales+1));

  // 3. We draw the bars
  for (int i = 0; i < barrasTotales; i++) {

    // a. The height
    float yBarraT = yBarra -(i*alturaBarra);

    // b. color options
    noStroke();
    fill(red(azul3), green(azul3), blue(azul3), 30);
    if (i < howManyBars) fill(c);

    // b. We draw the bar
    shapeMode(CENTER);
    shape(Rect, xBarra, yBarraT -1.5, anchoBarra, alturaBarra - 1);
  }

  // 4. LEGEND
  // 4-1 We set the coordinates
  float xNyTimesMentionsLegend = xBarra-33;
  // 4-2 We draw the subtitle
  fill(red(azul3), green(azul3), blue(azul3), 150);
  textAlign(RIGHT);
  textFont(avenirHeavy, 10);
  text( "NYTIMES MENTIONS FOR THIS YEAR", xNyTimesMentionsLegend, yearHeight-3);

  String texto = int(currentMeasurement)+" / "+cantidadMentionsDeEsteIndividuo;
  fill(c);
  textAlign(RIGHT);
  text(texto, xNyTimesMentionsLegend, yearHeight-15);

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ NGram Mentions legend
  // 1. We set the Circle displacement and size
  float xNgramCircle = cx+70;
  float tamanoNgram = 31;
  float yNgramCircle = yearHeight -12 -1;

  // 2. We draw the central circle
  fill(red(azul3), green(azul3), blue(azul3), 120);
  noStroke();
  shapeMode(CENTER);
  shape(Ellipse, xNgramCircle, yNgramCircle, 5, 5);

  // 3. Full circle
  fill(red(azul3), green(azul3), blue(azul3), 10);
  shape(Ellipse, xNgramCircle, yNgramCircle, tamanoNgram, tamanoNgram);

  // 4. Indicator circle, the most important one
  // 4 - 1 We calculate the size
  float diametroNgram = detailItem.getNGramF(deseo);
  diametroNgram = map(diametroNgram, 1, 0, 0, 1); // We flip the values
  //float interesVerdadero = map(diametroNgram, 0, 1, 0, 100); // To put later in the percentages
  diametroNgram = map(diametroNgram, 0, 1, tamanoNgram/5, tamanoNgram);

  float interesVerdadero = detailItem.getNGramF(deseo);
  interesVerdadero = map(interesVerdadero, NGramMaximo, 1, 0, 100);
  interesVerdadero = map(interesVerdadero, 0, 100, 100, 0);

  // 4 - 2 We draw the circle
  fill(red(c), green(c), blue(c), 180);
  shape(Ellipse, xNgramCircle, yNgramCircle, diametroNgram, diametroNgram);

  // 5. And now, the legends
  // 5 - 1 coordinates
  float xNGramLegend = xNgramCircle+33;

  // 5 - 1 subtitle
  fill(red(azul3), green(azul3), blue(azul3), 150);
  textAlign(LEFT);
  textFont(avenirHeavy, 10);
  text( "NGRAM INTEREST", xNGramLegend, yearHeight-3);

  // 5 - 1 title
  String textoNgramInterest = int(interesVerdadero)+"%";
  fill(c);
  textAlign(LEFT);
  text(textoNgramInterest, xNGramLegend, yearHeight-15);

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████  AND NOW.. THE ROWS!!!!!
  // 1. We establish the row coordinates
  float rowY = nameHeight -60;
  float rowHeight = 30;

  // 2. We will ask if we have any mentions for this year
  int cantidadSubItems = detailItem.getCantidad();

  // 3. Now we will cycle through the years and put something if it fits and if we have something tho
  int renglonesActuales = 0;
  float currentHeight = 100; // Just a random number
  for (int i = 0; i < cantidadSubItems && currentHeight > 50; i++) {

    // a. We check if we are in the current year
    if ( int(detailItem.getAno(i)) == int(timeLineCenter)) {

      // b. We establish a Height
      currentHeight = rowY-( rowHeight*renglonesActuales );

      // xx. Let's draw a rectange (TEST)
      rectMode(CORNERS);
      stroke(0, 0, 0, 50);
      noFill();
      //rect(0, currentHeight-(rowHeight/2), cx, currentHeight+(rowHeight/2));

      // c. We display the title
      fill(azul3);
      textAlign(RIGHT);
      textFont(avenirRegular, 13);
      text( '"'+detailItem.getTitulo(i)+'"', cx - 7, currentHeight+3.5 );

      // d. We display the URL
      String urlItem = detailItem.getUrl(i);
      fill(red(azul3), green(azul3), blue(azul3), 40);
      textAlign(LEFT);
      textFont(avenirRegular, 13);
      text( urlItem, cx + 7, currentHeight+3.5 );


      // e. Le hacemos un boton
      //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
      //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   OPEN NYTIMES URL
      if ( hiceHit( 0, currentHeight-(rowHeight/2), width, currentHeight+(rowHeight/2) )) { 

        // 1. MOUSE OVER DRAW ATTRIBUTES
        fill(red(azul3), green(azul3), blue(azul3), 10); // OVER COLOR
        noStroke(); 
        rect(0, currentHeight-(rowHeight/2), width, currentHeight+(rowHeight/2));

        // 2. ACTION AFTER HIT
        if (mousePressed && fallOff == 0) {

          open(urlItem);

          fallOff = fallOffLimit;
        } 
        // 3. FALL OFF OPERATIONS (ignore)
        // FallOff Operations, highly important!
        fallOff -= 1;
        if (fallOff <= 0) fallOff = 0; // So we don't get negative values
      } // <-- Button iF
      //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
      //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••



      // x. We increase the number of items placed
      renglonesActuales++;
    }
  }
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████  BACK Button
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   OPEN NYTIMES URL  
  //1. We specify some coordinates
  float anchoBack = 110;
  float backx1 = cx-(anchoBack/2);
  float backy1 = cy +16;
  float backx2 = cx+(anchoBack/2);
  float backy2 = cy+20 +16;
  /*
  // TEST RECTANGLE
   stroke(azul3);
   noFill();
   rectMode(CORNERS);
   rect(backx1, backy1, backx2, backy2);
   */
  // 2. We specify a color
  fill(azul3); // Default color
  if ( hiceHit( backx1, backy1, backx2, backy2 )) { 

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(c); // OVER COLOR

    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {
      //We go back to our previous state
      iniciarTransicion(escenarioAnterior); 

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  // We draw the text
  textFont(avenirBlack, 9);
  textAlign(CENTER);
  text("<< GO BACK", cx, cy+28);
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████ 
  //
  // detailView viz ends nxt ---->
}



// -------------------------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------------------------
int detailRes = 80; // How smooth the NGram graph will be (mountain style) 280 works
int NYTimesRes = 80; // How smooth the NYTimes grpah will be (line style)
float [] detailAlturas, detailAlturasD; // This is mostly for friction operations
float [] detailMentions, detailMentionsD; // We still use friction for this one, why not? It's all about experience
int cantidadMentionsDeEsteIndividuo; // Total mentions for this specific item
void iniciarDetailViz() {
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ a. Array Temporary Filling
  // Mostly this values are for the animated Graph making 
  // 1. We create temporary array/values
  float [] detailAlturasT = new float [detailRes];
  float [] detailAlturasDT = new float [detailRes];
  // 2. WE fill them
  for (int i = 0; i < detailRes; i++) {
    detailAlturasT[i] = 1.0;
    detailAlturasDT[i] = 0.0;
  }
  // 3. We equal the Temporary Arrays to the final ones
  detailAlturasD = detailAlturasDT;
  detailAlturas = detailAlturasT;

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ b. Now we will fill them with the NYTimes Data
  // 1. MENTIONS PER YEAR First we will calculate with an array as big as time
  int cantidadMentions = int(fecha2-fecha1);
  //println("Estamos buscando a: "+individuoPos+" | type: "+individuoType);
  //println("NOMBRE: "+technicianNombre[individuoPos]);

  // 2. Now we will start the arrays
  float [] detailMentionsT = new float[cantidadMentions];
  float [] detailMentionsDT = new float[cantidadMentions];

  // 3. We will fill it with zeros
  for (int i = 0; i < cantidadMentions; i++) {
    detailMentionsT[i] = 0.0;
    detailMentionsDT[i] = 0.0;
  }

  // 4. A temporary data item
  // We save everything into one Data item ---> detailItem
  if (individuoType.equals("artists")) detailItem = artistInfo[individuoPos];
  if (individuoType.equals("musicians")) detailItem = musicianInfo[individuoPos];
  if (individuoType.equals("technicians")) detailItem = technicianInfo[individuoPos];
  if (individuoType.equals("writers")) detailItem = writerInfo[individuoPos];
  if (individuoType.equals("topics")) detailItem = topicInfo[individuoPos];

  //5. An now we will add whatever we found there
  cantidadMentionsDeEsteIndividuo = detailItem.getCantidad();
  detailNYTimesMaxMention = 0; // This is to give us a sense of scale
  for (int i = 0; i < cantidadMentionsDeEsteIndividuo; i++) {
    // a. Obtenemos un year
    int anoObtenido = int(detailItem.getAno(i));

    // b. Conversion de posicion
    anoObtenido -= fecha1;
    if (anoObtenido < 0 || anoObtenido >=(fecha2-fecha1)) anoObtenido = 0;

    // c. Lo sumamos al valor anterior
    println("QUEREMOS EL ANO: "+anoObtenido+" cuando detmentionsdt lenght = "+detailMentionsDT.length);
    detailMentionsDT[anoObtenido]++;

    // d. we get the top number of mentions per year
    if (detailMentionsDT[anoObtenido] > detailNYTimesMaxMention) detailNYTimesMaxMention = detailMentionsDT[anoObtenido] ;
  }

  //println("Maxima mention de Fuller"+detailNYTimesMaxMention);
  // 6. Igualamos los arreglos
  detailMentionsD = detailMentionsDT;
  detailMentions = detailMentionsT;
}
// ------------------------------------------------------------------------------------------------------------------------------------
