import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.pdf.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class rise_and_fall__17 extends PApplet {


// ************************************************************************************************************* \\
// ************************************************************************************************************* \\
// *************************************** r \u00b7 i \u00b7 s \u00b7 e \u00b7 \u00b7 & \u00b7 \u00b7 f \u00b7 a \u00b7 l \u00b7 l \u00b7****************************** \\
// ************************************************************************************************************* \\
// ************************************************************************************************************* \\
//                                                                                                               \\
// An electronic art history exploration by JM Escalante | MAT-UCSB |  realitat.com | jmescalante@realitat.com   \\
//                                                                                                               \\
// ************************************************************************************************************* \\
/*
Version History
 
 01 - Early setup and data load
 02 - We load the NGram data as Numbers
 03 - First dataViz attempt
 04 - Too many squares, second attempt with PShape (too many shapes being drawn at the same time, issue not yet resolved, paused)
 04 - Zooming and main timeline operations implemented | first fonts loaded too
 05 - Huge Map Data Viz Working (needs more tunning tho) | Terrible mistake of not including musicians
 06 - NGram early tests
 07 - NGram visual style solved!
 08 - Texts over Mouse implemented and HugeMaps with different types of data (much needed for performance) huge Data Viz highly modified here
 09 - The alternate filling of the Array now belongs to a different function and DataMatrix CLASS (which does all of the sorting)
 10 - The gridMap (Tenori-on homage)  now works | Play function with spacebar implemented | PDF Record
 11 - TOP Yearly terms loaded | Central year type in the middle 
 12 - Yearly counts now finally visualized as a separate dataViz() | BIG step ! 
 13 - Text now appear in the huge graphic in the PDF | Crosses in corners | Fixed a problem of sketh crash due to invalid date | click to google button!
 Close button | Graph Titles | huge Map now supports huge and mini versions with the ability to change NYTimes or NGram from the outside
 Titles on each graph now implemented | animated crosses 
 14 - Scenarios motor implemented (not yet the buttons to acces it, just via keyboard)
 15 - Individual scenario (took one entire day to code) now working in all vizMap types.
 16 - Back button in detail view | Main Navigation | type improvements | startCover 
 17 - Low Resolution Modes Corrected
 
 */
// * Switches and other variables (data variables in "d_a_t_a" tab)
Boolean frameFeedback = true;
Boolean fullscreen = true;
int ancho = 1280;
int alto = 720;

// *
// - - Color Definitions
int amarillo =  color(255, 190, 15);// Yellow
int naranja = color(255, 96, 10);// Pure orange
int rojo = color(255, 10, 10); // Rojo medio anaranjado
int blanco = color(230, 246, 255); // Azul super claro, casi blanco
int azul1 =  color(125, 223, 255);// Clarito
int azul2 = color(0, 162, 255); // Oscuro (semi)
int azul3 = color(26, 32, 39); // SUPER OSCURO (fondo)
// -------------------------------------------------------------------------------------------------------------------

public void setup() {
  // 1. Display properties
  sizeProperties();  
  // 2. We load the data (crucial step)
  loadData();
  // 3. We create the shapes for PShapes
  loadShapes();
  // 4. Font operations
  loadFonts();
  // 5. Starting cover values
  startCover();
}


// ------------------------------------------------------------------------------------------------------------------
//
public void draw() { // NEEDS TO BE CLEANED UP!!!
  if (deboIniciarPDF) iniciarPDF();
  // Fondo
  background(azul3);

  // We show the scenarios
  mostrarEscenarios();

  // Zooming and Paning operations
  zooming();

  // WE draw the closing button interface
  if (!deboTerminarPDF) closeButton(); // ( X )

  // We check if the project is playing currently
  if (enReproduccion) playFunction();

  // 
  if (deboTerminarPDF) terminarPDF();


  // Kamindustries CEO's trick
  if (frameCount%2==0 && frameFeedback) {
    fill(blanco);
    if (escenarioActual == "detail view") fill(azul3);
    textFont(avenirMediumSmall, 8);
    //text(frameRate, width - 45, 19);
  }
  //
  if (enTransicion) ejecutarTransicion();
}
// ----------------------------------------------------------- \\
// -------------  C O V E R ----------------------------------- \\
// ------------------------------------------------------------ \\

// The cherry at the top of the cake, our cover in motion
float alphaLetrasCover = 0;
int sentidoAlphaLetrasCover = 1;
public void cover() {

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 WIDESCREEN BARS
  // 1. We show the waves
  for (int i = 0; i < cantidadOlas; i++) {
    fondo[i].mostrar();
  }

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 WIDESCREEN BARS
  // 1. TOP Bar
  noStroke();
  fill(azul3);
  rectMode(CORNER);
  rect(0, 0, width, height/4);

  // 2. Bottom bar
  rectMode(CORNER);
  rect(0, height/4 *3, width, height/4);


  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 MAIN TITLE
  // 1. We put the title
  /*
  // Test full text
   fill(blanco);
   textFont(avenirRegular, 23);
   textAlign(CENTER);
   String tituloPrincipal = "N \u00b7 E \u00b7 W     M \u00b7 E \u00b7 D \u00b7 I \u00b7 A     R \u00b7 I \u00b7 S \u00b7 E     A \u00b7 N \u00b7 D     F \u00b7 A \u00b7 L \u00b7 L";
   text(tituloPrincipal, width/2, height/2);
   
   */
  textFont(avenirNextUltraLight, 23);
  fill(blanco);
  textAlign(RIGHT);
  text("N \u00b7 E \u00b7 W     M \u00b7 E \u00b7 D \u00b7 I \u00b7 A", width/2 -60, height/2);
  textFont(avenirNextMedium, 23);
  textAlign(LEFT);
  text("R \u00b7 I \u00b7 S \u00b7 E     A \u00b7 N \u00b7 D     F \u00b7 A \u00b7 L \u00b7 L", width/2 -29, height/2);


  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 LEGEND CLICK ANYWHERE and Credits
  // 1. We put the text
  fill(red(blanco), green(blanco), blue(blanco), alphaLetrasCover);
  textFont(avenirNextMedium, 13);
  textAlign(CENTER);
  text(" > click to start < ", width/2, height-90); 

  // 2. We calculate the alpha
  alphaLetrasCover += 3.6f * sentidoAlphaLetrasCover;
  if (alphaLetrasCover > 255) sentidoAlphaLetrasCover = -1;
  if (alphaLetrasCover < 0) sentidoAlphaLetrasCover = 1;
  
  // 3. 
  fill(red(blanco), green(blanco), blue(blanco), 60);
  textFont(avenirBook, 12);
  textAlign(CENTER);
  String credits = "Idea and code by JM Escalante | Media Arts & Technology - UCSB | MMXV";
  text(credits, width/2, height-35);

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 HUGE INVISIBLE BUTTON!!!!
  // 1. We just put the button and that's it
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   ( x )
  if ( hiceHit( 0, 0, width, height )) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    // stroke(blanco); // full Hover color

    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      // After the cover we start with the minority report view
      iniciarTransicion("minority report");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  // Cover scenario ends next --->
}

// -----------------------------------------------------------------------------------------------------------------------

// -----------------------------------------------------------------------------------------------------------------------
// Here we will start the class
int cantidadOlas = 30;
Ola [] fondo;
public void startCover() {

  // 1. Temporary Array
  Ola [] fondoT = new Ola[cantidadOlas];

  //2. We fill it
  for (int i = 0; i < cantidadOlas; i++) {
    fondoT[i] = new Ola();
  }

  // 3. Lo igualamos
  fondo = fondoT;
}

// --------------------------------------------------------------------------------------------------------------------
// A special class11
class Ola {
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 
  // Properties
  float elementosMin = 4; //3 worked
  float elementosMax = 29; // 23 worked
  float ruidoMin = 0.000002f;
  float ruidoMax = 0.0024f;
  float alturaMax = 400;
  float alturaMin = 350;
  float altura;
  float yGlobal;
  float alphaGlobal, alphaGlobalR, alphaGlobalV;
  int elementos;
  float [] posY, ruidosY, varsY; // The positions that will change
  int c;
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 
  // Constructors
  Ola() {
    this.elementos = PApplet.parseInt(random( elementosMin, elementosMax ));
    this.altura = random(alturaMin, alturaMax);
    this.yGlobal = random(height/4, height/4*3 +80);
    this.alphaGlobalR = random(0.00003f,0.005f);
    // We start the Arrays
    posY = new float[this.elementos];
    ruidosY = new float[this.elementos];
    varsY = new float[this.elementos];
    // We fill them
    for (int i = 0; i < this.elementos; i++) {
      posY[i] = 0.0f; // Doesn't matter
      ruidosY[i] = random(ruidoMin, ruidoMax); // Different noises
      varsY[i] = random(ruidosY[i])*random(100,1000); // So they start at different times
    }
    String [] tipos = {
      "musicians", "technicians", "topics", "writers", "artists", "technicians"
    };
    c = obtenerColor(tipos[floor(random(tipos.length))]); // A random color
  }

  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 
  // Getters/Setters

  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 
  // Methods
  public void mostrar() {
    // We calculate the positions
    calcularPosiciones();
    
    // We calculate global alpha animated
    alphaGlobalV += alphaGlobalR;
    alphaGlobal = noise(alphaGlobalV);

    // We begin creating the shape
    beginShape();
    fill(red(c), green(c), blue(c), 100 *alphaGlobal);
    noStroke();
    // Strating and ending X positions
    float inicioX = 0 -150; // Where does the graphic starts
    float finX = width+150;
    // Cycle for the vertex
    vertex( inicioX, 0 );
    for ( int i = 0; i < elementos; i++ ) {

      // We calculate the Y
      float y = yGlobal + map( posY[i], 0, 1, 0, -altura );

      // We calculate the X
      float x = map( i, 0, elementos, inicioX, finX );

      // We put a vertex
      //vertex( x, y );
      vertex( x, y );
    }
    vertex( finX, yGlobal );
    vertex( inicioX, yGlobal );
    endShape();
  }
  // 
  public void calcularPosiciones() {
    // The usual Perlin Noise clich'e operations
    for ( int i = 0; i < elementos; i++ ) {
      varsY[i] += ruidosY[i];
      posY[i] = noise(varsY[i] );
    }
  }
}
// --------------------------------------------------- \\
// ------------- data loading ------------------------ \\
// --------------------------------------------------- \\
// This tab relates loads all of the data!!!!!!!!!!!!!!!!
//
// * Working variables
int topics, writers, technicians, artists, musicians; // totales
String [] artistNombre, technicianNombre, writerNombre, topicNombre, musicianNombre; // Names

// * Complex detailed data files --->
Data [] artistInfo, technicianInfo, writerInfo, topicInfo, musicianInfo; 
YearlyData [] artistInfoTopNYT, technicianInfoTopNYT, writerInfoTopNYT, topicInfoTopNYT, musicianInfoTopNYT;
YearlyData [] artistInfoTopNGram, technicianInfoTopNGram, writerInfoTopNGram, topicInfoTopNGram, musicianInfoTopNGram;
Data itemT, detailItem; // We'll use this item to iterate individually while displaying data
// *
// ------------------------------------------------------------------------------------------------------------------------
public void loadData() {
  println(">> DATA loading starts --- > ");

  // 1. First we load the index data (Nombre)cap
  artistNombre =  loadStrings("DATA/INDICES/artists.txt");
  technicianNombre =  loadStrings("DATA/INDICES/technicians.txt");
  writerNombre =  loadStrings("DATA/INDICES/writers.txt");
  topicNombre =  loadStrings("DATA/INDICES/topics.txt");
  musicianNombre =  loadStrings("DATA/INDICES/musicians.txt");

  // 2. We specify the quantities
  artists = artistNombre.length;
  technicians = technicianNombre.length;
  writers = writerNombre.length;
  topics = topicNombre.length;
  musicians = musicianNombre.length;
  println(">> TOTALES >> artists("+artists+")  technicians("+technicians+")  writers("+writers+")  topics("+topics+")");
  println(" >> ------------------------------------------------------------------------------------------------------");

  // XX. We load the Yearly Data
  cargarYearlyData();

  // 3. We start the Main Arrays
  artistInfo = new Data[ artists ];
  technicianInfo = new Data[ technicians ];
  writerInfo = new Data [ writers ];
  topicInfo = new Data [ topics ];
  musicianInfo = new Data [ topics ];

  // 3. We load each data for each member of the name's array, and put it into the INFO Data container(Ano, Url, Titulo)
  for (int i = 0; i < artists; i++) { // ARTIST

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"artists/"+artistNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"artists/"+artistNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"artists/"+artistNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"artists/"+artistNombre[i]+".txt"); // NYTimes yearly tops
    // 2. We create a new SubClass 
    artistInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "artists" );

    // 3. Feedback
    if (i == 0) println(">> First Artist["+i+"]: "+ artistNombre[i]+" ("+artistInfo[i].getAno(0)+") -> "+artistInfo[i].getTitulo(0));
  }
  for (int i = 0; i < writers; i++) { // WRITER

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"writers/"+writerNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"writers/"+writerNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"writers/"+writerNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"writers/"+writerNombre[i]+".txt"); // NYTimes yearly tops

    // 2. We create a new SubClass 
    writerInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "writers" );

    // 3. Feedback
    if (i == 0) println(">> First Writer["+i+"]: "+ writerNombre[i]+" ("+writerInfo[i].getAno(0)+") -> "+writerInfo[i].getTitulo(0));
  }
  for (int i = 0; i < technicians; i++) { // TECHNICIAN

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"technicians/"+technicianNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"technicians/"+technicianNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"technicians/"+technicianNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"technicians/"+technicianNombre[i]+".txt"); // NYTimes yearly tops

    // 2. We create a new SubClass 
    technicianInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "technicians" );

    // 3. Feedback
    if (i == 0) println(">> First Tech["+i+"]: "+ technicianNombre[i]+" ("+technicianInfo[i].getAno(0)+") -> "+technicianInfo[i].getTitulo(0));
  }
  for (int i = 0; i < topics; i++) { // TOPIC

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"topics/"+topicNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"topics/"+topicNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"topics/"+topicNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"topics/"+topicNombre[i]+".txt"); // NYTimes yearly tops

    // 2. We create a new SubClass 
    topicInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "topics" );

    // 3. Feedback
    if (i == 0) println(">> First TOPIC["+i+"]: "+ topicNombre[i]+" ("+topicInfo[i].getAno(0)+") -> "+topicInfo[i].getTitulo(0));
  }
  for (int i = 0; i < musicians; i++) { // MUSICIAN

    // 1. We load the array in a temporal file
    String [] anoT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_anos.txt"); // ANO
    String [] urlT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_urls.txt"); // URL
    String [] tituloT = loadStrings("DATA/SAVED_Searches/"+"musicians/"+musicianNombre[i]+"_titulos.txt"); // TITULO
    String [] nGramsT = loadStrings("DATA/NGRAMS_points/"+"musicians/"+musicianNombre[i]+".txt"); // NGrams
    //String [] yearlyNGramsT = loadStrings("DATA/NGRAMS_yearlyTops/"+"musicians/"+musicianNombre[i]+".txt"); // NGrams yearly tops
    //String [] yearlyNYTimesT = loadStrings("DATA/NYTimes_yearlyTops/"+"musicians/"+musicianNombre[i]+".txt"); // NYTimes yearly tops

    // 2. We create a new SubClass 
    musicianInfo[i] = new Data( anoT, urlT, tituloT, nGramsT, "musicians");

    // 3. Feedback
    if (i == 0) println(">> First MUSICIAN["+i+"]: "+ musicianNombre[i]+" ("+musicianInfo[i].getAno(0)+") -> "+musicianInfo[i].getTitulo(0));
  }
  // Ends Load Data function
  print(">> NGRAMS loaded too!");
  println(">> ------------------------------------------------------------------------------------------------------");
}
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593  D A T A  -  C L A S S E S
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 
// -----------------------------------------------------------------------------------------------------------
// This BOTH Small Classes will keep all of our Data for each individual (very helpful)
// One fo the main Data (except yearly top participants)
class Data {
  // A. Properties
  String [] ano, url, titulo, nGrams;
  float [] nGramF;
  String tipo; // artists ? musicians ? technicians ? topics ? writers ?
  int cantidad, cantidadNGrams;
  //YearlyData [] nGramYears; // We will store all of the NGRAM Yearly Data Here
  // YearlyData [] NYTimesYears; // We will store all of the NYTimes Yearly Data Here

  // B. Constructores
  Data(String [] ano, String [] url, String [] titulo, String [] nGram, String tipo) {
    this.ano = ano;
    this.url = url;
    this.titulo = titulo;
    this.cantidad = ano.length;
    this.nGrams = nGram;
    this.tipo = tipo;
    this.cantidadNGrams = nGram.length-1;
    // We fill the float NGram Array with floating numbers
    this.nGramF = new float[ cantidadNGrams ];
    for (int i = 0; i < cantidadNGrams; i++) {
      nGramF[i] = PApplet.parseFloat( nGram[i] );
    }
  }

  // C. Getters/Setters (Very important, this is how we access the data)
  public int getCantidad() {
    return cantidad;
  }
  public String getAno(int i) {
    return ano[i];
  }
  public String getUrl(int i) {
    return url[i];
  }
  public String getTitulo(int i) {
    return titulo[i];
  }
  public String getNGram(int i) {
    return nGrams[i];
  }
  public float getNGramF(int i) {
    return nGramF[i];
  }
  public int getCantidadNGrams() {
    return cantidadNGrams;
  }
  /*
  String [] getNGramYearlyTop(int anoDeseado) {
   // anoDeseado should come in 0, 1, 2, 3 array numeration (take the necessary precautions)
   return nGramYears[anoDeseado].getYearValues();
   }
   String [] getNYTimesYearlyTop(int anoDeseado) {
   // anoDeseado should come in 0, 1, 2, 3 array numeration (take the necessary precautions)
   return NYTimesYears[anoDeseado].getYearValues();
   }
   */
}
// *******************************************************************************************************************************************************
// YEALRY DATA --> One individual class to store just one single year data *******************************************************************************
// *******************************************************************************************************************************************************
class YearlyData {
  // A. Properties ------------------------------------------------------------------------
  String [] yearValues; // WE will hold all of the individual year values here
  String ruta, tipo;
  int ano;

  // B. Constructor -----------------------------------------------------------------------
  //NYTimesYears[i] = new YearlyData( "NGRAMS_yearlyTops", anoActual, tipo );
  YearlyData( String ruta, int ano, String tipo ) {
    this.ruta = ruta;
    this.ano = ano;
    this.tipo = tipo;
    // We load the array
    String rutaFinal = ruta+"/"+tipo+"/"+ano+".txt";
    yearValues = loadStrings(rutaFinal);
    // Feedback: 
    if (random(100) > 99) {
      //println("Random year data loaded --> "+rutaFinal);
      //println("Pos 0: "+yearValues[0]);
    }
  }
  // C. Getters | Setters -----------------------------------------------------------------
  public String [] getYearValues() {
    return yearValues;
  }
  // Class ends next ---->
}


// -------------------------------------------------------------------------------
// The function that creates the Yearly data using the previous class
/*
This Variables were declared earlier:
 YearlyData [] artistInfoTopNYT, technicianInfoTopNYT, writerInfoTopNYT, topicInfoTopNYT, musicianInfoTopNYT;
 YearlyData [] artistInfoTopNGram, technicianInfoTopNGram, writerInfoTopNGram, topicInfoTopNGram, musicianInfoTopNGram;
 */
public void cargarYearlyData() {
// WHat is important to remember is that every item in this array is a YearlyDataObject which we can call to get information

  // i. Total quantity of years
  int cantidadAnos = PApplet.parseInt(fecha2-fecha1);

  // ii. We start all Arrays NYT and NGram
  artistInfoTopNYT = new YearlyData[cantidadAnos];
  technicianInfoTopNYT = new YearlyData[cantidadAnos];
  writerInfoTopNYT = new YearlyData[cantidadAnos];
  topicInfoTopNYT = new YearlyData[cantidadAnos];
  musicianInfoTopNYT = new YearlyData[cantidadAnos];
  //
  artistInfoTopNGram = new YearlyData[cantidadAnos];
  technicianInfoTopNGram = new YearlyData[cantidadAnos];
  writerInfoTopNGram = new YearlyData[cantidadAnos];
  topicInfoTopNGram = new YearlyData[cantidadAnos];
  musicianInfoTopNGram = new YearlyData[cantidadAnos];


  // iii. We fill these Arrays
  for (int i = 0; i < cantidadAnos; i++) {
    int anoActual = PApplet.parseInt(fecha1+i);
    //                                 (folder Name,       year,    category 
    artistInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "artists");
    artistInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "artists");
    //
    musicianInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "musicians");
    musicianInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "musicians");
    //
    technicianInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "technicians");
    technicianInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "technicians");
    //
    topicInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "topics");
    topicInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "topics");
    //
    writerInfoTopNYT[i] = new YearlyData( "DATA/NYTimes_yearlyTops", anoActual, "writers");
    writerInfoTopNGram[i] = new YearlyData( "DATA/NGRAMS_yearlyTops", anoActual, "writers");
  }
  
  //return nGramYears[anoDeseado].getYearValues();
}
// ------------------------------------------------------------------ \\
// ------------- G R A L - f u n c t i o n s ------------------------ \\
// ------------------------------------------------------------------ \\
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 SIZE properties
// -----------------------------------------------------------------------------------------------> size properties
public void sizeProperties() {
  // 1. We setup the width and height
  if (fullscreen) ancho = displayWidth;
  if (fullscreen) alto = displayHeight;

  // 3. We restart the variables that need to be restarted
  timeLineY = (alto/4) *3;

  // 2. We setup the size
  size(ancho, alto, P2D);
  background(azul3);
}
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 SHAPE works
// -----------------------------------------------------------------------------------------------> shapes
PShape Rect, Line, Ellipse, Punto; // Same function as Processing but with a CAPITAL letter, huh? 
// * 
public void loadShapes() {
  // RECT, ELLIPSE AND LINE SHAPE
  Rect = createShape(RECT, 0, 0, 8, 8);
  Ellipse = createShape(ELLIPSE, 0, 0, 8, 8);
  crearPunto(); // We'll create a point differently

  // We disable all the styles
  Rect.disableStyle(); 
  Ellipse.disableStyle();
  Punto.disableStyle();
}

public void crearPunto() {
  Punto = createShape();
  Punto.beginShape();
  Punto.vertex(0, 0);
  Punto.vertex(0, 2);
  Punto.vertex(2, 2);
  Punto.vertex(2, 0);
  Punto.vertex(0, 0);
  Punto.endShape();
}
// ----------------------------------------------------------------------------------------------
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 Friction Calculation
public float calcularFriccion(float actual, float deseo, float coeficiente) {

  // 0. Local variables we'll use
  float intervalo = 0;
  float resultado = 0.0f;

  // 1. We check which value is bigger
  if (actual > deseo) intervalo = actual - deseo;
  if (deseo > actual) intervalo = deseo - actual;

  // 2. We calculate the friction operations
  intervalo /= coeficiente;

  // 3. We add all of the data
  if (intervalo > 0.0000001f) {
    if (actual > deseo) resultado = actual - intervalo;
    if (deseo > actual) resultado = actual + intervalo;
  } else {
    resultado = deseo;
  }

  // 4. We return the number
  return resultado;
}

// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593  FONTS

// ----------------------------------------------------------------------------------------------
PFont avenirBook, avenirMedium, avenirMediumBig, avenirBlack, avenir, avenirHeavy, avenirMediumSmall, avenirTitle1, avenirTitle2, avenirTops, avenirDemiBold;
PFont avenirRegular, avenirBookYear;
PFont avenirNextMedium, avenirNextUltraLight;
public void loadFonts() {

  // Normal Avenir (book)
  avenirBook = createFont("DATA/FONTS/Avenir-Book.ttf", 18);
  // For the year detail view
  avenirBookYear = createFont("DATA/FONTS/Avenir-Book.ttf", 34);
  // Tops Avenir
  avenirTops = createFont("DATA/FONTS/Avenir-Book.ttf", 11);
  // Medium Avenir
  avenirMediumSmall = createFont("DATA/FONTS/Avenir-Medium.ttf", 8);
  // Medium Avenir
  avenirMedium = createFont("DATA/FONTS/Avenir-Medium.ttf", 18);
  // Medium Avenir
  avenirMediumBig = createFont("DATA/FONTS/Avenir-Medium.ttf", 67);
  // Black Avenir
  avenirBlack = createFont("DATA/FONTS/Avenir-Black.ttf", 18);
  // Black Avenir
  avenirTitle1 = createFont("DATA/FONTS/Avenir-Black.ttf", 9);
  // Black Avenir
  avenirTitle2 = createFont("DATA/FONTS/AvenirNext-UltraLight.ttf", 10);
  // Heavy Avenir
  avenirHeavy = createFont("DATA/FONTS/Avenir-Heavy.ttf", 18);
  // OTF avenir
  avenir = createFont("DATA/FONTS/avenir.otf", 8);
  // Demi Bold
  avenirDemiBold = createFont("DATA/FONTS/AvenirNext-DemiBold.ttf", 14);
  // Regular
  avenirRegular = createFont("DATA/FONTS/AvenirNext-Regular", 14);
  // Next Medium
  avenirNextMedium = createFont("DATA/FONTS/AvenirNext-Medium.ttf", 23);
  // Next UltraLight
  avenirNextUltraLight = createFont("DATA/FONTS/AvenirNext-UltraLight.ttf", 23);
}
// ----------------------------------------------------------------------------------------------
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 Sorting HAT

// This Class is used to make the alternate fillings of an specific graphic --------------
class SortingHat {
  // A. Properties
  Boolean artistPrendido = false;
  Boolean musicianPrendido = false;
  Boolean technicianPrendido = false;
  Boolean topicPrendido = false;
  Boolean writerPrendido = false;
  String tiposPrendidosT = ""; // 
  String [] tiposPrendidos;
  int totalesPrendidos = 0; // Very important to see how many are turned on
  int totales = 0;
  String [] positionsTipo; // the arrays we will actually return
  int [] positionsNo;

  // B. Constructores
  SortingHat(String combinacion) {

    // We check which types are turned on and which ones not
    revisarPrendidos(combinacion);
    // How many items we have in total
    revisarTotales();
    // Now we realize the sorting
    realizarSorting();
  }

  // -----------------------------------------
  public void revisarPrendidos(String quienes) {
    // Quienes activaton order ARTIST(1) MUSICIAN(2) TECHNICIAN(3) TOPIC(4) WRITER(5)
    // 1. We check who is activated and who is not
    if ((quienes.charAt(0)) == '1') {
      artistPrendido = true;
      tiposPrendidosT += "artists,";
      totalesPrendidos++;
    }
    if ((quienes.charAt(1)) == '1') {
      musicianPrendido = true;
      tiposPrendidosT += "musicians,";
      totalesPrendidos++;
    }
    if ((quienes.charAt(2)) == '1') {
      technicianPrendido = true;
      tiposPrendidosT += "technicians,";
      totalesPrendidos++;
    }
    if ((quienes.charAt(3)) == '1') {
      topicPrendido = true;
      tiposPrendidosT += "topics,";
      totalesPrendidos++;
    }
    if ((quienes.charAt(4)) == '1') {
      writerPrendido = true;
      tiposPrendidosT += "writers,";
      totalesPrendidos++;
    }
    //2. We divide the tipos String
    tiposPrendidos = split(tiposPrendidosT, ","); // The names of all types
  }
  // -------------------------
  public void revisarTotales() {
    // 1. Depending on the datasets desired, we will select the quantities
    if (artistPrendido) totales += artists;
    if (musicianPrendido) totales += musicians;
    if (technicianPrendido) totales += technicians;
    if (topicPrendido) totales += topics;
    if (writerPrendido) totales += writers;
  }
  // --------------------------
  public void realizarSorting() {

    // I. We will create a helper filling arrays
    String [] tiposHelpers = new String[totalesPrendidos];
    int [] totalesHelpers = new int[totalesPrendidos];
    int [] actualesHelpers = new int[totalesPrendidos];
    Boolean [] yaTerminadosHelpers = new Boolean[totalesPrendidos];

    // I. We will fill these helper arrays

    for (int i = 0; i < totalesPrendidos; i++) {
      // Tipos
      tiposHelpers[i] = tiposPrendidos[i]; // This array was declared earlier in the function
      //println(">> CREATING A NEW TIPO >> "+tiposHelpers[i]);
      // Totales
      if (tiposHelpers[i].equals("artists")) totalesHelpers[i] = artists;
      if (tiposHelpers[i].equals("musicians")) totalesHelpers[i] = musicians;
      if (tiposHelpers[i].equals("technicians")) totalesHelpers[i] = technicians;
      if (tiposHelpers[i].equals("topics")) totalesHelpers[i] = topics;
      if (tiposHelpers[i].equals("writers")) totalesHelpers[i] = writers;
      // Actuales
      actualesHelpers[i] = 0;
      // Ya terminados
      yaTerminadosHelpers[i] = false;
    }

    // II. We will now use declare the actual arrays we'll fill to display an alternate thing  THIS ARE THE ARRAYS WE WILL RETURN
    positionsTipo = new String[totales]; // We'll save the types here
    positionsNo = new int[totales]; // We'll save the numbers to each array position here
    Boolean yaTodos = false;

    // XX IV. And now the delicate function, the alternate array filling function
    int contadorGlobal = 0;
    //println(">> Alternate filling function");
    for (int i = 0; yaTodos == false; i++) { // This will execute as long as we haven't finished up fillinf
      // IV - 1 We determine the modulo we'll use
      int modulo = totalesPrendidos;

      // IV - 2 We will start to fill it now
      if (!yaTerminadosHelpers[i%modulo]) {

        // We set the new values
        positionsTipo[contadorGlobal] = tiposHelpers[i%modulo];
        positionsNo[contadorGlobal] = actualesHelpers[i%modulo];

        // We add the actual type counter and the global one
        actualesHelpers[i%modulo]++;
        contadorGlobal++;

        // Let's ask if this type has already been filled
        if (actualesHelpers[i%modulo] >= totalesHelpers[i%modulo]) yaTerminadosHelpers[i%modulo] = true;
      }

      // IV - 4 Let's check if we've finished with all of them
      int contadorTotalesPrendidos = 0;
      for ( int j = 0; j < totalesPrendidos; j++ ) {
        if ( yaTerminadosHelpers[j]) contadorTotalesPrendidos++;
      }
      if (contadorTotalesPrendidos >= totalesPrendidos) yaTodos = true;
    }
  }

  // C. Getters/Setters (Very important, this is how we access the data) ------------------------
  public String [] getPositionsTipo() {
    return positionsTipo;
  }
  public int [] getPositionsNo() {
    return positionsNo;
  }
  public int getTotales() {
    return totales;
  }
  // Class ends next --->
}



// ----------------------------------------------------------------------------------------------
// This function controls play along the sketch
Boolean enReproduccion = false;
public void playFunction() {
  // We ask if we can go on
  float intervaloAumento = 0.025f; // How fast
  if (timeLineCenter < fecha2-intervaloAumento) {
    timeLineCenterD += intervaloAumento;
  } else {
    timeLineCenterD = fecha1;
  }
}

// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 String Splitting

// ------------------------------------------------------------------------- the Function
public String [] separarTexto(String texto, Boolean dividir) {
  // 1. We always start in the first point
  int posicionArreglo = 0;

  // 2. We establish the length of our text
  int longitud = texto.length();

  // 3. We create a new Array where to put everything
  String [] letras = new String[longitud];
  letras[0] = "";
  letras[1] = "";

  // 4. We cycle through the Array
  int contPalabraActual = 0;
  int limiteCaracteres = 7;
  for (int i = 0; i < longitud; i++) {
    if (texto.charAt(i) == ' ') {
      posicionArreglo++;
      contPalabraActual = 0;
    } else {
      contPalabraActual++;
      if (dividir) {
        if (contPalabraActual < limiteCaracteres ) letras[posicionArreglo] += texto.charAt(i);
        if (contPalabraActual == limiteCaracteres) letras[posicionArreglo] += ".";
      } else {
        letras[posicionArreglo] += texto.charAt(i);
      }
    }
  }
  // 5. We return the data
  return letras;
}
// -----------------------------------------------------------------------
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 PDF

Boolean deboIniciarPDF = false;
Boolean deboTerminarPDF = false;

// PDF Recording functions
public void iniciarPDF() {
  beginRecord( PDF, "CAPTURES/PDF/Rise_And_Fall_"+year()+""+month()+""+day()+"_"+hour()+""+minute()+""+second()+".pdf" );
  deboIniciarPDF  = false;
  deboTerminarPDF = true;
}
public void terminarPDF() {
  deboTerminarPDF = false;
  endRecord();
}

// -------------------------------------------------------------------------
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 TYPE WORKS

public void typography() {
  // timeLineY Nos determina la posici'on, no olvidarlo

  // ----------------------------------------------------------------------------------------------------------- Main Year
  // 1. We determine the y position
  float alturaAnoPrincipal = timeLineY+110;

  //2. We put the year there
  textFont( avenirMediumBig, 67 ); // Disponible book black heavy
  fill(red(blanco), green(blanco), blue(blanco), 160);
  text(PApplet.parseInt(timeLineCenter), width/2, alturaAnoPrincipal );

  // ----------------------------------------------------------------------------------------------------------- Viz Title #nwmd
  // 1. We specify the values
  String title1 = "N \u00b7 e \u00b7 w  |  M \u00b7 e \u00b7 d \u00b7 i \u00b7 a  |  R \u00b7 i \u00b7 s \u00b7 e  |  a \u00b7 n \u00b7 d    f \u00b7 a \u00b7 l \u00b7 l";
  String title2 = "\u00b7  \u00b7  \u00b7 N \u00b7 e \u00b7 w  |  M \u00b7 e \u00b7 d \u00b7 i \u00b7 a \u00b7  \u00b7  \u00b7";
  String title3 = "R \u00b7 i \u00b7 s \u00b7 e  |  a \u00b7 n \u00b7 d  |  f \u00b7 a \u00b7 l \u00b7 l";

  // 2. Title position
  float titleY1 = alturaAnoPrincipal + 28;
  float titleY2 = titleY1+17;



  // 4. We put the text (finally)
  fill(red(blanco), green(blanco), blue(blanco), 100);
  textFont(avenirTitle1);
  textAlign(CENTER);
  text( title2.toUpperCase(), width/2, titleY1 );
  //fill(red(blanco), green(blanco), blue(blanco), 100);
  fill(blanco);
  textFont(avenirTitle1);
  text( title3.toUpperCase(), width/2, titleY2 );
}


// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 COLORS per category
// 1. This function will return the color per category
public int obtenerColor(String tipo) {
  // 1. a random color
  int c = color(0, 0, 0);

  // 2. We evaluate the type and return a color
  if (tipo.equals("artists")) {
    c = (amarillo);
  } else if (tipo.equals("topics")) {
    c = (azul1);
  } else if (tipo.equals("technicians")) {
    c = (rojo);
  } else if (tipo.equals("musicians")) {
    c = (naranja);
  } else if (tipo.equals("writers")) {
    c = (azul2);
  }

  // 3. we return the color
  return c;
}

// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 Loaded in every scenario (almost)

public void timeLineAndTitle() {
  // We draw the Timeline
  timeLine();

  // We ddraw additional typography elemments
  typography();
}
// ----------------------------------------------------------- \\
// ------------- i n t e r a c t i o n ------------------------ \\
// ------------------------------------------------------------ \\
// \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 This tab also has button related options/actions  (bottom )\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
public void keyPressed() {

  // ----------------------------- G L O B A L ----------------------------------------------------
  if (key == 's') save( "CAPTURES/BITMAPS/Rise_And_Fall_"+year()+""+month()+""+day()+"_"+hour()+""+minute()+""+second()+".tiff" );
  // ------------------------------- S K E T C H   C O N T R O L------------------------------------ 
  if (key == '1') {
    timeLineCenterD = 1957; // So it centers the frame
    zoomD = 1;
  }
  if (key == '2') zoomD = 4;
  if (key == '3') zoomD = 17;
  // TESTING MINI AND HUGE MAPS MODES: 
  if (key == '6') hugeMapMode = "NYTimes";
  if (key == '7') hugeMapMode = "NGram";
  if (key == '8') miniMapMode = "NYTimes";
  if (key == '9') miniMapMode = "NGram";
  //if (keyCode == ENTER || keyCode == RETURN) {
  if (keyCode == ' ') {
    enReproduccion = !enReproduccion;
  }
  if (key == 'p') deboIniciarPDF = true;
  // SPECIAL KEYS -------------------------
  if (key == CODED) {
    int intervaloAumento = 1;
    if (keyCode == RIGHT) {
      if (timeLineCenter < fecha2-intervaloAumento) timeLineCenterD += intervaloAumento;
      if (timeLineCenterD >= fecha2) timeLineCenterD = fecha2; // FAILSwitch cause otherwise, the sketch will crash!
    }
    if (keyCode == LEFT) {
      if (timeLineCenter > fecha1+intervaloAumento) timeLineCenterD -= intervaloAumento;
      if (timeLineCenterD <= fecha1) timeLineCenterD = fecha1; // FAILSwitch cause otherwise, the sketch will crash!
    }
  }
  // SCENARIO CHANGE TESTS ----------------
  if (key == 'M') iniciarTransicion("minority report"); // Minority report
  if (key == 'T') iniciarTransicion("tenori on"); // Tenori ON
  if (key == 'F') iniciarTransicion("full huge graph"); // Full Huge Graph
  if (key == 'O') iniciarTransicion("4 tops"); // Tops
}

// --------------------------------------------------------------------------------------------------------------------------------------------
// ********************************************************************************************************************************************
// --------------------------------------------------------------------------------------------------------------------------------------------

public void mousePressed() {

  if (timeLineHit(mouseY)) {
    timeLineCenterD = map(mouseX, 0, width, fecha1, fecha2); 
    println(">> NEW DATE: "+floor(timeLineCenterD));
  }
}
// --------------------------------------------------------------------------------------------------------------------------------------------
// ********************************************************************************************************************************************
// --------------------------------------------------------------------------------------------------------------------------------------------

//
//\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
//\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Button related operations
//\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
//\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
// Must be a global variable, why not !!! ???
int fallOff = 0; // Protection for multiple clics
int fallOffLimit = 10; // (usually works, perhaps even more) 50 was before, but it was just too much
// A very simple function will verify if the mouse is within an specific range
public Boolean hiceHit( float cx1, float cy1, float cx2, float cy2 ) {
  Boolean respuesta = false;
  if (mouseX > cx1 && mouseX < cx2 && mouseY > cy1 && mouseY < cy2) respuesta = true;
  return respuesta;
}
//\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022

public void closeButton() {
  // 1. Fijamos dimensiones
  float tamanoBoton = 5;
  float margenBoton = 15;
  // 2. Trasladamos
  //pushMatrix();
  //translate( width -margenBoton -(tamanoBoton/2), 0 +margenBoton +(tamanoBoton/2) );
  float x = width -margenBoton -(tamanoBoton/2);
  float y = 0 +margenBoton +(tamanoBoton/2);

  // 3. Propiedades de dibujo
  fill(blanco);
  stroke(red(blanco), green(blanco), blue(blanco), 20);
  strokeWeight(2.5f);
  if (escenarioActual == "detail view") stroke(red(azul3), green(azul3), blue(azul3), 60);
  // 4. Le hacemos un boton
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   ( x )
  if ( hiceHit( x-tamanoBoton-10, y-tamanoBoton-10, x+tamanoBoton+10, y+tamanoBoton+10 )) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    stroke(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);


    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      stroke(azul3); // White press
      exit();

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022

  // 5. Dibujamos la cruz
  line(x-tamanoBoton, y-tamanoBoton, x+tamanoBoton, y+tamanoBoton);
  line(x-tamanoBoton, y+tamanoBoton, x+tamanoBoton, y-tamanoBoton);
  //ellipse(0, 0, 3, 3);

  // Fin.
  //popMatrix();
}

// ----------------------------------------------------------------------------------------------------------------------
// This will show the buttons between the  FULL VIEW  /  TOP LIST / WIDE VIEW
public void mostrarNavegacion() {
  // 1. Coordinates  --------------------------------------------------------------------
  float xBot = width/2 +40; // THis 80 is to compensate because at the beginning we wanted a 3 button nav
  float yBot = 20;
  float altoNavegacion = 16;
  float toleranciaHit = 9;
  // -----------------------------------------------------------------------------------------------------------------------------------
  // 2. The TOP LIST BUTTON ------------------------------------------------------------- 
  float anchoTopButton = 80 ;
  // Testing rectangle
  noFill();
  stroke( blanco );
  rectMode(CENTER);
  fill(red(blanco), green(blanco), blue(blanco), 70);
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   ( x )
  if ( hiceHit( xBot-(anchoTopButton/2), yBot-(altoNavegacion/2)-toleranciaHit, xBot+(anchoTopButton/2), yBot+(altoNavegacion/2)+toleranciaHit )) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);


    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      fill(azul3); // White press
      iniciarTransicion("4 tops");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //rect(xBot, yBot, anchoTopButton, altoNavegacion); // TRUE TEST RECTANG:E
  // Finally the text
  textAlign(CENTER);
  textFont(avenirMedium, 9);
  text("> TOP LIST <", xBot-(anchoTopButton*0), yBot+3);

  // -----------------------------------------------------------------------------------------------------------------------------------
  // 3. The WIDE VIEW BUTTON -------------------------------------------------------------
  anchoTopButton = 80;
  float xBotW = xBot + anchoTopButton;
  // Testing rectangle
  noFill();
  stroke( blanco );
  rectMode(CENTER);
  fill(red(blanco), green(blanco), blue(blanco), 70);
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   ( x )
  if ( hiceHit( xBotW-(anchoTopButton/2), yBot-(altoNavegacion/2)-toleranciaHit, xBotW+(anchoTopButton/2), yBot+(altoNavegacion/2)+toleranciaHit )) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);


    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      fill(azul3); // White press
      iniciarTransicion("full huge graph");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  // rect(xBotW, yBot, anchoTopButton, altoNavegacion); // TEST RECTANGLE
  // Finally the text
  textAlign(CENTER);
  textFont(avenirMedium, 9);
  text("> WIDE VIEW <", xBotW-(anchoTopButton*0), yBot+3);

  // -----------------------------------------------------------------------------------------------------------------------------------
  // 3. The FULL VIEW BUTTON ------------------------------------------------------------- "Minority report"
  anchoTopButton = 80;
  float xBotF = xBot - anchoTopButton;
  // Testing rectangle
  noFill();
  stroke( blanco );
  rectMode(CENTER);
  fill(red(blanco), green(blanco), blue(blanco), 70);
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   ( x )
  if ( hiceHit( xBotF-(anchoTopButton/2), yBot-(altoNavegacion/2)-toleranciaHit, xBotF+(anchoTopButton/2), yBot+(altoNavegacion/2 )+toleranciaHit)) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);

    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      fill(azul3); // White press
      iniciarTransicion("minority report");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //rect(xBotF, yBot, anchoTopButton, altoNavegacion); // TRUE TEST RECTANGLE
  // Finally the text
  textAlign(CENTER);
  textFont(avenirMedium, 9);
  text("> FULL VIEW <", xBotF-(anchoTopButton*0), yBot+3);
  
  // -----------------------------------------------------------------------------------------------------------------------------------
  // 4. The TENORI BUTTON ------------------------------------------------------------- ""tenori on"
  anchoTopButton = 80;
  float xBotN = xBot - anchoTopButton*2;
  // Testing rectangle
  noFill();
  stroke( blanco );
  rectMode(CENTER);
  fill(red(blanco), green(blanco), blue(blanco), 70);
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   ( x )
  if ( hiceHit( xBotN-(anchoTopButton/2), yBot-(altoNavegacion/2)-toleranciaHit, xBotN+(anchoTopButton/2), yBot+(altoNavegacion/2 )+toleranciaHit)) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);

    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      fill(azul3); // White press
      iniciarTransicion("tenori on");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
 // rect(xBotN, yBot, anchoTopButton, altoNavegacion); // TRUE TEST RECTANGLE
  // Finally the text
  textAlign(CENTER);
  textFont(avenirMedium, 9);
  text("> SPLIT NGRAM <", xBotN-(anchoTopButton*0), yBot+3);
}
// ------------------------------------------------------------ \\
// ------------- s c e n a r i o s ---------------------------- \\
// ------------------------------------------------------------ \\
// This is the function that controls what is being visualize and what is not



String escenarioAnterior = "cover";
String escenarioActual = "cover"; // This will be the starting scenario BTW
String escenarioDeseado = "meh";
//
/// Starting variables for the Minority Report Scenario
String hugeMapMode = "MYtimes"; // Could be ----> "NYTimes" / "NGram"
String miniMapMode = "NGram"; // Could be ----> "NYTimes" / "NGram"
// "cover" "
// \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 SHOW SCENARIOS

// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 
public void mostrarEscenarios() {

  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593  "cover" 
  // This is what we're supposed to see once we open the sketch
  if (escenarioActual == "cover") {
    cover();
  }
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593  "minority report"
  // The ever traditional FULL INFO scenario
  if (escenarioActual == "minority report") {
    // The values
    float margenD = 110;
    float margenI = 1;
    float margenTop = height*110/1050; 
    println("El display esta a : "+displayWidth+" x "+displayHeight);
    // The main Huge Graphic
    hugeMap(margenTop, margenTop, width-620.0f, height/4*3.0f -70, "barras", true, "11111", false, "conLeyenda", "hugeMap"); //NYTIMES test
    // 
    float altoADistribuir = (height-(height-timeLineY)-margenTop)/2;
    float inicioVizD = width-540;
    // The mini Map
    //hugeMap(inicioVizD, margenTop, width-42, height/4*2.0 -150, "barras", true, "01101", true, "sinLeyenda", "miniMap" ); //NGram test
    hugeMap(inicioVizD, margenTop, width-42, margenTop+altoADistribuir -30, "barras", true, "01101", true, "sinLeyenda", "miniMap" ); //NGram test

    // The Tenori-ON option
    gridMap(inicioVizD, margenTop+altoADistribuir, width-42, margenTop+(altoADistribuir*2), "00001", true); // Writers only

    // We show the Lower tops rating
    lowerTops();

    // ]Navigation between scenarios
    mostrarNavegacion();

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 "full huge graph"
  if (escenarioActual == "full huge graph") {
    // 1. We specify the position 
    float margenDer = 40;
    // The main Huge Graphic
    // 
    //hugeMap(110.0, 110, width-110.0, height/4*3.0 -70, "barras", true, "11111", false, "conLeyenda", "hugeMap"); //NYTIMES test
    hugeMap(margenDer, 110, width-margenDer, height/4*3.0f -70, "barras", true, "11111", false, "conLeyenda", "hugeMap"); //NYTIMES test

    // We show the Lower tops rating
    lowerTops();

    // Navigation between scenarios
    mostrarNavegacion();

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 "tenori on"
  if (escenarioActual == "tenori on") {
    // 1. We specify the position 
    float margenDer = 20;
    float margenUp = 10;
    // The huge map
    if (width <= 1280) gridMap(margenDer, margenUp, width-margenDer, timeLineY-margenUp, "11111", false); // Huge Grid (FULLSCREEN all categories)
    if (width > 1280) gridMap(margenDer, margenUp, width-margenDer, timeLineY-margenUp, "11111", true); // Huge Grid (FULLSCREEN all categories)
    // Navigation between scenarios
    mostrarNavegacion();

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 "4 tops"
  if (escenarioActual == "4 tops") {
    // 1. We specify the position 
    float margenDer = 40;
    float margenTop = 90;
    float anchoTops = width-(margenDer*2);
    anchoTops /= 4;
    // 2. 
    topsMap( margenDer+(anchoTops*0), margenTop, margenDer+(anchoTops*0)+anchoTops, timeLineY-40, "artists", "\u00b7Artists\u00b7", artists);
    topsMap( margenDer+(anchoTops*1), margenTop, margenDer+(anchoTops*1)+anchoTops, timeLineY-40, "musicians", "\u00b7Musicians\u00b7", musicians);
    topsMap( margenDer+(anchoTops*2), margenTop, margenDer+(anchoTops*2)+anchoTops, timeLineY-40, "technicians", "\u00b7Technicians\u00b7", technicians);
    topsMap( margenDer+(anchoTops*3), margenTop, margenDer+(anchoTops*3)+anchoTops, timeLineY-40, "topics", "\u00b7Topics\u00b7", topics);

    // Navigation between scenarios
    mostrarNavegacion();

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 "detail view"
  if (escenarioActual == "detail view") {
    // We shoe the detail view, almost fullscreen mode
    detailView(0, 0, width, timeLineY-(timeLineHeight/2));

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593
}
// \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 LOWER TERMS function
public void lowerTops() {
  // Top terms at the bottom
  // 1. We specify the position 
  float margenDer = 40;
  float anchoTops = ((width/2) -margenDer -100)/2;
  // 2. 
  topsMap( margenDer, timeLineY+40, margenDer+anchoTops, timeLineY+40+150, "artists", "\u00b7Artists\u00b7", 3);
  topsMap( margenDer+anchoTops, timeLineY+40, margenDer+(anchoTops*2), timeLineY+40+150, "musicians", "\u00b7Musicians\u00b7", 3 );
  topsMap( width/2+120, timeLineY+40, (width/2+120)+(anchoTops*1), timeLineY+40+150, "technicians", "\u00b7Technicians\u00b7", 3);
  topsMap( width/2+120+anchoTops, timeLineY+40, (width/2+120)+(anchoTops*2), timeLineY+40+150, "topics", "\u00b7Topics\u00b7", 3);
}

// \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 CHANGE A SCENARIO

public void cambiarEscenario( String tipoNuevo) {
  // This function is activated when we change, like... setting the previous one and so forth.....

  // 1. We set the options for the new map
  if (tipoNuevo == "minority report") {
    hugeMapMode = "MYtimes"; // Could be ----> "NYTimes" / "NGram"
    miniMapMode = "NGram";
  }
  if ( tipoNuevo == "full huge graph") {
    hugeMapMode = "NGram"; // SO we see it googleStyle
    hugeMapMode = "both";
    zoomD = 1; // So we see it all
    timeLineCenterD = 1957;
  }
  if ( tipoNuevo == "detail view") {
    // We restart the fritcion values
    iniciarDetailViz();
  }

  // 2. We set the previous and the current one
  escenarioAnterior = escenarioActual; // This will help the 'back' functions
  escenarioActual = escenarioDeseado;
}
// \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 TRANSITION
Boolean enTransicion = false;
Boolean primeraVezTransicion = false;
Boolean segundaVezTransicion = false;
float opacidadActual = 0;
float opacidadD = 0;
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 "ejecutar transition"
public void ejecutarTransicion() {

  // So, this function will just make a fade function
  // 1. If this is the first time, we will set new opacity values --------------
  if (primeraVezTransicion) {
    opacidadD = 255;
    primeraVezTransicion = false; 
    segundaVezTransicion = false;
  }

  // 2. Now we will execute the friction values --------------------------------
  opacidadActual = calcularFriccion(opacidadActual, opacidadD, 6);

  // 3. We will draw the rectangle ---------------------------------------------
  noStroke();
  fill(red(azul3), green(azul3), blue(azul3), opacidadActual);
  // fill(red(blanco), green(blanco), blue(blanco), opacidadActual); // Flash blanco (just practice, not a game)
  shapeMode(CORNER);
  shape(Rect, 0, 0, width, height);

  // 4. We will ask if the growth is already there -----------------------------
  if (!segundaVezTransicion && opacidadActual >= 254) { // It means we are growing, adding up opacity
    opacidadActual = 255;
    opacidadD = 0;
    segundaVezTransicion = true;
    // We will trigger the stage changing here!
    cambiarEscenario(escenarioDeseado);
  }

  // 5. We will ask if the fade out is already there ---------------------------
  if (segundaVezTransicion && opacidadActual <= 0.01f) {
    opacidadActual = 0;
    segundaVezTransicion = false;
    enTransicion = false;
  }
}
// \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 "start the transition"
public void iniciarTransicion(String tipo) {
  // We set the file
  escenarioDeseado = tipo;
  // Transition global control values
  primeraVezTransicion = true;
  enTransicion = true; //
}
// -------------------------------------------------------- \\
// ------------- TOP MENTIONS VIEW ------------------------ \\
// -------------------------------------------------------- \\
// 
// -------------------------------------------------------------------------------------
// \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588  FUNCTION START
// This function shows the TOP terms for some categories
// ----------( cooordenadas -------------------------- la categoria , cuantos tops,   )
public void topsMap(float c1x, float c1y, float c2x, float c2y, String quienes, String title, int limite) {

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 TEST RECT *
  // 1. Rectangle test ( comment and uncomment as needed )
  shapeMode(CORNERS);
  fill(red(blanco), green(blanco), blue(blanco), 17);
  //shape(Rect, c1x, c1y, c2x, c2y);

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 CENTER COORDINATES
  // 1. We specify our centers (from where we'll work)
  float ancho = c2x-c1x;
  float cx = c1x+(ancho/2); // el centro en X
  float alto = c2y-c1y;
  float cy = c1y+(alto/2); // el centro en Y
  cy = c1y;
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 COLOR
  // 1. Each color for every category
  int c = obtenerColor(quienes);

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 MAIN TITLE AND subdividing line
  // 1. We put the main title
  float alturaTitle = c1y+7.5f;
  fill(c);
  textAlign(CENTER);
  textFont(avenirTops);
  text(title, cx, alturaTitle);
  // 2. A dividing line (just for reference perhaps)
  stroke(blanco);
  stroke(red(blanco), green(blanco), blue(blanco), 70);
  //line(cx, alturaTitle+20, cx, alturaTitle+( alto-17.5 ));


  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 GATHERING THE DATA
  // 1. To make this easier, we'll create a new object with all of the data
  TopData datosTop = new TopData( quienes, limite, PApplet.parseInt(timeLineCenter) ); // (both for NYT & NGram)
  String [] nombresNYTop = datosTop.getNombresNYT(); // Para los main titles            - NYT
  String [] valoresNYTop = datosTop.getValoresNYT(); // Para el subtitle % o items      - NYT
  String [] nombresNGramTop = datosTop.getNombresNGram(); // Para los main titles       - NGRAMS 
  String [] valoresNGramTop = datosTop.getValoresNGram(); // Para el subtitle % o items - NGRAMS


  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 ANIMATING the circle growth 


  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 DRAWING THE VALUES
  // 
  float alturaRenglon = 30;
  float alturaInicio = alturaTitle+40;
  float desplazamientoH = 13; // How much we will move to the left or right the text between the columns

  // 1. We draw the whole data ------------------------------------
  float textoXR = 0.0f; // We put this outside so we can access it for the subtitles
  float textoLR = 0.0f;
  float textoXL = 0.0f;
  float yRenglon = 100;
  for (int i = 0; i < limite && i < 15 && yRenglon < c2y-20; i++) {
    // -------------------------------------------------------------
    // a. We calculate the row height  -----------------------------
    yRenglon = alturaInicio+(alturaRenglon*i);

    // ---------------------------------------------------------------------
    // b. Let's specify coordinates for the center circles ------------------------------------ ( we are not drawing them right now)
    //     b1 LEFT (nyt)
    float xCircleL = cx-desplazamientoH;
    //     b2 RIGHT (ngram)
    float xCircleR = cx+desplazamientoH;


    // -------------------------------------------------------------
    // c. Let's put the main TITLE and SUBTITLE ----------------------
    //     c1 LEFT (nyt)
    String topTitleL = nombresNYTop[i]; // Value for the top title
    int subTitleL = PApplet.parseInt(valoresNYTop[i]); // Value for the subtitle
    if (subTitleL == 0) topTitleL = "X"; // We put an "x" if there is no value
    textoXL = xCircleL-(alturaRenglon/2) -8; // Location of the text
    fill(c);
    textAlign(RIGHT);
    textFont(avenirBlack, 8);
    if (i == 0) textFont(avenirBlack, 11); // If it is the first, special font treatment
    text(topTitleL.toUpperCase(), textoXL, yRenglon +3); // Top title
    textFont(avenirHeavy, 7);
    fill( red(blanco), green(blanco), blue(blanco), 150 );
    if (subTitleL > 0) text( subTitleL, textoXL, yRenglon +12 ); // Subtitle, only if it's greater than -
    //     d2 RIGHT (nGram)
    String topTitleR = nombresNGramTop[i]; // Value for the Top title
    float subTitleR = map(PApplet.parseFloat(valoresNGramTop[i]), 0, 1, 1, 0); // Subtitle Value (inverted cause of the NGram conversion)
    float subTitleRPorcentaje = PApplet.parseInt(map(subTitleR, 0, 1, 0, 100 )); // 
    String subTitleRArreglado = subTitleRPorcentaje+"%";
    if (subTitleR <= 0) topTitleR = "X";
    textoXR = xCircleR+(alturaRenglon/2) +8;
    fill(c);
    textAlign(LEFT);
    textFont(avenirBlack, 8);
    if (i == 0) textFont(avenirBlack, 11);
    text(topTitleR.toUpperCase(), textoXR, yRenglon +3);
    textFont(avenirHeavy, 7);
    fill( red(blanco), green(blanco), blue(blanco), 150 );
    if (subTitleR > 0) text( subTitleRArreglado, textoXR, yRenglon +12 );


    // 



    // ------------------------------------------------------------------------------------
    // c. Let's specify the center circles sizes first ------------------------------------
    //     b1 LEFT (nyt)
    //float xCircleL = cx-desplazamientoH;
    float tamanoCirculoL = alturaRenglon*1.5f;
    float tamanoCirculoLArreglado = map( PApplet.parseFloat(valoresNYTop[i]), PApplet.parseFloat(valoresNYTop[PApplet.parseInt(limite-1)]), PApplet.parseFloat(valoresNYTop[0]), tamanoCirculoL/7, tamanoCirculoL );
    float tamanoCirculoR = alturaRenglon*1.5f*( subTitleRPorcentaje/100  );
    fill(red(c), green(c), blue(c), 160); // This color will only change if the mouse is over the button

    // -------------------------------------------------------------------------------------
    // d. Let's make them interactive (click to google) ------------------------------------
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022  NYT
    if ( hiceHit( xCircleL-(tamanoCirculoLArreglado/2), yRenglon-(tamanoCirculoLArreglado/2), xCircleL+(tamanoCirculoLArreglado/2), yRenglon+(tamanoCirculoLArreglado/2))) {
      if (topTitleL != "X") {
        // 1. MOUSE OVER DRAW ATTRIBUTES
        fill(blanco); // full HOVEr color

        // 2. ACTION AFTER HIT
        if (mousePressed && fallOff == 0) {
          String [] nombreABuscar = separarTexto(topTitleL, false);
          String nombreABuscarFinal = nombreABuscar[0]+"+"+nombreABuscar[1];
          String anoABuscar = PApplet.parseInt( timeLineCenter )+"";
          String rutaURL = "https://www.google.com/?gws_rd=ssl#safe=off&q="+nombreABuscarFinal+"+"+anoABuscar;
          open(rutaURL);

          fill(255); // White press

          fallOff = fallOffLimit;
        } 
        // 3. FALL OFF OPERATIONS (ignore)
        // FallOff Operations, highly important!
        fallOff -= 1;
        if (fallOff <= 0) fallOff = 0; // So we don't get negative values
      } // <-- No content iF
    } // <-- Button iF
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022

    // ------------------------------------------------------------------------------------
    // e1. Let's draw the NYTIMES MAIN circles  ------------------------------------
    //     e1 LEFT (nyt)
    noStroke();
    shapeMode(CENTER);
    shape(Ellipse, xCircleL, yRenglon, tamanoCirculoLArreglado, tamanoCirculoLArreglado);


    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022  NGrams
    fill(red(c), green(c), blue(c), 160); // This color will only change if the mouse is over the button
    if ( hiceHit( xCircleR-(tamanoCirculoR/2), yRenglon-(tamanoCirculoR/2), xCircleR+(tamanoCirculoR/2), yRenglon+(tamanoCirculoR/2))) {
      if (topTitleR != "X") {
        // 1. MOUSE OVER DRAW ATTRIBUTES
        fill(blanco); // full HOVER color

        // 2. ACTION AFTER HIT
        if (mousePressed && fallOff == 0) {
          String [] nombreABuscar = separarTexto(topTitleR, false);
          String nombreABuscarFinal = nombreABuscar[0]+"+"+nombreABuscar[1];
          String anoABuscar = PApplet.parseInt( timeLineCenter )+"";
          String rutaURL = "https://www.google.com/?gws_rd=ssl#safe=off&q="+nombreABuscarFinal+"+"+anoABuscar;
          open(rutaURL);

          fill(255); // White press

          fallOff = fallOffLimit;
        } 
        // 3. FALL OFF OPERATIONS (ignore)
        // FallOff Operations, highly important!
        fallOff -= 1;
        if (fallOff <= 0) fallOff = 0; // So we don't get negative values
      } // <-- No content iF
    } // <-- Button iF
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022

    // e2. Let's draw the NGRAMS MAIN circles  ------------------------------------
    //     e2. RIGHT (ngram)
    //float xCircleR = cx+desplazamientoH;
    //fill(c);
    shapeMode(CENTER);
    shape(Ellipse, xCircleR, yRenglon, tamanoCirculoR, tamanoCirculoR);


    // f. Let's draw the center dark circles ------------------------------------
    //     b1 LEFT (nyt)
    fill(azul3);
    shapeMode(CENTER);
    shape(Ellipse, xCircleL, yRenglon, 4, 4);
    //     b2 RIGHT (ngram)
    fill(azul3);
    shapeMode(CENTER);
    shape(Ellipse, xCircleR, yRenglon, 4, 4);
  }
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 NGRAM and Google Titles
  // 1. WE set a new height (x already defined in these variables --> textoXR | textoLR = 0.0;
  float alturaCategories = alturaTitle+20;

  // 2. We just draw the Text, that simple
  fill(red(blanco), green(blanco), blue(blanco), 70);
  textAlign(RIGHT);
  textFont( avenirMedium, 7 );
  text("NYTIMES", textoXL, alturaCategories);
  textAlign(LEFT);
  text("NGRAM", textoXR, alturaCategories);
  // TopsMap Viz ends next ---->
}

// \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 

// \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 TPO DATA CLass

// \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 

// ----------------------------------------------------------------------------------------------------------
// This class will process all of the information we'll need and then return them
// This class was made to make it easy handling all of the values and keep the topsMap() function clan
/*
TopData datosTop = new TopData( quienes, limite, timeLineCenter ); // (both for NYT & NGram)
 String [] nombresNYTop = datosTop.getNombresNYT(); // Para los main titles            - NYT
 String [] valoresNYTop = datosTop.getValoresNYT(); // Para el subtitle % o items      - NYT
 String [] nombresNGramTop = datosTop.getNombresNGram(); // Para los main titles       - NGRAMS 
 String [] valoresNGramTop = datosTop.getValoresNGram(); // Para el subtitle % o items - NGRAMS
 */
// ----------------------------------------------------------------------------------------------------------
class TopData {
  // A. Propiedades -----------------------------------------------------------------------------------------
  String tipo; // artists? topics?....
  int limite; // How many items from the top ten we will return
  int fecha;
  // The arrays to hold the whole thing
  String [] rawNYT, rawNGrams; // This function will save the raw data
  String [] nombresNYT, nombresNGram, valoresNYT, valoresNGram;

  // B. Constructores ---------------------------------------------------------------------------------------
  TopData( String tipo, int limite, int fecha ) {
    // 1. We receive the values -----------------------------------------------------------------------------
    this.tipo = tipo;
    this.limite = limite;
    this.fecha = fecha;

    // 2. So, we get the Raw data for the NYT and NGram -----------------------------------------------------
    int anoDeseado = PApplet.parseInt(fecha-fecha1);
    // 
    if (tipo.equals("artists")) rawNYT = artistInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("artists")) rawNGrams = artistInfoTopNGram[anoDeseado].getYearValues();
    //
    if (tipo.equals("musicians")) rawNYT = musicianInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("musicians")) rawNGrams = musicianInfoTopNGram[anoDeseado].getYearValues();
    //
    if (tipo.equals("technicians")) rawNYT = technicianInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("technicians")) rawNGrams = technicianInfoTopNGram[anoDeseado].getYearValues();
    //
    if (tipo.equals("topics")) rawNYT = topicInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("topics")) rawNGrams = topicInfoTopNGram[anoDeseado].getYearValues();
    //
    if (tipo.equals("writers")) rawNYT = writerInfoTopNYT[anoDeseado].getYearValues();
    if (tipo.equals("writers")) rawNGrams = writerInfoTopNGram[anoDeseado].getYearValues();

    // 3. And now we start the final recipients array (the ones that will be returned) --------------------------
    nombresNYT = new String[limite];
    valoresNYT = new String[limite];
    nombresNGram = new String[limite];
    valoresNGram = new String[limite];

    // 4. Finally, we fill all of the items (notice that the NGram Values is already twisted) ------------------
    // We could probably did this function with some slice value, meh
    for (int i = 0; i < limite; i++) {

      // i. This is a ROW in the rawNYT Array --> 1906,0.79,Extended Reality
      //    We split every row
      String [] datosExplotadosNYT = split(rawNYT[i], ",");
      String [] datosExplotadosNGrams = split(rawNGrams[i], ",");

      // ii. We fill the values
      nombresNYT[i] = datosExplotadosNYT[2];
      valoresNYT[i] = datosExplotadosNYT[1];
      nombresNGram[i] = datosExplotadosNGrams[2];
      valoresNGram[i] = datosExplotadosNGrams[1];
    }
  }
  // C. GETTERS without them this class would make no sense -------------------------------------------------
  public String [] getNombresNYT() {
    return nombresNYT;
  }
  public String [] getValoresNYT() {
    return valoresNYT;
  }
  public String [] getNombresNGram() {
    return nombresNGram;
  }
  public String [] getValoresNGram() {
    return valoresNGram;
  }
}
// ---------------------------------------------------- \\
// ------------- grid Map View ------------------------ \\
// ---------------------------------------------------- \\

// A more detailed view on each change based on an specific date (TENORI-ON STYLE)

// -------------------------------------------------------------------------------------
public void gridMap(float c1x, float c1y, float c2x, float c2y, String quienes, Boolean dividir) {

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 WHICH DATA ARE WE GOING TO USE?
  // 1. ACTIVATED TYPES - Who is activated
  //   We create a new object to store all of our data files (and for future Array Filling)
  SortingHat dataMatrix = new SortingHat(quienes);

  // 2. QUANTITIES - We extract the total number from our datamatrix object
  int totales = dataMatrix.getTotales();

  // 3. ALTERNATION FILLING - The DataMatrix Object has already sorted everything for us
  String [] positionsTipo = dataMatrix.getPositionsTipo(); // We'll save the types here
  int [] positionsNo = dataMatrix.getPositionsNo(); // We'll save the numbers to each array position here

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 TEST RECT * CROSSES TOO
  // 1. Rectangle test ( comment and uncomment as needed )
  shapeMode(CORNERS);
  fill(red(blanco), green(blanco), blue(blanco), 17);
  //shape(Rect, c1x, c1y, c2x, c2y);
  //2. Some crosses to mark the territory
  colocarCrucecillas( c1x, c1y, c2x, c2y );

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 CEll size and DRAWING PROPERTIES
  // 1. We calculate height and width
  float altura = c2y-c1y;
  float ancho = c2x-c1x;

  // 2. We will estimate how many elements per row and column
  int renglones = ceil(sqrt(totales));
  int columnas = ceil(sqrt(totales));

  // 3. We will divide our width and height
  float anchoColumna = ancho/(columnas+1);
  float altoRenglon = altura/(renglones+1);

  // 4. According to the lowest value we will establish a cell size
  float cellSize = 1;
  if (anchoColumna > altoRenglon) cellSize = altoRenglon;
  if (altoRenglon > anchoColumna) cellSize = anchoColumna;

  // 5. We readjust the real cell size
  float alturaTexto = 18; //Very important since the text is down
  if(!dividir) alturaTexto = 10;
  float margen = 2;
  float cell = cellSize-(margen*2)-alturaTexto ;

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 ACTUAL DRAWING
  int contadorItems = 0;
  int  cellRes = 0; // Here, so we can access it later.
  // We cycle each cell
  for (int i = 0; i < renglones && contadorItems < totales; i++) {
    // 1. We establish a width for the cell
    float y = altoRenglon*(i+1);
    y += c1y;// We re-adjust the position
    for (int j = 0; j < columnas && contadorItems < totales; j++) {
      // 2. We establish a renglon height
      float x = anchoColumna*(j+1);
      x += c1x; 

      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 Cell individual operations start here
      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 0 . Item T Object defined here
      if (positionsTipo[contadorItems].equals("artists")) itemT = artistInfo[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("musicians")) itemT = musicianInfo[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("technicians")) itemT = technicianInfo[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("writers")) itemT = writerInfo[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("topics")) itemT = topicInfo[positionsNo[contadorItems]];
      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 a . Main Cell drawing and preparations
      // 1. Cell Square
      noFill();
      strokeWeight(1);
      noStroke();
      fill(red(blanco), green(blanco), blue(blanco), 19);
      noStroke();
      // ellipse(x, y, 3, 3); // elipse de prueba
      rectMode(CENTER);
      rect(x, y, cell, cell);

      // 2. Middle line
      stroke(red(azul3), green(azul3), blue(azul3), 130);
      line( x, y- cell/2, x, y+ cell/2 );

      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 b . Getting the Name and displaying it

      // 3. Text - getting the data
      String nombre = "meh";
      if (positionsTipo[contadorItems].equals("artists")) nombre = artistNombre[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("writers")) nombre = writerNombre[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("technicians")) nombre = technicianNombre[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("musicians")) nombre = musicianNombre[positionsNo[contadorItems]];
      if (positionsTipo[contadorItems].equals("topics")) nombre = topicNombre[positionsNo[contadorItems]];
      String [] nombreFinal = separarTexto(nombre, dividir);
      

      // 3 - B . Text - puttin' it there
      fill(blanco);
      textAlign(CENTER);
      textFont( avenirMediumSmall);
      //      text( nombreFinal[0].toUpperCase(), x, y+ cell/2 + alturaTexto/2 + 2);
      if(dividir){
      text( nombreFinal[0], x, y+ cell/2 + alturaTexto/2 + 2);
      text( nombreFinal[1], x, y+ cell/2 + alturaTexto + 2);
      }else{
        text( nombre, x, y+ cell/2 + alturaTexto/2 + 4);
      }

      // 4. We Specify the drawing properties according to their type
      int c = obtenerColor(positionsTipo[i]);

      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 BUTTON/INteraction
      // Button for the CELL
      //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
      //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   ( x )
      if ( hiceHit( x-(cell/2), y-(cell/2), x+(cell/2), y+(cell/2))) { 

        // 1. MOUSE OVER DRAW ATTRIBUTES
        fill(red(blanco), green(blanco), blue(blanco), 50); // OVER COLOR
        noStroke();
        rectMode(CENTER);
        rect(x, y, cell, cell);

        // 2. ACTION AFTER HIT
        if (mousePressed && fallOff == 0) {
          // A. We set the individual data
          individuoPos = positionsNo[contadorItems];
          individuoType = positionsTipo[contadorItems];
          individuoNombre = nombre;

          // B. We restart the filling function
          iniciarDetailViz();

          // C. We start the transition
          iniciarTransicion("detail view"); // Detail View

          fallOff = fallOffLimit;
        } 
        // 3. FALL OFF OPERATIONS highly important!
        fallOff -= 1;
        if (fallOff <= 0) fallOff = 0; // So we don't get negative values
      } 
      //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
      //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022

      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 c . Gettin' NGram Data


      // A. GRID RESOLUTION
      cellRes = 5; // Siempre impar !!! MOLTO IMPORTANTE!
      int mitadCellRes = ceil(cellRes/2);

      // B. Central Year
      int anoCentral = PApplet.parseInt(timeLineCenter);
      int anoInicial = PApplet.parseInt(timeLineCenter-floor((cellRes/2)));

      // C. We create and fill an array with years
      int [] nGramYears = new int [cellRes];
      for (int k = 0; k < cellRes; k++) { // 1st half
        nGramYears[k] = anoInicial+k;
        //println("Year ["+k+"] = "+nGramYears[k]);
      }

      // D. Data gather for each year NGram -----------------------------
      float [] ngrams = new float[ cellRes ];
      for (int k = 0; k < cellRes; k++) {

        // We will gather this NGram totals
        int nGramTotalesT = itemT.getCantidadNGrams();

        // We Calculate a position
        int deseo = floor(map( nGramYears[k], fecha1, fecha2, 0, nGramTotalesT-1));

        // FailSwitch gathering the data
        ngrams[k] = 1.0f;
        if (deseo >= 0 && deseo < nGramTotalesT) {
          ngrams[k] = itemT.getNGramF(deseo);
        } else {
          ngrams[k] = 1.0f;
        }
        //println(">> NGRAM ["+k+"] = "+ngrams[k]);
      }

      // E.  We will scale the Data
      for (int k = 0; k < cellRes; k++) {
        ngrams[k] = PApplet.parseInt(map(ngrams[k], 1, 0, 0, cellRes)); // Crucial step to draw the data
        //ngrams[k] = ceil(map(ngrams[k], 0, 1, 0, cellRes));
      }

      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 d . We get the color data


      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 e . Drawing finally!!!!!!!!!! (grid Tenori style)
      int totalesTenori = cellRes*cellRes; // Total number
      // We translate everything
      pushMatrix();
      translate(-cell/2 + (cell/cellRes)/2, -cell/2);

      int contadorTenori = 0;
      for (int k = 0; k < cellRes && contadorTenori < totalesTenori; k++ ) { //Columnas
        float xTenori = cell/cellRes * k ;

        for (int m = 0; m < cellRes && contadorTenori < totalesTenori; m++) { // Renglones
          float yTenori = cell/cellRes * m;

          // Tamano del circulo
          float radioTenori = cell/cellRes -1;

          // We ask and we draw then
          float posicionPregunta = map( m, 0, cellRes, cellRes, 0 );
          if (ngrams[k] >= posicionPregunta) {
            // We draw the circle
            fill(c);
            noStroke();
            shapeMode(CENTER);
            shape(Ellipse, x+xTenori, y+yTenori, radioTenori, radioTenori);
          }

          //Tenori objects counter
          contadorTenori++;
        }
      }
      popMatrix();

      // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 Each Cycle 2 fors end after -->
      contadorItems++;
    }
  }
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 MAP TITLE 
  // At the end, so we could use the cellRes variable
  // 1. We establish our title
  String tituloMap = "// "+cellRes+"-YEAR NGRAM";

  // 2. Where should we put this?
  float yTitle = c1y-10;
  float xTitle = c1x;
  // yTitle = c1y;


  //3. Let's put it mate, once and for all
  fill(red(blanco), green(blanco), blue(blanco), 210);
  textAlign(LEFT);
  textFont(avenirBlack, 9.5f);
  text(tituloMap, xTitle, yTitle);

  // gridMapViz ends next ------->
}
// ---------------------------------------------------- \\
// ------------- huge Map View ------------------------ \\
// ---------------------------------------------------- \\
// The first initial view over time
// 
Boolean estatico = true; // This means, show the full year or a zoom (i think this wasn't used at last)
//
// ----------------------------------------------------------------------------------------------------------------------------------------------
// 
// --------  ( coordenadas x,y cuadro, tipo "barras/bolas", grid/reticula, quienes="todos")
public void hugeMap(float c1x, float c1y, float c2x, float c2y, String tipo, Boolean grid, String quienes, Boolean uniZoom, String leyenda, String tipoMapa) {
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 NYTimes or NGrams ????? 
  // VERY IMPORTANT! This few lines will establish the whole behaviour of our map
  // This lines allow the user to change the map on the go with an external variable as switch 
  Boolean NYTimesMode = true;
  Boolean NGramMode = false;
  if (hugeMapMode == "both") NGramMode = true; // We activate them all
  if (tipoMapa == "hugeMap" && hugeMapMode == "NGram") {
    NYTimesMode = false;
    NGramMode = true;
  }
  if (tipoMapa == "miniMap" && miniMapMode == "NGram") {
    NYTimesMode = false;
    NGramMode = true;
  }

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 WHO IS ACTIVATED?
  // 1. Who is activated
  //   We create a new object to store all of our data files (and for future Array Filling)
  SortingHat dataMatrix = new SortingHat(quienes);

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 TEST RECT AND CROSSES
  // 1. Rectangle test ( comment and uncomment as needed )
  shapeMode(CORNERS);
  fill(red(blanco), green(blanco), blue(blanco), 17);
  //shape(Rect, c1x, c1y, c2x, c2y);
  //2. Some crosses to mark the territory
  colocarCrucecillas( c1x, c1y, c2x, c2y );
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 MAP TITLE
  // 1. We establish our title
  String tituloMap = "// N.Y.TIMES MENTIONS";
  if (NGramMode) tituloMap = "// GOOGLE'S NGRAM COUNT";

  // 2. Where should we put this?
  float yTitle = c1y-40;
  float xTitle = c1x;

  //3. Let's put it mate, once and for all
  fill(red(blanco), green(blanco), blue(blanco), 210);
  textAlign(LEFT);
  textFont(avenirBlack, 9.5f);
  text(tituloMap, xTitle, yTitle);
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 TIME FRAME SETTINGS
  // (very important, according to the zoom level) -------------------------------
  // 1. Standard values for #1 zoom
  float fechaMin = fecha1;
  float fechaMax = fecha2;
  //2. If zoom is greater than one, then we calculate according to our centered date
  if (zoom > 1) {
    // This is how many years normally fit
    float standarizedYears = 115; 
    // b. We create a range we'll add to the timeline Center Date to the right and left
    float yearsRange = standarizedYears/2; // We split it into two, casue there are two sides

    // 3. WE check if the UniZOom property is activated
    if (uniZoom) {
      yearsRange /= 1.1f;
    } else {
      yearsRange /= zoom; // We divide it according to the zoom level
    }

    // c. We specify the new Min and Max Dates
    fechaMin = timeLineCenter-yearsRange;
    fechaMax = timeLineCenter+yearsRange;

    // d. If we are too into 2015, we will leave the zoom in 2015 in the far right side
    /* FAIL --> revisit this later
     if(fechaMax> 2014){
     fechaMin = 2015-(standarizedYears/zoom);
     fechaMax = 2015;
     }
     */
  }

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 Date display and helpers
  // 0. A height for all dates
  float fechasAlturaY = c1y-15;
  // 1. We display the TOP dates
  noStroke();
  fill(red(blanco), green(blanco), blue(blanco), 255);
  textFont(avenirBook, 15);
  if (tipoMapa == "miniMap") textFont(avenirMedium, 9);
  textAlign(LEFT);
  text(floor(fechaMin), c1x, fechasAlturaY); // MIN
  textAlign(CENTER);
  //
  float centroX = c1x+((c2x-c1x)/2); // 
  int anoCentralDato = floor(map( centroX, c1x, c2x, fechaMin, fechaMax ));
  textFont(avenirBook, 15);
  text(anoCentralDato, centroX, fechasAlturaY); // MIDDLE
  //
  textAlign(RIGHT);
  textFont(avenirBook, 15);
  if (tipoMapa == "miniMap") textFont(avenirMedium, 9);
  text(floor(fechaMax), c2x, fechasAlturaY); // MAX
  // 2. We display the current timeline state
  strokeWeight(0.6f);
  stroke(blanco);
  float posTimeLineParticular = map( timeLineCenter, fechaMin, fechaMax, c1x, c2x );
  line( posTimeLineParticular, c1y, posTimeLineParticular, c2y );
  fill(blanco);
  shapeMode(CENTER);
  shape(Ellipse, posTimeLineParticular, c1y, 3, 3 );
  shape(Ellipse, posTimeLineParticular, c2y, 3, 3 );
  //  3. And now some interval dates
  int cantidadFechasMitad = 4;
  float intervalo = ((c2x-c1x)/2)/cantidadFechasMitad;
  for (int i = 1; i < cantidadFechasMitad; i++) { // LEFT SIDE
    // 3 - 1 We calculate the position and a date according to that position
    float fechaMiniX = c1x+( intervalo*i );
    int datoFechaMini = floor(map( fechaMiniX, c1x, c2x, fechaMin, fechaMax ));
    // 3 - 2 We draw the text
    textAlign(CENTER);
    textFont(avenirMedium, 9);
    fill(red(blanco), green(blanco), blue(blanco), 105);
    text( datoFechaMini, fechaMiniX, fechasAlturaY);
  }
  for (int i = 1; i < cantidadFechasMitad; i++) { // RIGHT SIDE
    // 3 - 1 We calculate the position and a date according to that position
    float fechaMiniX = centroX+( intervalo*i );
    int datoFechaMini = floor(map( fechaMiniX, c1x, c2x, fechaMin, fechaMax ));
    // 3 - 2 We draw the text
    textAlign(CENTER);
    textFont(avenirMedium, 9);
    fill(red(blanco), green(blanco), blue(blanco), 105);
    text( datoFechaMini, fechaMiniX, fechasAlturaY);
  }
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 Quantities
  // 1. We extract the total number from our datamatrix object
  int totales = dataMatrix.getTotales();
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 We calculate the height
  // 1. We calculate a height for each member and the current height
  float y = c1y;
  float interY = c2y-c1y;
  interY /= totales;

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 Alternation and Intel Filling
  // 1. The DataMatrix Object has already sorted everything for us
  String [] positionsTipo = dataMatrix.getPositionsTipo(); // We'll save the types here
  int [] positionsNo = dataMatrix.getPositionsNo(); // We'll save the numbers to each array position here

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 Drawing operations

  // 4. We proceed to draw everything! Finally!
  // -------------------------------------------------------------------------------- Legend variables 
  String leyendaNombre = "meh";
  float leyendaY = 0.0f;
  int leyendaColor = color(255, 0, 0);
  // ------------------------------------------------------------------------------------------- -
  // ------------------------------------------------------------------------------------------- -
  for ( int i = 0; i < totales; i++ ) { // ------------------------------------------ FOR starts - (each item)
    // 0. 1st APPEARANCE
    Boolean primeraAparicion = true;
    // ----------------------------------------------------------------------------------------- -
    // A. Obtenemos nuestra altura actual
    float yT = y+(interY*i); // T de temporal

    // ----------------------------------------------------------------------------------------- -
    // B. We Draw the GRID lines
    int frecuencia = 15; // frecuencia con la que apareceran las l'ineas 15 original
    if (grid && i%frecuencia == (frecuencia-1)) { // nice % modulo
      // 
      strokeWeight(0.6f);
      stroke(red(blanco), green(blanco), blue(blanco), 55);
      line( c1x, yT, c2x, yT);
    }
    // ----------------------------------------------------------------------------------------- -
    // C. --> We will put the names (if applicable) to the left
    if (leyenda == "conLeyenda" && deboTerminarPDF) {
      String nombreRenglon = "";
      // a. We get the name
      if (positionsTipo[i].equals("artists")) nombreRenglon = artistNombre[positionsNo[i]];
      if (positionsTipo[i].equals("writers")) nombreRenglon = writerNombre[positionsNo[i]];
      if (positionsTipo[i].equals("technicians")) nombreRenglon = technicianNombre[positionsNo[i]];
      if (positionsTipo[i].equals("musicians")) nombreRenglon = musicianNombre[positionsNo[i]];
      if (positionsTipo[i].equals("topics")) nombreRenglon = topicNombre[positionsNo[i]];
      // c. WE put it
      fill(red(blanco), green(blanco), blue(blanco), 120);
      textAlign(RIGHT);
      textFont(avenirMedium, 6);
      text(nombreRenglon, c1x -13, yT);
    }
    // ----------------------------------------------------------------------------------------- -
    // D.. We Specify the drawing properties according to their type
    int c = obtenerColor(positionsTipo[i]);
    fill(c);
    //println(">> We just specified drawing properties");
    // X. This funcion TEST TES TEST just a ball
    // shape( Ellipse, random(c1x, c2x), yT, 5, 5 );
    // \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 
    // \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 
    // D. Now, a tricky part. We will analyze each row for each item  \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2

    // 1 - Let's get how many items this item has
    int cantidad = 0;
    if (positionsTipo[i].equals("artists")) cantidad = artistInfo[positionsNo[i]].getCantidad();
    if (positionsTipo[i].equals("musicians")) cantidad = musicianInfo[positionsNo[i]].getCantidad();
    if (positionsTipo[i].equals("technicians")) cantidad = technicianInfo[positionsNo[i]].getCantidad();
    if (positionsTipo[i].equals("writers")) cantidad = writerInfo[positionsNo[i]].getCantidad();
    if (positionsTipo[i].equals("topics")) cantidad = topicInfo[positionsNo[i]].getCantidad();

    // 2 - We save everything into one Data item ---> itemT
    if (positionsTipo[i].equals("artists")) itemT = artistInfo[positionsNo[i]];
    if (positionsTipo[i].equals("musicians")) itemT = musicianInfo[positionsNo[i]];
    if (positionsTipo[i].equals("technicians")) itemT = technicianInfo[positionsNo[i]];
    if (positionsTipo[i].equals("writers")) itemT = writerInfo[positionsNo[i]];
    if (positionsTipo[i].equals("topics")) itemT = topicInfo[positionsNo[i]];

    // 3 - We'll calculate a slight displacement (to prevent overlapping) in an horizontal fashion
    float displacementWindow = (c2x-c1x)/(fechaMax-fechaMin); //This is the available data per Year
    float displacement = 0;
    if (positionsTipo[i].equals("artists")) displacement = (displacementWindow/5)*0;
    if (positionsTipo[i].equals("musicians")) displacement = (displacementWindow/5)*1;
    if (positionsTipo[i].equals("topics")) displacement = (displacementWindow/5)*2;
    if (positionsTipo[i].equals("technicians")) displacement = (displacementWindow/5)*3;
    if (positionsTipo[i].equals("writers")) displacement = (displacementWindow/5)*4;

    // 4 - Let's iterate through that data
    int fechaAnterior = 1800; // A random date that will never exist
    int fechaActual = 1900; // 
    int sumaElementosFecha = 0; // We will know how many elements we have

    //println(">> On to NYTimes operation, if activated");
    // 5 - New York Times Operations
    for (int j = 0; j < cantidad && NYTimesMode; j++) {

      // a. we get the year
      fechaActual = PApplet.parseInt(itemT.getAno(j));
      // b. we add the counter
      sumaElementosFecha++;
      // c. We ask if the year is different from the previous one (so we draw something)
      if (fechaActual != fechaAnterior) {
        // --> we specify a new date
        fechaAnterior = fechaActual;
        // --> we see if it is within the timeScale limit
        Boolean puedoDibujar = false;
        if ( fechaActual > fechaMin && fechaActual < fechaMax &&  sumaElementosFecha>1) puedoDibujar = true;
        // --> we specify the X position where to draw
        float xCuadrito = map( fechaActual, fechaMin, fechaMax, c1x, c2x );
        // -- > NYTimes mode
        // ********************************************************
        float tamano = 0.0f; // WE declare this outside the next loop so we can access it on the 1st appearance cross
        if (NYTimesMode) { // --> NYTimesMode
          // --> Let's calculate a size for the Bar
          tamano = map( sumaElementosFecha, 0, 1000, 0.3f, 1.4f );
          // --> Finally, we draw the bar
          shapeMode(CENTER);
          stroke(255);
          noStroke();
          //if (puedoDibujar) shape( Ellipse, xCuadrito + displacement, yT, tamano, tamano );
          if (puedoDibujar && tipo.equals("barras")) shape( Rect, xCuadrito + displacement, yT, displacementWindow*tamano, 4 );
          if (puedoDibujar && tipo.equals("bolas")) shape( Ellipse, xCuadrito + displacement, yT, displacementWindow*tamano/1, displacementWindow*tamano/1 );
        }
        // d. We do the operations for the 1st appearance ( x - - - )
        //
        if (primeraAparicion && sumaElementosFecha > 1) {
          // WE ask if it is proper to draw (yet again)
          // if ( fechaActual > fechaMin && fechaActual < fechaMax &&  sumaElementosFecha>1) puedoDibujar = true;
          // We draw the cross
          pushMatrix();
          float alturaPrimeraAparicion = 14;
          //translate( xCuadrito + displacement - (tamano/2) - 9, yT);
          translate( xCuadrito + displacement -9 -(displacementWindow*tamano/2), yT);
          fill(c);
          //strokeWeight(3);
          noStroke();
          if (puedoDibujar) {
            rotate(radians(45));
            shapeMode(CENTER);
            shape( Rect, 0, 0, 3, alturaPrimeraAparicion);
            rotate(radians(90));
            shape( Rect, 0, 0, 3, alturaPrimeraAparicion);
          }
          popMatrix();

          // We set the 1st appearance off
          primeraAparicion = false;
        }
        // --> we reset the elements per date
        sumaElementosFecha = 0;
      }
    }
    // 5b - New York times Mouse Helper
    if (mouseY < yT+(interY/2) && mouseY > yT-(interY/2) && mouseX > c1x && mouseX < c2x && NYTimesMode) {
      //fill(c);
      strokeWeight(1.5f);
      stroke(red(blanco), green(blanco), blue(blanco), 124);
      line(c1x, yT, c2x, yT);
    }
    // ********************************************************
    // --> NGram Mode
    //println(">> On to NGram Mode if activated");
    if (NGramMode) {

      // i. Working variables -----------------------------
      int resolution = 77; // How many points our shape will have 150/10 helps and it's fast
      float [] puntosXT = new float[resolution]; // AN Array with all the points in the shape
      float puntoInicial = 0.0f; // We record the first point, so we can close the shape
      float puntoFinal = 0.0f; // same... but final
      float xTN = 0.0f; //working variables
      float yTN = 0.0f; 

      // ii. Display properties --------------------------
      //Boolean colocarCero = true;
      noStroke();
      //stroke(red(azul3), green(azul3), blue(azul3), 33);
      fill(red(c), green(c), blue(c), 100);

      // iii. Mouse goodies ------------------------------
      if (mouseY < yT+(interY/2) && mouseY > yT-(interY/2) && mouseX>c1x && mouseX < c2x) {
        fill(c);
        strokeWeight(1.5f);
        stroke(red(blanco), green(blanco), blue(blanco), 244);
      }
      // iv. Shape Begins --------------------------------
      beginShape(); // We beginAShape
      for (int k = 0; k < resolution; k++) {
        // We check our X
        xTN = map( k, 0, resolution, c1x, c2x );

        // We get our Y
        float mappingFecha = map(xTN, c1x, c2x, fechaMin, fechaMax); // Transforming x value into dates
        if (mappingFecha <= fecha1 || mappingFecha >= fecha2) { // Let's see if we are not asking for null dates
          yTN = 1.0f; // We put a zero value (which is 1.0 in Ngram mode)
          // yTN = 1.0;
        } else {
          int nGramTotales = itemT.getCantidadNGrams();
          int nGramDeseado = floor(map(mappingFecha, fecha1, fecha2, 0, nGramTotales ));
          //println(">>["+i+"] nGramTotales= "+nGramTotales+" VS deseo= "+nGramDeseado+" fecha= "+mappingFecha);
          float nGramT = itemT.getNGramF(nGramDeseado);
          //println(" >> NGRAM data: "+nGramT);
          // yTN = (1-nGramT); // Cause we are re-adjusting the values
          yTN = nGramT;
        }
        // We make the height operations
        float nuevaAltura = map( yTN, 1, 0, 0, -100 );
        yTN = yT+nuevaAltura; // We finally set the Y where it belongs

        // At last, we put a vertex
        vertex( xTN, yTN );
        // We check if this is the first point
        if (k == 0) puntoInicial = yTN;

        // We check if this is the last point
        if (k == resolution-1) puntoFinal =yTN;
      }
      // Closing shape operations
      vertex(c2x, yT); //Final
      vertex(c1x, yT); // Inicial
      endShape();
      // ---------------------------------------------- Shape for constructor ends  (NGram)
    } 

    // 6 - Text indicator/legend (Variable setting only)
    // a. We ask if they're on sight! On Sight! On Site!
    if (mouseY < yT+(interY/2) && mouseY > yT-(interY/2) && mouseX>c1x && mouseX < c2x) {

      // b. We get the topic name (I know this is a terrible way to do it)
      if (positionsTipo[i].equals("artists")) leyendaNombre = artistNombre[positionsNo[i]];
      if (positionsTipo[i].equals("writers")) leyendaNombre = writerNombre[positionsNo[i]];
      if (positionsTipo[i].equals("technicians")) leyendaNombre = technicianNombre[positionsNo[i]];
      if (positionsTipo[i].equals("musicians")) leyendaNombre = musicianNombre[positionsNo[i]];
      if (positionsTipo[i].equals("topics")) leyendaNombre = topicNombre[positionsNo[i]];

      // c. Y position and color Name
      leyendaY = yT;
      leyendaColor = c;
    }


    // \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2
    // \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2 \u25b2

    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
    // Button for the CELL \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   (to detail view)
    if ( hiceHit(  c1x, yT-(interY/2) , c2x, yT+(interY/2) )) { 
      // 1. MOUSE OVER DRAW ATTRIBUTES
      // No mouse over for this button
      // 2. ACTION AFTER HIT
      if (mousePressed && fallOff == 0) {
        // A. We set the individual data
        individuoPos = positionsNo[i];
        individuoType = positionsTipo[i];
        individuoNombre = leyendaNombre;

        // B. We restart the filling function
        iniciarDetailViz();

        // C. We start the transition
        iniciarTransicion("detail view"); // Detail View

        fallOff = fallOffLimit;
      } 
      // 3. FALL OFF OPERATIONS highly important!
      fallOff -= 1;
      if (fallOff <= 0) fallOff = 0; // So we don't get negative values
    } 
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
    //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  } // <------ each item "for" ends

  //
  // 6 - Text indicator/legend (we draw it at the end so it would be on top, previous operations calculated before)

  if (mouseY < c2y && mouseY > c1y && mouseX>c1x && mouseX < c2x) {  
    // println(">> Printing text legend");  
    // i. This variables are declared up (nested inside each item's loop) --> 
    //String leyendaNombre | float leyendaY  | color  leyendaColor 

    // ii. Background - calculation and positions
    float caracteresNombre = leyendaNombre.length();
    float anchoRectBack = map(caracteresNombre, 0, 1, 1, 9);
    float trasladoText = 14;

    // iii. Background - draw
    fill(leyendaColor);
    noStroke();
    rectMode(CENTER);
    rect(mouseX, leyendaY-trasladoText, anchoRectBack, 17);

    // iv. The small cartoon globe thing
    beginShape();
    vertex(mouseX, leyendaY);
    vertex(mouseX-13, leyendaY-trasladoText);
    vertex(mouseX+13, leyendaY-trasladoText);
    vertex(mouseX, leyendaY);
    endShape();

    // v. We put the name 
    fill(azul3);
    textFont( avenirHeavy, 13 );
    text(leyendaNombre, mouseX, leyendaY-trasladoText+4);
  }

  // 
  // ------------------------------------------------------------------------------------------- -
  // ------------------------------------------------------------------------------------------- -
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588
  // HugeMap Ends next: --->
}
// --------------------------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------------------------------- Useful functions for this same map
// --------------------------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------------------------
public void colocarCrucecillas(float x1, float y1, float x2, float y2) {

  // 1. We attempt to draw one for each point (so simple) (with a slight touch of animated effect)
  if (random(100)<99)colocarCruz(x1, y1);
  if (random(100)<99)colocarCruz(x1, y2);
  if (random(100)<99)colocarCruz(x2, y2);
  if (random(100)<99)colocarCruz(x2, y1);
}
// --------------------------------------------------------------------------------------------------------------------------------------
public void colocarCruz(float x, float y) {
  // 1. Trasladamos el escenario
  pushMatrix();
  translate(x, y);

  // 2. A height for the line (L)
  float alturaL = 3;

  // 3. Cross properties
  strokeWeight(1);
  stroke(red(blanco), green(blanco), blue(blanco), 120);
  line( alturaL, 0, -alturaL, 0); // Horizontal
  line( 0, +alturaL, 0, -alturaL); // Horizontal

  // C'est tout!
  popMatrix();
}
// ---------------------------------------------------- \\
// ------------- huge Map View ------------------------ \\
// ---------------------------------------------------- \\
// Just one data per individual (detail view)
// This global variables must be set 
int individuoPos = 1;
String individuoType = "technicians";
String individuoNombre = "Buckminster Fuller";
//color c = obtenerColor(positionsTipo[i]);
float detailNYTimesMaxMention = 0;
float friccionNYTimes = 7;
float friccionNgrams = 6;
// -------------------------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------------------------
public void detailView(float c1x, float c1y, float c2x, float c2y) {
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 COORDINATES
  // 1. We establish our coordinates and center points from where to start drawing
  float cx = (c2x-c1x)/2; // The center
  float desplazamientoSuperior = 51;
  float cy = c2y -desplazamientoSuperior ; // El punto base sobre el cual empezaremos hacia arriba, japanese style!


  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 BACKGROUND & color data
  // 1. Bckground drawing
  noStroke();
  fill(blanco);
  shapeMode(CORNERS);
  shape(Rect, c1x, c1y, c2x, c2y);
  int c = obtenerColor( individuoType );

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 GRAPH Baseline and properties
  // 1. Viz properties
  float anchoGrafica = 650;
  float alturaGrafica = 160; // This will be the measure of increments
  // 2. Baseline
  stroke(red(c), green(c), blue(c), 180);
  strokeWeight(3);
  strokeCap(SQUARE);
  line( cx-(anchoGrafica/2), cy, cx+(anchoGrafica/2), cy );

  // 3. We set the dates
  fill(red(azul3), green(azul3), blue(azul3), 255);
  textFont(avenirRegular, 11);
  textAlign (LEFT);
  text(PApplet.parseInt(fecha1), cx-(anchoGrafica/2), cy+19);
  textAlign (RIGHT);
  text(PApplet.parseInt(fecha2), cx+(anchoGrafica/2), cy+19);

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 DATA LOCAL OBJECT
  // 1. This object will hold all of the data
  // We save everything into one Data item ---> detailItem
  if (individuoType.equals("artists")) detailItem = artistInfo[individuoPos];
  if (individuoType.equals("musicians")) detailItem = musicianInfo[individuoPos];
  if (individuoType.equals("technicians")) detailItem = technicianInfo[individuoPos];
  if (individuoType.equals("writers")) detailItem = writerInfo[individuoPos];
  if (individuoType.equals("topics")) detailItem = topicInfo[individuoPos];

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 NGRAM GRAPH 
  // 1. Crucial variables for sketch control
  float NGramMaximo = 1.0f; // To know the biggest one, we already know the lowest 1.0 = 0
  float NGramAnoActual = 0.0f; // SO we know what to draw

  // 2. We will re-fill/get the detail data
  for (int i = 0; i < detailRes; i++) {
    // a. which NGram do we want?
    int cantidadNGrams = detailItem.getCantidadNGrams();
    int deseo = PApplet.parseInt(map( i, 0, detailRes, 0, cantidadNGrams ));
    if (deseo >= cantidadNGrams || deseo <= 0) deseo = 0; // (FAIL SWITCH)

    // b. what is the value of that NGram
    detailAlturasD[i] = detailItem.getNGramF( deseo );

    // c. We see if it is the biggest (or lowest in practice) so far
    if (detailAlturasD[i] < NGramMaximo) NGramMaximo = detailAlturasD[i];

    // d. We get the current year data
    int fechaLocal = PApplet.parseInt(map(i, 0, detailRes, fecha1, fecha2));
    if (fechaLocal == PApplet.parseInt(timeLineCenter)) NGramAnoActual = detailAlturasD[i];

    // e. We calculate the actual positions using friction
    detailAlturas[i] = calcularFriccion(detailAlturas[i], detailAlturasD[i], friccionNgrams);
  }

  // 3. We draw the graph finally!!!!
  pushMatrix();
  translate( cx-(anchoGrafica/2), cy ); // We translate into the origins
  noStroke();
  fill(red(c), green(c), blue(c), 190);
  beginShape();
  vertex(0, 0); // First vertex
  for (int i = 0; i < detailRes; i++) {
    // a. Calculamos la x del vertex
    float xNgram = map( i, 0, detailRes, 0, anchoGrafica );

    // B. ahora la Y del vertex (inverted, since low in Ngrams means 1, and high means 0)
    float yNgram = map( detailAlturas[i], 0, 1, 1, 0 ); // This is just a percentage
    yNgram =  alturaGrafica * yNgram;// This is the actual height
    yNgram *= -1;// Minus -1 since we don't want it to be flipped

    // C. Colocamos el vertex
    vertex(xNgram, yNgram);
  }
  vertex(anchoGrafica, 0);
  vertex(0, 0); // Last vertex to Properly close the Shape
  endShape();


  //4. Now we will put our little helper friend, our buddy
  //4-1. X Position
  float detailNGramCircleX = map( timeLineCenter, fecha1, fecha2, 0, anchoGrafica );

  // 4-2. Y Position ( a little bit more tricky)
  // 4-2 a. which NGram do we want?
  int cantidadNGrams = detailItem.getCantidadNGrams();
  int deseo = PApplet.parseInt(map( timeLineCenter, fecha1, fecha2, 0, cantidadNGrams ));
  if (deseo >= cantidadNGrams || deseo <= 0) deseo = 0; // (FAIL SWITCH)

  // 4-2 b. We set the new height
  float detailNGramCircleY = detailItem.getNGramF(deseo);

  // 4-2 c. We adjust the height
  detailNGramCircleY = map(detailNGramCircleY, 1, 0, 0, 1); // This are just valies from 0 to 1, now correctly ordered
  detailNGramCircleY *= alturaGrafica; // this is a multiplication for the height, a percentage
  detailNGramCircleY *= -1; // we invert them to be down to up

  // 4-3 We will draw him at last
  strokeWeight(2);
  fill(red(azul3), green(azul3), blue(azul3), 220);
  noStroke();
  ellipseMode(CENTER);
  ellipse(detailNGramCircleX, detailNGramCircleY-1, 7, 7);
  strokeWeight(1);
  stroke(red(azul3), green(azul3), blue(azul3), 20);
  line(detailNGramCircleX, detailNGramCircleY-1, detailNGramCircleX, detailNGramCircleY-height);

  popMatrix();

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 NYTimes graph
  // 1. We start cyclin' thru the data and drawing on the go 
  // a. Drawing properties
  pushMatrix();
  translate( cx-(anchoGrafica/2), cy ); // We translate into the origins
  noStroke();
  fill(red(azul3), green(azul3), blue(azul3), 90);
  beginShape();
  vertex(0, 0);

  // b. Let's calculate friction values
  for (int i = 0; i < (fecha2-fecha1); i++ ) {
    detailMentions[i] = calcularFriccion(detailMentions[i], detailMentionsD[i], friccionNYTimes);
  }

  // c. Actual iteration
  for (int i = 0; i < NYTimesRes; i++) {

    // d. We calculate the X position
    float nyTimesX = map(i, 0, NYTimesRes, 0, anchoGrafica);

    // e. We get the desired year
    int anoDeseado = PApplet.parseInt(map( i, 0, NYTimesRes, fecha1, fecha2));
    anoDeseado -= fecha1;
    if (anoDeseado < 0 || anoDeseado >= detailMentions.length) anoDeseado = 0;

    // f. we get the data for that desired year
    float nyTimesY = detailMentions[anoDeseado];
    nyTimesY = map(nyTimesY, 0, detailNYTimesMaxMention, 0, alturaGrafica);
    nyTimesY *= -1;

    // g. we add a vertex
    curveVertex( nyTimesX, nyTimesY );
    //vertex( nyTimesX, nyTimesY );
  }

  vertex(anchoGrafica, 0);
  vertex(0, 0);
  endShape();
  popMatrix();

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 TYPE: title and year
  // 1. We set the height for the Year
  float yearHeight = cy - alturaGrafica - 55;

  // 2. We put the year
  fill(red(azul3), green(azul3), blue(azul3), 40);
  textFont(avenirBookYear, 34);
  textAlign(CENTER);
  text(PApplet.parseInt(timeLineCenter), cx, yearHeight);

  // 3. We set the height for the Main Title
  float nameHeight = yearHeight -55;

  // 4. We put the title
  fill(red(c), green(c), blue(c), 180);
  textFont(avenirMediumBig, 37);
  textAlign(CENTER);
  text( individuoNombre, cx, nameHeight );


  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 NYTimes mention legend
  // 1. We set the bar displacement and size
  int barrasTotales = 6;
  int anchoBarra = 25;
  int alturaBarras = 25;
  float alturaBarra = alturaBarras/barrasTotales;
  float xBarra = cx-70;
  float yBarra = yearHeight;

  // 2. For this, how many mentions compared to the total?
  int fechaDeseada =  PApplet.parseInt(timeLineCenter-fecha1);
  if (fechaDeseada < 0 || fechaDeseada >= (fecha2-fecha1))fechaDeseada = 0; // (FAIL SWITCH)
  float currentMeasurement = detailMentions[ fechaDeseada];
  int howManyBars = PApplet.parseInt(map(currentMeasurement, 0, detailNYTimesMaxMention, 0, barrasTotales+1));

  // 3. We draw the bars
  for (int i = 0; i < barrasTotales; i++) {

    // a. The height
    float yBarraT = yBarra -(i*alturaBarra);

    // b. color options
    noStroke();
    fill(red(azul3), green(azul3), blue(azul3), 30);
    if (i < howManyBars) fill(c);

    // b. We draw the bar
    shapeMode(CENTER);
    shape(Rect, xBarra, yBarraT -1.5f, anchoBarra, alturaBarra - 1);
  }

  // 4. LEGEND
  // 4-1 We set the coordinates
  float xNyTimesMentionsLegend = xBarra-33;
  // 4-2 We draw the subtitle
  fill(red(azul3), green(azul3), blue(azul3), 150);
  textAlign(RIGHT);
  textFont(avenirHeavy, 10);
  text( "NYTIMES MENTIONS FOR THIS YEAR", xNyTimesMentionsLegend, yearHeight-3);

  String texto = PApplet.parseInt(currentMeasurement)+" / "+cantidadMentionsDeEsteIndividuo;
  fill(c);
  textAlign(RIGHT);
  text(texto, xNyTimesMentionsLegend, yearHeight-15);

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 NGram Mentions legend
  // 1. We set the Circle displacement and size
  float xNgramCircle = cx+70;
  float tamanoNgram = 31;
  float yNgramCircle = yearHeight -12 -1;

  // 2. We draw the central circle
  fill(red(azul3), green(azul3), blue(azul3), 120);
  noStroke();
  shapeMode(CENTER);
  shape(Ellipse, xNgramCircle, yNgramCircle, 5, 5);

  // 3. Full circle
  fill(red(azul3), green(azul3), blue(azul3), 10);
  shape(Ellipse, xNgramCircle, yNgramCircle, tamanoNgram, tamanoNgram);

  // 4. Indicator circle, the most important one
  // 4 - 1 We calculate the size
  float diametroNgram = detailItem.getNGramF(deseo);
  diametroNgram = map(diametroNgram, 1, 0, 0, 1); // We flip the values
  //float interesVerdadero = map(diametroNgram, 0, 1, 0, 100); // To put later in the percentages
  diametroNgram = map(diametroNgram, 0, 1, tamanoNgram/5, tamanoNgram);

  float interesVerdadero = detailItem.getNGramF(deseo);
  interesVerdadero = map(interesVerdadero, NGramMaximo, 1, 0, 100);
  interesVerdadero = map(interesVerdadero, 0, 100, 100, 0);

  // 4 - 2 We draw the circle
  fill(red(c), green(c), blue(c), 180);
  shape(Ellipse, xNgramCircle, yNgramCircle, diametroNgram, diametroNgram);

  // 5. And now, the legends
  // 5 - 1 coordinates
  float xNGramLegend = xNgramCircle+33;

  // 5 - 1 subtitle
  fill(red(azul3), green(azul3), blue(azul3), 150);
  textAlign(LEFT);
  textFont(avenirHeavy, 10);
  text( "NGRAM INTEREST", xNGramLegend, yearHeight-3);

  // 5 - 1 title
  String textoNgramInterest = PApplet.parseInt(interesVerdadero)+"%";
  fill(c);
  textAlign(LEFT);
  text(textoNgramInterest, xNGramLegend, yearHeight-15);

  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588  AND NOW.. THE ROWS!!!!!
  // 1. We establish the row coordinates
  float rowY = nameHeight -60;
  float rowHeight = 30;

  // 2. We will ask if we have any mentions for this year
  int cantidadSubItems = detailItem.getCantidad();

  // 3. Now we will cycle through the years and put something if it fits and if we have something tho
  int renglonesActuales = 0;
  float currentHeight = 100; // Just a random number
  for (int i = 0; i < cantidadSubItems && currentHeight > 50; i++) {

    // a. We check if we are in the current year
    if ( PApplet.parseInt(detailItem.getAno(i)) == PApplet.parseInt(timeLineCenter)) {

      // b. We establish a Height
      currentHeight = rowY-( rowHeight*renglonesActuales );

      // xx. Let's draw a rectange (TEST)
      rectMode(CORNERS);
      stroke(0, 0, 0, 50);
      noFill();
      //rect(0, currentHeight-(rowHeight/2), cx, currentHeight+(rowHeight/2));

      // c. We display the title
      fill(azul3);
      textAlign(RIGHT);
      textFont(avenirRegular, 13);
      text( '"'+detailItem.getTitulo(i)+'"', cx - 7, currentHeight+3.5f );

      // d. We display the URL
      String urlItem = detailItem.getUrl(i);
      fill(red(azul3), green(azul3), blue(azul3), 40);
      textAlign(LEFT);
      textFont(avenirRegular, 13);
      text( urlItem, cx + 7, currentHeight+3.5f );


      // e. Le hacemos un boton
      //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
      //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   OPEN NYTIMES URL
      if ( hiceHit( 0, currentHeight-(rowHeight/2), width, currentHeight+(rowHeight/2) )) { 

        // 1. MOUSE OVER DRAW ATTRIBUTES
        fill(red(azul3), green(azul3), blue(azul3), 10); // OVER COLOR
        noStroke(); 
        rect(0, currentHeight-(rowHeight/2), width, currentHeight+(rowHeight/2));

        // 2. ACTION AFTER HIT
        if (mousePressed && fallOff == 0) {

          open(urlItem);

          fallOff = fallOffLimit;
        } 
        // 3. FALL OFF OPERATIONS (ignore)
        // FallOff Operations, highly important!
        fallOff -= 1;
        if (fallOff <= 0) fallOff = 0; // So we don't get negative values
      } // <-- Button iF
      //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
      //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022



      // x. We increase the number of items placed
      renglonesActuales++;
    }
  }
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588  BACK Button
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022 Rect Button \u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022   OPEN NYTIMES URL  
  //1. We specify some coordinates
  float anchoBack = 110;
  float backx1 = cx-(anchoBack/2);
  float backy1 = cy +16;
  float backx2 = cx+(anchoBack/2);
  float backy2 = cy+20 +16;
  /*
  // TEST RECTANGLE
   stroke(azul3);
   noFill();
   rectMode(CORNERS);
   rect(backx1, backy1, backx2, backy2);
   */
  // 2. We specify a color
  fill(azul3); // Default color
  if ( hiceHit( backx1, backy1, backx2, backy2 )) { 

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(c); // OVER COLOR

    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {
      //We go back to our previous state
      iniciarTransicion(escenarioAnterior); 

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  // We draw the text
  textFont(avenirBlack, 9);
  textAlign(CENTER);
  text("<< GO BACK", cx, cy+28);
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  //\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022
  // \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588 
  //
  // detailView viz ends nxt ---->
}



// -------------------------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------------------------
int detailRes = 80; // How smooth the NGram graph will be (mountain style) 280 works
int NYTimesRes = 80; // How smooth the NYTimes grpah will be (line style)
float [] detailAlturas, detailAlturasD; // This is mostly for friction operations
float [] detailMentions, detailMentionsD; // We still use friction for this one, why not? It's all about experience
int cantidadMentionsDeEsteIndividuo; // Total mentions for this specific item
public void iniciarDetailViz() {
  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 a. Array Temporary Filling
  // Mostly this values are for the animated Graph making 
  // 1. We create temporary array/values
  float [] detailAlturasT = new float [detailRes];
  float [] detailAlturasDT = new float [detailRes];
  // 2. WE fill them
  for (int i = 0; i < detailRes; i++) {
    detailAlturasT[i] = 1.0f;
    detailAlturasDT[i] = 0.0f;
  }
  // 3. We equal the Temporary Arrays to the final ones
  detailAlturasD = detailAlturasDT;
  detailAlturas = detailAlturasT;

  // \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 \u2593 b. Now we will fill them with the NYTimes Data
  // 1. MENTIONS PER YEAR First we will calculate with an array as big as time
  int cantidadMentions = PApplet.parseInt(fecha2-fecha1);
  //println("Estamos buscando a: "+individuoPos+" | type: "+individuoType);
  //println("NOMBRE: "+technicianNombre[individuoPos]);

  // 2. Now we will start the arrays
  float [] detailMentionsT = new float[cantidadMentions];
  float [] detailMentionsDT = new float[cantidadMentions];

  // 3. We will fill it with zeros
  for (int i = 0; i < cantidadMentions; i++) {
    detailMentionsT[i] = 0.0f;
    detailMentionsDT[i] = 0.0f;
  }

  // 4. A temporary data item
  // We save everything into one Data item ---> detailItem
  if (individuoType.equals("artists")) detailItem = artistInfo[individuoPos];
  if (individuoType.equals("musicians")) detailItem = musicianInfo[individuoPos];
  if (individuoType.equals("technicians")) detailItem = technicianInfo[individuoPos];
  if (individuoType.equals("writers")) detailItem = writerInfo[individuoPos];
  if (individuoType.equals("topics")) detailItem = topicInfo[individuoPos];

  //5. An now we will add whatever we found there
  cantidadMentionsDeEsteIndividuo = detailItem.getCantidad();
  detailNYTimesMaxMention = 0; // This is to give us a sense of scale
  for (int i = 0; i < cantidadMentionsDeEsteIndividuo; i++) {
    // a. Obtenemos un year
    int anoObtenido = PApplet.parseInt(detailItem.getAno(i));

    // b. Conversion de posicion
    anoObtenido -= fecha1;
    if (anoObtenido < 0 || anoObtenido >=(fecha2-fecha1)) anoObtenido = 0;

    // c. Lo sumamos al valor anterior
    println("QUEREMOS EL ANO: "+anoObtenido+" cuando detmentionsdt lenght = "+detailMentionsDT.length);
    detailMentionsDT[anoObtenido]++;

    // d. we get the top number of mentions per year
    if (detailMentionsDT[anoObtenido] > detailNYTimesMaxMention) detailNYTimesMaxMention = detailMentionsDT[anoObtenido] ;
  }

  //println("Maxima mention de Fuller"+detailNYTimesMaxMention);
  // 6. Igualamos los arreglos
  detailMentionsD = detailMentionsDT;
  detailMentions = detailMentionsT;
}
// ------------------------------------------------------------------------------------------------------------------------------------
// ---------------------------------------------------------------------- \\
// ------------- Zooming and time paning control ------------------------ \\
// ---------------------------------------------------------------------- \\
// *
// MAIN VARIABLES AND SWITCHES
// - - - - - zooming | panning | dates - - - - - - 
float zoom = 1; // By default we se everything, but this can be scaled up to 3. Or even 4 maybe? Perhaps changin this value at the beginning could animate it
float zoomD = 2;
float fecha1 = 1900; // Starting date of our viz... // Watch out, because this dates are not only for the "visual"
float fecha2 = 2015; // Finishing date of our viz... // This dates are used to load the yearly NGrams and NYTimes data
float zoomFriccion = 7; // 19 works
// - - - - - timeline - - - - - - - - - - -
float timeLineY = (alto/4) *3; 
float timeLineCenter = 1910;// Specified DATE in years (could be any year to start), this variable controls all graphics!
float timeLineCenterD = 1910;
float timeLineCenterFriccion = 5;
float timeLineHeight = 25;
//
// * friction and other veriables
// 
// ----------------------------------------------------------------------------------------------------------------
// Controls zooming and paning
public void zooming() {

  // 1. We calculate the actual zoom
  if (zoom != zoomD) zoom = calcularFriccion( zoom, zoomD, zoomFriccion );

  // 2. We calculate the timeline Values
  if ( timeLineCenter != timeLineCenterD ) timeLineCenter = calcularFriccion( timeLineCenter, timeLineCenterD, timeLineCenterFriccion );
}
// ----------------------------------------------------------------------------------------------------------------
// This function will display the timeline at the middle of our stage (always visible, always present)
public void timeLine() {

  // 1. We draw the timeline's rectange
  noStroke();
  fill(red(blanco), green(blanco), blue(blanco), 3); 
  shapeMode(CENTER);
  shape( Rect, width/2, timeLineY, width, timeLineHeight);

  // 2. We draw the TimeLine Center Position
  noFill();
  strokeWeight(0.5f);
  stroke(blanco);
  float altoTimeLineCenter = timeLineHeight+1;
  float timeLineActualXCenter = map(timeLineCenter, fecha1, fecha2, 0, width);
  line( timeLineActualXCenter, timeLineY, timeLineActualXCenter, timeLineY+altoTimeLineCenter);
  line( timeLineActualXCenter, timeLineY, timeLineActualXCenter, timeLineY-altoTimeLineCenter);
  shapeMode(CENTER);
  fill(blanco);
  noStroke();
  shape( Ellipse, timeLineActualXCenter, timeLineY+altoTimeLineCenter, 4, 4);
  shape( Ellipse, timeLineActualXCenter, timeLineY-altoTimeLineCenter, 4, 4);

  // 3. We draw the mouse indicator (only if it is still in position)
  if (timeLineHit(mouseY)) {
    // a. Drawing properties
    noStroke();
    fill(red(blanco), green(blanco), blue(blanco), 80);

    // b. Actual drawing
    shapeMode(CENTER);
    shape( Rect, mouseX, timeLineY, 10, timeLineHeight );
  }

  //4. We draw the dates
  int cantidadFechas = 15;
  for ( int i = 0; i < cantidadFechas*3 +1; i++ ) {
    // We specify a temporary value
    float interDate = width/(cantidadFechas*3);
    float xDate = i*interDate;

    if (i%3 == 0) { // 4-1 We draw the date
      //
      int valor = floor(map(xDate, 0, width, fecha1, fecha2)); // We see which year we want
      textFont(avenirMedium, 8);
      textAlign(CENTER);
      fill(red(blanco), green(blanco), blue(blanco), 190);
      noStroke();
      text( valor, xDate, timeLineY+3);
    } else { // 4-2 We draw a line
      strokeWeight(random(0.5f, 0.51f));
      stroke(red(blanco), green(blanco), blue(blanco), 80);
      //stroke(blanco);
      line(xDate, timeLineY, xDate, timeLineY+(timeLineHeight/8) );
      line(xDate, timeLineY, xDate, timeLineY-(timeLineHeight/8) );
    }
  }
  
  
}
// ----------------------------------------------------------------------------------------------------------------
// This functions checks if the mouse cursor is above the timeline
public Boolean timeLineHit( float y) {  
  // 1. A variable to store values
  Boolean hicimosHit = false;  
  // 2. We check if we are within the height
  if ( y > timeLineY-( timeLineHeight/2 ) && y < timeLineY+(timeLineHeight/2) ) {
    hicimosHit = true;
  }
  // 3. We return the variable
  return hicimosHit;
}

// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#000000", "--hide-stop", "rise_and_fall__17" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
